/*
 * 用户登录
 * 
 * */

function reqLogin(param, callback) {
	var url = "User/Login";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

/*
 * 设置当前语言
 * 'Language':' en : 英文；zh_cn：简体中文'
 * */

function reqSetLanguage(param, callback) {
	var url = "Config/SetLanguage";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
/*
 * 获取当前语言
 * 
 * */
function reqGetLanguage(callback) {
	var url = "Config/GetLanguage";
	postServer("", url, callback);
}
/*
 * 获取当前播出时间表
 * 
 * */

function reqLoadAlternateDate(callback) {
	var url = "Config/LoadAlternateDate";
	postServer("", url, callback);
}
/*
 * 获取当前时间
 * 
 * */

function reqGetCurrentTime(callback) {
	var url = "Config/GetCurrentTime";
	postServer("", url, callback);
}
/*
 * 获取设备分类
 * 
 * 参数  expertUserId  顾问id
 * 
 *
 * */

function reqListDeviceClasses(callback) {
	var url = "Device/ListDeviceClasses";
	var param = {};
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

/*ajax请求设备列表*/
function reqListDeviceTree(param, callback) {
	var url = "Device/ListDeviceTree"
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
/*获取设备任务列表*/
function reqListDeviceSessions(param, callback) {
	var url = "Device/ListDeviceSessions"
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

/*获取设备复制列表树*/
function reqListDevicesForMember(param, callback) {
	var url = "Device/ListDevicesForMember"
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

/*设备状态控制
 
 *  'DeviceIDs':'需要控制的设备id，格式1，2，3（必传字段）',
    'SysStatus':' 系统启用/禁用，0：禁用，1：启用（不传为不修改）',
    'PwrStatus':' 系统开机/关机命令，0：关机，1：开机（不传为不修改）',
    'ProjectorSrc':' 投影仪源，1：计算机，2：笔记本，3：数字展台，4：视频',
    'ProjectorStatus':' 投影仪开启/关闭，0：关闭，1：开启（不传为不修改）',
    'VoiceMute':' 音量是否静音，0: 非静音，1：静音',
    'VoiceValue':' 音量控制，0-63',
    'MicMute':' 麦是否静音，0: 非静音，1：静音',
    'MicValue':' 麦音量控制，0-63',
    'BroadcastStatus':' 广播启用/禁用，0：禁用，1：启用（不传为不修改）',
    'ExpandInfo':'扩展电源控制,JSON数组，[{PwrID:12,Mode:0}] ，PwrID电源ID，Mode状态：0：关闭，1~4模式（其中电源1：打开电源，4：本地模式，其他无效）（不传为不修改）
 * 
 * 
 * */
function reqEditDeviceCtrl(param, callback) {
	var url = "Device/EditDeviceCtrl";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

/*删除设备
   'DeviceIDs':'删除的设备的ID,2810000479,2810000480'
 * 	/Device/DeleteDevices
 * */

function reqDelDevices(param, callback) {
	var url = "Device/DeleteDevices";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

/*【设备模块】获取设备分类路径
   '   'ClassID':'当前分类ID'
 * */

function reqListDevClassParent(param, callback) {
	var url = "Device/ListDevClassParent";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

/*获取扩展设备信息
   '
 * */

function reqListRfDevices(callback) {
	var url = "Config/ListRfDevices";
	postServer("", url, callback);
}

/*日志查询
   ' 'DeviceIDs':'需要查询日志的设备ID，格式：1，2，3；查询全部日志则不传递参数',
    'BeginTime':'日志开始时间,年月日；时间从0点开始',
    'EndTime':'日志结束时间,年月日；时间到23:29:29结束',
    'Event':'日志类型，格式：1，2，3；全部则不用传值；1在线/离线，2打开/关闭，3可用/不可用，4投影机开/关，5紧急信息',
    'SortName':'排序，DateTime：日期或时间，Dev_Name：设备，Event：事件，User_Name：用户',
    'SortOrder':'排序方式，asc升序，desc降序',
    'Start':'起始数目，需要结合size参数，和size任意不传表示全部获取',
    'Size':'获取记录条数，需要结合start参数，和start任意不传表示全部获取'
 * */

function reqListDeviceLogs(param, callback) {
	var url = "Device/ListDeviceLogs";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

/*加载设备日志
  DeviceIDs':'需要查询日志的设备ID，格式：1，2，3；查询全部日志则不传递参数','BeginTime':'日志开始时间,
年月日；时间从0点开始','EndTime':'日志结束时间,
年月日；时间到23:29:29结束','Event':'日志类型，格式：1，2，3；全部则不用传值；1在线/离线，2打开/关闭，3可用/不可用，4投影机开/关，5紧急信息'
 * */

function reqListDeviceLog(param, callback) {
	var url = "log/ListDeviceLog";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

/*加载设备配置信息
 'DeviceID':'设备ID'
 * */

function reqLoadDeviceConfig(param, callback) {
	var url = "Device/LoadDeviceConfig";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
/*定时刷新
 'LastID':'设备ID'
 * */

function reqLoadUpdateInfo(param, callback) {
	var url = "Update/LoadUpdateInfo";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
/*加载设备详细信息
 'DevID':'设备ID'
 * */

function reqLoadDeviceDetail(param, callback) {
	var url = "Device/LoadDeviceDetail";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
/*设置设备配置信息
 * */

function reqUpdateDeviceConfig(param, callback) {
	var url = "/Device/UpdateDeviceConfig";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

/*拷贝设备
 * */

function reqCopyDevice(param, callback) {
	var url = "/Device/CopyDevice";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

/*导出设备
  'FileName':'导出文件名，不包括扩展名'
 * */

function reqExportDevice(param, callback) {
	var url = "/Device/ExportDevice";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
var lang=$.cookie("lang");
/*设备导出*/
function formSubmit(param) {
	var params = JSON.stringify(param);
	var turnForm = document.createElement("form");
	//加入到body中
	document.body.appendChild(turnForm);
	turnForm.method = 'post';
	turnForm.action = getBaseURL() + "Device/ExportDevice";
	//创建隐藏表单
	var newElement = document.createElement("input");
	newElement.setAttribute("name", "DataParam");
	newElement.setAttribute("type", "hidden");
	newElement.setAttribute("value", params);
	turnForm.appendChild(newElement);
	var newUserID = document.createElement("input");
	newUserID.setAttribute("name", "UserID");
	newUserID.setAttribute("type", "hidden");
	newUserID.setAttribute("value", $.cookie("id"));
	turnForm.appendChild(newUserID);
	var newSession = document.createElement("input");
	newSession.setAttribute("name", "Session");
	newSession.setAttribute("type", "hidden");
	newSession.setAttribute("value", $.cookie("session"));
	turnForm.appendChild(newSession);
	var newLang= document.createElement("input");
	newLang.setAttribute("name", "Lang");
	newLang.setAttribute("type", "hidden");
	newLang.setAttribute("value", lang);
	turnForm.appendChild(newLang);

	turnForm.submit();
}

/*设备日志导出*/
function reqLogExportDevLogs(param) {
	var params = JSON.stringify(param);
	var turnForm = document.createElement("form");
	//加入到body中
	document.body.appendChild(turnForm);
	turnForm.method = 'post';
	turnForm.action = getBaseURL() + "log/ExportDevLogs";
	//创建隐藏表单
	var newElement = document.createElement("input");
	newElement.setAttribute("name", "DataParam");
	newElement.setAttribute("type", "hidden");
	newElement.setAttribute("value", params);
	turnForm.appendChild(newElement);
	var newUserID = document.createElement("input");
	newUserID.setAttribute("name", "UserID");
	newUserID.setAttribute("type", "hidden");
	newUserID.setAttribute("value", $.cookie("id"));
	turnForm.appendChild(newUserID);
	var newSession = document.createElement("input");
	newSession.setAttribute("name", "Session");
	newSession.setAttribute("type", "hidden");
	newSession.setAttribute("value", $.cookie("session"));
	turnForm.appendChild(newSession);
	var newLang= document.createElement("input");
	newLang.setAttribute("name", "Lang");
	newLang.setAttribute("type", "hidden");
	newLang.setAttribute("value", lang);
	turnForm.appendChild(newLang);

	turnForm.submit();
}

/*能耗统计日志导出*/
function reqLogExportDeviceEnergy(param) {
	var params = JSON.stringify(param);
	var turnForm = document.createElement("form");
	//加入到body中
	document.body.appendChild(turnForm);
	turnForm.method = 'post';
	turnForm.action = getBaseURL() + "log/ExportDeviceEnergy";
	//创建隐藏表单
	var newElement = document.createElement("input");
	newElement.setAttribute("name", "DataParam");
	newElement.setAttribute("type", "hidden");
	newElement.setAttribute("value", params);
	turnForm.appendChild(newElement);
	var newUserID = document.createElement("input");
	newUserID.setAttribute("name", "UserID");
	newUserID.setAttribute("type", "hidden");
	newUserID.setAttribute("value", $.cookie("id"));
	turnForm.appendChild(newUserID);
	var newSession = document.createElement("input");
	newSession.setAttribute("name", "Session");
	newSession.setAttribute("type", "hidden");
	newSession.setAttribute("value", $.cookie("session"));
	turnForm.appendChild(newSession);
	var newLang= document.createElement("input");
	newLang.setAttribute("name", "Lang");
	newLang.setAttribute("type", "hidden");
	newLang.setAttribute("value", lang);
	turnForm.appendChild(newLang);

	turnForm.submit();
}

/*用户操作日志导出*/
function reqLogExportUserLogs(param) {
	var params = JSON.stringify(param);
	var turnForm = document.createElement("form");
	//加入到body中
	document.body.appendChild(turnForm);
	turnForm.method = 'post';
	turnForm.action = getBaseURL() + "log/ExportUserLogs";
	//创建隐藏表单
	var newElement = document.createElement("input");
	newElement.setAttribute("name", "DataParam");
	newElement.setAttribute("type", "hidden");
	newElement.setAttribute("value", params);
	turnForm.appendChild(newElement);
	var newUserID = document.createElement("input");
	newUserID.setAttribute("name", "UserID");
	newUserID.setAttribute("type", "hidden");
	newUserID.setAttribute("value", $.cookie("id"));
	turnForm.appendChild(newUserID);
	var newSession = document.createElement("input");
	newSession.setAttribute("name", "Session");
	newSession.setAttribute("type", "hidden");
	newSession.setAttribute("value", $.cookie("session"));
	turnForm.appendChild(newSession);
	var newLang= document.createElement("input");
	newLang.setAttribute("name", "Lang");
	newLang.setAttribute("type", "hidden");
	newLang.setAttribute("value", lang);
	turnForm.appendChild(newLang);

	turnForm.submit();
}
//清除用户操作日志

function reqClearUserLogs(param, callback) {
	var url = "log/ClearUserLogs";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//清除设备使用日志

function reqClearDevLogs(param, callback) {
	var url = "log/ClearDevLogs";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//清除能耗统计

function reqClearDeviceEnergy(param, callback) {
	var url = "log/ClearDeviceEnergy";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

/*媒体库*/
//获取一级导航

function reqListFirstMenu(callback) {
	var url = "Media/ListFirstMenu";
	postServer("", url, callback);
}

//获取二级导航

function reqListSecondMenu(param, callback) {
	var url = "Media/ListSecondMenu";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//新建文件夹

function reqMediaAddDir(param, callback) {
	var url = "Media/AddDir";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//修改文件夹

function reqMediaRename(param, callback) {
	var url = "Media/Rename";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//刪除文件夹

function reqMediaDelete(param, callback) {
	var url = "Media/Delete";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//【媒体库】获取媒体树
function reqListMediaTree(param, callback) {
	callback = (typeof param === 'function') ? param:callback;
	param = (typeof param === 'function')? "" : param;
	var url = "Media/ListMediaTree";
	postServer(param, url, callback);
}

//上传媒体文件

function reqMediaUpload(param, callback) {
	var url = "Media/Upload";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//添加节目源

function reqUploadProgram(param, callback) {
	var url = "Media/UploadProgram";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

/*系统设置*/
//加载网络参数

function reqLoadNetConfig(callback) {
	var url = "Sys/LoadNetConfig";
	postServer("", url, callback);
}

//修改网络参数
function reqUpdateNetConfig(param, callback) {
	var url = "Sys/UpdateNetConfig";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//加载静态路由

function reqListRoute(callback) {
	var url = "Sys/ListRoute";
	postServer("", url, callback);
}
//添加静态路由
function reqAddRoute(param, callback) {
	var url = "Sys/AddRoute";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//修改静态路由
function reqModifyRoute(param, callback) {
	var url = "Sys/ModifyRoute";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//删除静态路由
function reqDelRoute(param, callback) {
	var url = "Sys/DelRoute";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//加载系统时间
function reqLoadSysTime(callback) {
	var url = "Sys/LoadSysTime";
	postServer("", url, callback);
}

//修改系统时间
function reqUpdateSysTime(param, callback) {
	var url = "Sys/UpdateSysTime";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//重启系统
function reqRestartSystem(callback) {
	var url = "Sys/RestartSystem";
	postServer("", url, callback);
}
//关闭系统
function reqShutdown(callback) {
	var url = "Sys/Shutdown";
	postServer("", url, callback);
}

//加载跨域设置
function reqListSubNetwork(callback) {
	var url = "Sys/ListSubNetwork";
	postServer("", url, callback);
}

//更新跨网设置
function reqUpdateSubnetwork(param, callback) {
	var url = "Sys/UpdateSubnetwork";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//加载用户授权设备列表
function reqLoadUserUseDevices(param, callback) {
	var url = "sys/LoadUserUseDevices";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//更新用户信息
function reqsysUpdateUserInfo(param, callback) {
	var url = "sys/UpdateUserInfo";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//删除用户信息
function reqDeleteUsers(param, callback) {
	var url = "sys/DeleteUsers";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//用户使用授权
function reqUpdateUserUseDev(param, callback) {
	var url = "sys/UpdateUserUseDev";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//加载基本信息
function reqLoadBaseInfo(callback) {
	var url = "SysDev/LoadBaseInfo";
	postServer("", url, callback);
}

//修改基本信息
function reqUpdateBaseInfo(param, callback) {
	var url = "SysDev/UpdateBaseInfo";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//加载物联设备信息
function reqListDevRefInfo(callback) {
	var url = "SysDev/ListDevRefInfo";
	postServer("", url, callback);
}
//更新物联设备信息
function reqUpdateDevRefInfo(param, callback) {
	var url = "SysDev/UpdateDevRefInfo";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//加载分区数据
function reqLoadDeviceClassInfo(callback) {
	var url = "SysDev/LoadDeviceClassInfo";
	postServer("", url, callback);
}

//系统-任务设置-新建修改任务模板
function reqTaskTemplateEdit(param, callback) {
	var url = "SysTask/TaskTemplateEdit";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//系统-任务设置-启用/停用任务模板
/*
 *   'id':'模板id,修改必传',
    'Enabled:':'启用/停用，1：启用；0：停用'
 * */
function reqTaskTemplateEnabled(param, callback) {
	var url = "SysTask/TaskTemplateEnabled";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//系统-任务设置-删除任务模板  'ids':'模板id，多个格式：1，2，3'
function reqTaskTemplateDelete(param, callback) {
	var url = "SysTask/TaskTemplateDelete";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//系统-任务设置-拷贝任务模板
function reqTaskTemplateCopy(param, callback) {
	var url = "SysTask/TaskTemplateCopy";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//系统-任务设置-添加/修改运行模式
function reqModeEdit(param, callback) {
	var url = "SysTask/ModeEdit";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//系统-任务设置-删除运行模式
function reqModeDelete(param, callback) {
	var url = "SysTask/ModeDelete";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//系统-任务设置-模式开启、关闭
function reqModeStartOrStop(param, callback) {
	var url = "SysTask/ModeStartOrStop";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//系统-任务设置-模式启用、停用
function reqModeEnabledOrDisabled(param, callback) {
	var url = "SysTask/ModeEnabledOrDisabled";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//系统-任务设置-拷贝模式
function reqModeCopy(param, callback) {
	var url = "SysTask/ModeCopy";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//系统-调课设置-编辑调课
function reqAdjustEdit(param, callback) {
	var url = "SysTask/AdjustEdit";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//系统-调课设置-删除
function reqAdjustDelete(param, callback) {
	var url = "SysTask/AdjustDelete";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//任务   获取一级菜单

function reqListFirtMenu(callback) {
	var url = "Task/ListFirtMenu";
	postServer("", url, callback);
}
//任务   获取二级菜单
function reqListSecondeMenu(param, callback) {
	var url = "Task/ListSecondeMenu";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//加载实时采播配置
function reqLoadRealtimeConfig(param, callback) {
	var url = "Task/LoadRealtimeConfig";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//更新实时采播配置
function reqUpdateRealtimeConfig(param, callback) {
	var url = "Task/UpdateRealtimeConfig";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//删除任务
function reqDeleteSessions(param, callback) {
	var url = "Task/DeleteSessions";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//获取任务播放列表
function reqListPlayList(param, callback) {
	var url = "Task/ListPlayList";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//获取接收成员列表
function reqListSessionDevices(param, callback) {
	var url = "Task/ListSessionDevices";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//获取接收成员列表(新建)
function reqListSessionDevicesForNew(callback) {
	var url = "Task/ListSessionDevicesForNew";
	postServer("", url, callback);
}
//获取任务播放列表
function reqListPlayList(param, callback) {
	var url = "Task/ListPlayList";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//获取任务详细信息
function reqLoadPlaySession(param, callback) {
	var url = "Task/LoadPlaySession";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//【任务模块】编辑（新增/修改）定时广播
function reqEditBroadcast(param, callback) {
	var url = "Task/EditBroadcast";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//【任务模块】编辑（新增/修改）定时控制任务
function reqEditCtrl(param, callback) {
	var url = "/Task/EditCtrl";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//【任务模块】获取任务详细信息
function reqLoadPlaySession(param, callback) {
	var url = "Task/LoadPlaySession";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//加载所有配置数据
function reqLoadConfig(callback) {
	var url = "Config/LoadConfig";
	postServer("", url, callback);
}

//【任务模块】播放广播
function reqPlaySession(param, callback) {
	var url = "Task/PlaySession";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//【任务模块】暂停广播
function reqPasueSession(param, callback) {
	var url = "Task/PasueSession";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//【任务模块】停止广播
function reqStopSession(param, callback) {
	var url = "Task/StopSession";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//修改个人信息
function reqUpdateUserInfo(param, callback) {
	var url = "User/UpdateUserInfo";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//	【用户系统】 加载个人信息
function reqLoadUserInfo(callback) {
	var url = "User/LoadUserInfo";
	postServer("", url, callback);
}

//【系统管理-用户管理】加载用户信息
function reqsysLoadUserInfo(param, callback) {
	var url = "sys/LoadUserInfo";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//【系统管理-运行/备用模式】获取模式详情
function reqsysLoadModeInfo(param, callback) {
	var url = "SysTask/LoadModeInfo";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//【系统管理-运行/备用模式】获取备用模式
function reqsysModeDisabledList(param, callback) {
	var url = "SysTask/ModeDisabledList";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//【系统管理-分区设置】更新分区数据
function reqsysUpdateDeviceClassInfo(param, callback) {
	var url = "SysDev/UpdateDeviceClassInfo";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//【系统管理-分区设置】编辑分区数据
function reqSysDevEditDevClass(param, callback) {
	var url = "SysDev/EditDevClass";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//【系统管理-分区设置】删除分区数据
function reqSysDevDeleteDevClass(param, callback) {
	var url = "SysDev/DeleteDevClass";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}

//	【系统管理-分区设置】移动分区或设备
function reqSysDevMoveDevices(param, callback) {
	var url = "SysDev/MoveDevices";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//	【系统管理-分区设置】获取分区下的分区或设备
function reqSysDevListDevicesForClass(param, callback) {
	var url = "SysDev/ListDevicesForClass";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//	【媒体库】获取媒体资源文件
function reqMediaListMedias(param, callback) {
	var url = "Media/ListMedias";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//	【任务模块】手动广播更新
function reqTaskUpdateHandTask(callback) {
	var url = "Task/UpdateHandTask";
	postServer("", url, callback);
}
//	【任务模块】临时停播/取消临时停播
function reqTaskTemporary(param,callback) {
	var url = "Task/Temporary";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//	【系统管理-跨网设置】编辑跨网设置	
function reqSysEditSubnetwork(param,callback) {
	var url = "Sys/EditSubnetwork";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//	【系统管理-跨网设置】删除跨网设置
function reqSysDeleteSubnetwork(param,callback) {
	var url = "Sys/DeleteSubnetwork";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//【系统管理-用户管理】获取模式成员(新建模式任务需要)
function reqTaskListModeDevices(param,callback) {
	var url = "Task/ListModeDevices";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//【设备模块】加载设备物联控制状态
function reqDeviceLoadDevRf(param,callback) {
	var url = "Device/LoadDevRf";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//【事件模块】获取事件详细
function reqSysEventInfo(param,callback) {
	var url = "SysEvent/Info";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//【事件模块】获取手动任务
function reqSysEventListTask(param,callback) {
	var url = "SysEvent/ListTask";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//【事件模块】获取厂商、型号	
function reqSysEventListModel(callback) {
	var url = "SysEvent/ListModel";
/*	var params = JSON.stringify(param);*/
	postServer("", url, callback);
}
//【事件模块】编辑事件	
function reqSysEventEdit(param,callback) {
	var url = "SysEvent/Edit";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//【事件模块】删除事件	
function reqSysEventRemove(param,callback) {
	var url = "SysEvent/Remove";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//【系统管理-RTMP服务器】获取配置数据
function reqSysRTMPInfo(param,callback) {
	var url = "SysRTMP/Info";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//	【系统管理-RTMP服务器】编辑配置数据
function reqSysRTMPEdit(param,callback) {
	var url = "SysRTMP/Edit";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//	【系统管理-RTMP服务器】删除配置数据
function reqSysRTMPRemove(param,callback) {
	var url = "SysRTMP/Remove";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}
//	【媒体库】获取文件路径（选择媒体文件需要）
function reqMediaLoadPathForSelect(param,callback) {
	var url = "Media/LoadPathForSelect";
	var params = JSON.stringify(param);
	postServer(params, url, callback);
}