<?php
	
$data = getData('./api_config.json');

function getData($file)
{
	$text = file_get_contents($file);
	$text = preg_replace("%//\s+[^\n]+%", '', $text);
	$data = json_decode($text);
	
	if (empty($data)) {
		return false;
	} else {
		return formatData($data);
	}
}

function formatData($data)
{
	return $data;
}
?>
<html>
<head>
	<meta charset="utf-8">
	<link href="index.css" rel="stylesheet" type="text/css">
	<script type="text/javascript" src="../admin/js/default/jquery.min.js"></script>
</head>
<body>
	<h1><?php echo $data->title; ?>接口测试工具</h1>
	<div class="parms_div">
		<span>接口名称：</span>
                <select id="apipick" autocomplete="off">
			<option value="" selected>接口名称</option>                            
				<?php $i=1; foreach ($data->api as $key => $value): ?>
					<option value="<?php echo $i++; ?>"><?php echo  $value->Desc ?></option>
				<?php endforeach ?>
		</select>
		<select id="apipick_action" autocomplete="off">
			<option value="" selected>接口名称</option> 
				<?php $i=1; foreach ($data->api as $key => $value): ?>
					<option value="<?php echo $i++; ?>"  ><?php echo  $value->Action ?></option>
				<?php endforeach ?>
		</select>
	</div>
	<div class="parms_div">
		<span>接口地址：</span>
		<select id="serverUrl" autocomplete="off">
				<?php foreach ($data->server as $key => $value): ?>
					<option value="<?php echo $value ?>" ><?php echo $key ?></option>
				<?php endforeach ?>
		</select>
	</div>
       <div class="parms_div">
           
        <?php foreach ($data->api as $key => $value): ?>
           <input type="hidden" id="form_<?php echo $key + 1; ?>" value="<?php echo $value->Alias; ?>"/>
        <?php endforeach;?>
	
	<?php if ( 0 == count($data->api) ) { ?>

	<span>接口参数：没有参数</span>

	<?php } else { ?>

	<span>接口参数：</span>
		<?php $i = 1;?>
		
		<?php foreach ($data->api as $key => $value): ?>
			<div id='<?php echo $i ?>' style="display:none;" class="parms">
				<form id="<?php echo $value->Alias ?>" action="<?php echo $key ?>" method="POST" target="">
					<table border="1">
                   		<?php   
                   			echo '<tr><td>描述</td>';
                   			echo '<td>'.$value->Desc.'</td>';
                   			echo '<td>'.$value->Action.'</td></tr>';

                   			foreach ($value->Request as $key1 => $value1):
                            	echo '<tr><td align="right" style="max-width:550px;">'.$value1->Desc."</td>";
                            	echo '<td>'.$key1."</td>";
                            	if (property_exists($value1, 'Type') == 1 && strtolower($value1->Type) == 'textarea'):
                            		echo '<td><textarea name="'. $key1 .'" rows=5 cols=50>'.$value1->Value.'</textarea></td></tr>';
                            	else:
                            		echo '<td><input type="text" name="'. $key1 .'" value="'.$value1->Value.'" ></td></tr>';
                            	endif;
                          	endforeach; 
                          	 ?>
				</table>
				</form>

			</div>
			</div>

		<?php  $i++ ?>
		<?php endforeach ?>
	<?php }?>

	<div class="parms_div">
		<button id="send">发送</button>
	</div>
	<div class="parms_div">
		<span>返回结果：</span><br/>
		<div id="request" style="word-break:break-all;white-space:normal;">
		</div>
	</div>
	<script type="text/javascript" charset="utf-8">
	$(function(){
		$("#apipick").change(function(){
			$("#request").html('');
			var api = $(this).val();
			if (api == '') {
				return false;
			}
			$(".parms").hide();
			var index = $("#apipick :selected").index();
			$("#"+index).show();
                        
                        $("#apipick_action").val(index);
		});
                $("#apipick_action").change(function(){
			$("#request").html('');
			var api = $(this).val();
			if (api == '') {
				return false;
			}
			$(".parms").hide();
			var index = $("#apipick_action :selected").index();
			$("#"+index).show();
                        
                        $("#apipick").val(index);
		});
		$("#send").click(function(){
			var url;
			var a = $("#apipick_action :selected").text();
			var b = $("#serverUrl :selected").val();
                        var index = $("#apipick :selected").index();
			var parm = $("#" + $("#form_"+index).val()).serialize();
                       
			if (a=='') {
				alert('请选择接口');
				return false;
			}
			if (b=='') {
				alert('请选择接口地址');
				return false;
			}
			url = b+a;

			if (a == '/Device/ExportDevLogs') {
				$("#" + $("#form_"+index).val()).attr('action', url);
				$("#" + $("#form_"+index).val())[0].submit();
			} else {
			$.ajax({
				'url': url,
				'data':parm,
				'dataType': 'text',
				'type' : 'post',
				'success':function(data){
					 try {
                         var tempdasta = eval('(' + data + ')'); ;
                     
                         if (tempdasta !== undefined && tempdasta.Data !== null && tempdasta.Data.Session !== undefined &&　tempdasta.Data.User_ID !== undefined) {
                             $('input[name=UserID]').val(tempdasta.Data.User_ID);
                             $('input[name=Session]').val(tempdasta.Data.Session);
                         } 
                    } catch(e){ 
                    }
					$("#request").html(data);
				},
				'beforeSend' : function(){
					$("#request").html('加载数据中...');
				},
				'error' : function(i, data){
					$("#request").html(i.responseText);
				}
			});
			}
		});
	});
	
	</script>
</body>
</html>


