<?php
	
$data = GetApiData('./api_config.json');

function GetApiData($file) {
    
    $ApiData = getData($file);
    
    if (!$ApiData) {
        return false;
    }
    $Api = $ApiData->api;
    $ApiData->api = array();
    
    foreach ($Api as $value) {
        $TempArr = getData($value);
        
        if (!$TempArr) {
            continue;
        }
        $ApiData->api = array_merge($ApiData->api, $TempArr);
    }
    
    return $ApiData;
}

function getData($file)
{
	$text = file_get_contents($file);
	$text = preg_replace("%//\s+[^\n]+%", '', $text);
	$data = json_decode($text);
	
	if (empty($data)) {
            return false;
	} else {
            $Out = formatData($data);
            
            return $Out;
	}
}

function formatData($data) {
	return $data;
}

function getFormatJsonStrFromString($jsonStr, $Html=false) {
    
    $res = "";
    $i =0;
    $j = 0;
    $k = 0; 
    $ii;
    $ele;
    
    for(; $i < strlen($jsonStr); $i++) {
        $ele = $jsonStr[$i];
        
        if($j%2==0 && $ele=="}") {
            $k--; 
            
            for($ii=0;$ii<$k;$ii++) {
                if ($Html) {
                    $ele = "    " . $ele;
                } else {
                    $ele ="    " . $ele;
                }
            }
            if ($Html) {
                $ele = "<br/>" . $ele;
            } else {
                $ele = "\n" . $ele;
            }
           
        } else if($j%2==0&&$ele=="{") {
            if ($Html) {
                $ele .="<br/>";
            } else {
                $ele .="\n";
            }
            $k++;        
            
            for($ii=0;$ii<$k;$ii++) 
                $ele .="    ";
        } else if($j%2==0&&$ele==",") {
           if ($Html) {
                $ele .="<br/>";
            } else {
                $ele .="\n";
            }
                
            for($ii=0;$ii<$k;$ii++) {
                if ($Html) {
                    $ele .= "    ";
                } else {
                    $ele .="    ";
                }
            }
        } else if($ele=="\"" || $ele == "'") { 
            $j++;
        }
        $res.=$ele;               
    }
    
    return $res;
}
?>
<html>
<head>
	<meta charset="utf-8">
	<link href="index.css" rel="stylesheet" type="text/css">
	<script type="text/javascript" src="http://code.jquery.com/jquery-2.0.0.min.js"></script>
</head>
<body>
	<h1><?php echo $data->title; ?>接口测试工具</h1>
	<div class="parms_div">
		<span>接口名称：</span>
                <select id="apipick" autocomplete="off">
			<option value="" selected>接口名称</option>                            
				<?php $i=1; foreach ($data->api as $key => $value): ?>
					<option value="<?php echo $i++; ?>"><?php echo  $value->Desc ?></option>
				<?php endforeach ?>
		</select>
		<select id="apipick_action" autocomplete="off">
			<option value="" selected>接口名称</option> 
				<?php $i=1; foreach ($data->api as $key => $value): ?>
					<option value="<?php echo $i++; ?>"  ><?php echo  $value->Action ?></option>
				<?php endforeach ?>
		</select>
	</div>
	<div class="parms_div">
		<span>接口地址：</span>
		<select id="serverUrl" autocomplete="off">
				<?php foreach ($data->server as $key => $value): ?>
					<option value="<?php echo $value ?>" ><?php echo $key ?></option>
				<?php endforeach ?>
		</select>
	</div>
       <div class="parms_div">
           
        <?php foreach ($data->api as $key => $value): ?>
           <input type="hidden" id="form_<?php echo $key + 1; ?>" value="<?php echo $value->Alias; ?>"/>
        <?php endforeach;?>
	
	<?php if ( 0 == count($data->api) ) { ?>

	<span>接口参数：没有参数</span>

	<?php } else { ?>

	<span>接口参数：</span>
		<?php $i = 1;?>
		
		<?php foreach ($data->api as $key => $value): ?>
			<div id='<?php echo $i ?>' style="display:none;" class="parms">
				<form id="<?php echo $value->Alias ?>" action="<?php echo $key ?>">
					<table border="1">
                   		<?php   
                   			echo '<tr><td>描述</td>';
                   			echo '<td>' . $value->Desc . '</td>';
                   			echo '<td>'.$value->Action.'</td></tr>';

                   			foreach ($value->Request as $key1 => $value1):
                            	echo '<tr><td align="left" style="max-width:600px"><div style="max-height:300px;overflow:auto;"><pre>'. getFormatJsonStrFromString($value1->Desc, true) . "</pre></div></td>";
                            	echo '<td>'.$key1."</td>";
                                echo '<td> <div style="max-height:300px;overflow:auto;">';
                            	if (property_exists($value1, 'Type') == 1 && strtolower($value1->Type) == 'textarea'):
                            		echo '<textarea name="'. $key1 .'" rows=15 cols=50>'. getFormatJsonStrFromString($value1->Value) .'</textarea>';
                            	else:
                            		echo '<input type="text" name="'. $key1 .'" value="'. getFormatJsonStrFromString($value1->Value).'" >';
                            	endif;
                                echo '</div></td></tr>';
                          	endforeach; 
                          	 ?>
				</table>
				</form>

			</div>
			</div>

		<?php  $i++ ?>
		<?php endforeach ?>
	<?php }?>

	<div class="parms_div">
		<button id="send">发送</button>
	</div>
	<div class="parms_div">
		<span>返回结果：</span><br/>
		<div  style="word-break:break-all;white-space:normal;">
                    <pre id="request"></pre>
		</div>
	</div>
	<script type="text/javascript" charset="utf-8">
	$(function(){
		$("#apipick").change(function(){
			$("#request").html('');
			var api = $(this).val();
			if (api == '') {
				return false;
			}
			$(".parms").hide();
			var index = $("#apipick :selected").index();
			$("#"+index).show();
                        
                        $("#apipick_action").val(index);
		});
                $("#apipick_action").change(function(){
			$("#request").html('');
			var api = $(this).val();
			if (api == '') {
				return false;
			}
			$(".parms").hide();
			var index = $("#apipick_action :selected").index();
			$("#"+index).show();
                        
                        $("#apipick").val(index);
		});
		$("#send").click(function(){
			var url;
			var a = $("#apipick_action :selected").text();
			var b = $("#serverUrl :selected").val();
                        var index = $("#apipick :selected").index();
			var parm = $("#" + $("#form_"+index).val()).serialize();
                       
			if (a=='') {
				alert('请选择接口');
				return false;
			}
			if (b=='') {
				alert('请选择接口地址');
				return false;
			}
			url = b+a;
			$.ajax({
				'url': url,
				'data':parm,
				'dataType': 'text',
				'type' : 'post',
				'success':function(data){
					 try {
                         var tempdasta = eval('(' + data + ')'); ;
                     
                         if (tempdasta !== undefined && tempdasta.Data !== null && tempdasta.Data.User_ID !== undefined &&　tempdasta.Data.Session !== undefined) {
                             $('input[name=UserID]').val(tempdasta.Data.User_ID);
                             $('input[name=Session]').val(tempdasta.Data.Session);
                             $('input[name=AppType]').val(tempdasta.Data.AppType);
                         } 
                    } catch(e){ 
                    }
					$("#request").html(formatJson(data));
				},
				'beforeSend' : function(){
					$("#request").html('加载数据中...');
				},
				'error' : function(i, data){
					$("#request").html(i.responseText);
				}
			});
		});
	});
	
        
        
        var formatJson = function(json, options) {
            var reg = null,
		formatted = '',
		pad = 0,
		PADDING = '    '; // one can also use '\t' or a different number of spaces
 
	// optional settings
	options = options || {};
	// remove newline where '{' or '[' follows ':'
	options.newlineAfterColonIfBeforeBraceOrBracket = (options.newlineAfterColonIfBeforeBraceOrBracket === true) ? true : false;
	// use a space after a colon
	options.spaceAfterColon = (options.spaceAfterColon === false) ? false : true;
 
	// begin formatting...
	if (typeof json !== 'string') {
		// make sure we start with the JSON as a string
		json = JSON.stringify(json);
	} else {
		// is already a string, so parse and re-stringify in order to remove extra whitespace
		json = JSON.parse(json);
		json = JSON.stringify(json);
	}
 
	// add newline before and after curly braces
	reg = /([\{\}])/g;
	json = json.replace(reg, '\r\n$1\r\n');
 
	// add newline before and after square brackets
	reg = /([\[\]])/g;
	json = json.replace(reg, '\r\n$1\r\n');
 
	// add newline after comma
	reg = /(\,)/g;
	json = json.replace(reg, '$1\r\n');
 
	// remove multiple newlines
	reg = /(\r\n\r\n)/g;
	json = json.replace(reg, '\r\n');
 
	// remove newlines before commas
	reg = /\r\n\,/g;
	json = json.replace(reg, ',');
 
	// optional formatting...
	if (!options.newlineAfterColonIfBeforeBraceOrBracket) {			
		reg = /\:\r\n\{/g;
		json = json.replace(reg, ':{');
		reg = /\:\r\n\[/g;
		json = json.replace(reg, ':[');
	}
	if (options.spaceAfterColon) {			
		reg = /\:/g;
		json = json.replace(reg, ':');
	}
 
	$.each(json.split('\r\n'), function(index, node) {
		var i = 0,
			indent = 0,
			padding = '';
 
		if (node.match(/\{$/) || node.match(/\[$/)) {
			indent = 1;
		} else if (node.match(/\}/) || node.match(/\]/)) {
			if (pad !== 0) {
				pad -= 1;
			}
		} else {
			indent = 0;
		}
 
		for (i = 0; i < pad; i++) {
			padding += PADDING;
		}
 
		formatted += padding + node + '\r\n';
		pad += indent;
	});
 
	return formatted;
};
	</script>
</body>
</html>


