<?php

/**
 * UserIdentity represents the data needed to identity a user.
 * It contains the authentication method that checks if the provided
 * data can identity the user.
 */
class UserIdentity extends CUserIdentity {
	private $UserId;
	private $Username;
	
	/**
	 * Authenticates a user.
	 * The example implementation makes sure if the username and password
	 * are both 'demo'.
	 * In practical applications, this should be changed to authenticate
	 * against some persistent user identity storage (e.g. database).
	 * @return boolean whether authentication succeeds.
	 */
	public function authenticate() {
		
		$sql = "SELECT * FROM Users WHERE User_Name=:User_Name AND Pass_Word = PASSWORD(:Pass_Word)";
		$user = DBMethodUtils::findData ( $sql, array(':User_Name' => $this->username, ':Pass_Word' => $this->password) );
		
		if (empty ( $user )) { //说明
			$sql = "SELECT * FROM Users WHERE User_Name=:User_Name";
			$tempuser = DBMethodUtils::findData ( $sql, array(':User_Name' => $this->username) );
			
			if (empty ( $tempuser )) {
				$this->errorCode = self::ERROR_USERNAME_INVALID;
			} else {
				$this->errorCode = self::ERROR_PASSWORD_INVALID;
			}
		} else {
			$this->errorCode = self::ERROR_NONE;
			$this->UserId = $user ['User_ID'];
			$this->Username = $user ['User_Name'];
		}
		
		return ! $this->errorCode;
	}
	
	/**
	 * Returns the unique identifier for the identity.
	 * The default implementation simply returns {@link username}.
	 * This method is required by {@link IUserIdentity}.
	 * @return string the unique identifier for the identity.
	 */
	public function getId() {
		return $this->UserId;
	}
	
	/**
	 * Returns the display name for the identity.
	 * The default implementation simply returns {@link username}.
	 * This method is required by {@link IUserIdentity}.
	 * @return string the display name for the identity.
	 */
	public function getName() {
		return $this->Username;
	}
}