<?php
class ConfigController extends ServerController {
	/**
	 * 加载空调模式 
	 */
	public function LoadAirConditioningMode() {
		
		$newLang = '';
		
		if (isset ( $_POST ['Lang'] )) {
			$newLang = $_POST ['Lang'];
		}
		
		$mode = array ();
		$mode [count ( $mode )] = array ('id' => 0, 'text' => $this->getStr ( 'appcommon', 'mode_power_off' ) );
		$dbarr = DBMethodUtils::listData ( "SELECT InfomationID as id, Description as text FROM BaseInfo WHERE InfomationID IN(1,2,3,4)" );
		
		foreach ( $dbarr as $dbarritem ) {
			if ("zh_cn" != $newLang) { //非中文
				if ($dbarritem ['text'] == "模式1") {
					$dbarritem ['text'] = "Mode 1";
				} else if ($dbarritem ['text'] == "模式2") {
					$dbarritem ['text'] = "Mode 2";
				} else if ($dbarritem ['text'] == "模式3") {
					$dbarritem ['text'] = "Mode 3";
				} else if ($dbarritem ['text'] == "模式4") {
					$dbarritem ['text'] = "Mode 4";
				}
			}
			$mode [count ( $mode )] = $dbarritem;
		}
		
		return $mode;
	}
	
	/**
	 * 加载电源模式 
	 */
	public function LoadPowerMode() {
		
		$mode = array (array ('id' => 0, 'text' => $this->getStr ( 'appcommon', 'mode_power_off' ) ), array ('id' => 1, 'text' => $this->getStr ( 'appcommon', 'mode_power_on' ) ), array ('id' => 4, 'text' => $this->getStr ( 'appcommon', 'mode_power_native' ) ) );
		
		return $mode;
	}
	
	/**
	 * 获取当前播出时间表
	 */
	public function LoadAlternateDate() {
		
		$sql = 'SELECT * FROM AlternateDate WHERE SpecialDate="' . date ( 'Y-m-d' ) . '"';
		$data = DBMethodUtils::findData ( $sql );
		
		if (! is_null ( $data ) && isset ( $data ['AlteredScheduleDay'] )) {
			return ( int ) $data ['AlteredScheduleDay'];
		}
		
		$W = date ( "w" );
		
		if ($W == 0) { //星期天
			return 6;
		}
		
		return $W - 1;
	}
	/***********************************************************************/
	/**
	 * 加载配置数据
	 */
	public function actionLoadConfig() {
		
		$owner = $this->GetPostOwnerID ();
		
		if (! is_null ( $owner ) && $owner < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '用户需要登陆', null );
			return;
		}
		$config = array ();
		$config ['AirConditioningMode'] = $this->LoadAirConditioningMode ();
		$config ['PowerMode'] = $this->LoadPowerMode ();
		$config ['RfDevice'] = ExpandUtil::LoadExpandDev ();
		$config ['AlternateDate'] = $this->LoadAlternateDate ();
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $config );
	}
	
	/**
	 * 获取空调模式 
	 */
	public function actionListAirConditioningMode() {
		
		$owner = $this->GetPostOwnerID ();
		
		if (! is_null ( $owner ) && $owner < 0) {
			//用户无效
			echo CJSON::encode ( array () );
			return;
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $this->LoadAirConditioningMode () );
	}
	
	/**
	 * 获取电源模式 
	 */
	public function actionListPowerMode() {
		
		$owner = $this->GetPostOwnerID ();
		
		if (! is_null ( $owner ) && $owner < 0) {
			//用户无效
			echo CJSON::encode ( array () );
			return;
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $this->LoadPowerMode () );
	}
	
	/**
	 * 获取扩展设备信息
	 */
	public function actionListRfDevices() {
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', ExpandUtil::LoadExpandDev () );
	}
	
	/**
	 * 加载当前不出时间表
	 */
	public function actionLoadAlternateDate() {
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', array ('AlternateDate' => $this->LoadAlternateDate () ) );
	}
	
	/**
	 * 设置语言
	 */
	public function actionSetLanguage() {
		
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		/**
		 * 可以不用区分大小写
		 * uk : 英文
		 * zh_cn：简体中文
		 */
		if (! empty ( $DataParam ['Language'] )) {
			$lang = ToolUtil::GetLanguage ( $DataParam ['Language'] );
			$lang = strtolower ( $lang );
			Yii::app ()->language = $lang;
			
			ToolUtil::WriteOrReadLanguage ( $lang, LanguageUtil::getUserId (), false );
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '修改成功', null );
		} else {
			echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '修改失败', null );
		}
	}
	
	/**
	 * 获取当前语言
	 */
	public function actionGetLanguage() {
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '成功', array ('Language' => ToolUtil::WriteOrReadLanguage ( '', LanguageUtil::getUserId (), true ) ) );
	}
	
	/**
	 * 
	 * 获取系统当前时间
	 */
	public function actionGetCurrentTime() {
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '成功', array ('CurrTime' => time () ) );
	}
}