<?php
/*****************************************
 * 系统设置
 ****************************************/
class SysController extends ServerController {

//	/**
//	 * 获取网络配置数据
//	 * @param  $Start 开始数据
//	 * @param  $Arr 命令获取的数组
//	 */
//	public function LoadNetData($Start, $Arr) {
//
//		foreach ( $Arr as $Item ) {
//			$Item = strtolower ( $Item );
//				
//			if (strlen ( $Item ) <= strlen ( $Start )) {
//				continue;
//			}
//			$Begin = substr ( $Item, 0, strlen ( $Start ) );
//				
//			if ($Begin == $Start) {
//				return trim ( str_replace ( $Start, '', $Item ) );
//			}
//		}
//
//		return '';
//	}
	////////////////////////////////////////////////////////////////////////////
	/**
	 * 加载网络参数
	 */
	public function actionLoadNetConfig() {

		$Out = array ('Netcard' => array (), 'DNS' => array ('First' => '', 'Second' => '' ) );

		//获取网卡数据
		for($i = 0; $i <= 1; $i ++) {
			$Output = array ();
			$cmd = 'bash idste-eth-cfg eth' . $i;
			exec ( $cmd, $Output );
				
			$Ip = SystemUtil::LoadNetData('address', $Output);
				
			if (empty ( $Ip )) {
				$Param = array ();
				$Param ["Id"] = "eth" . $i;
				$Param ["Ip"] = '';
				$Param ["Mask"] = '';
				$Param ["Getway"] = '';
				$Out ['Netcard'] [] = $Param;
			} else {
				$Param = array ();
				$Param ["Id"] = "eth" . $i;
				$Param ["Ip"] = $Ip;
				$Param ["Mask"] = SystemUtil::LoadNetData ( 'netmask', $Output );
				$Param ["Getway"] = SystemUtil::LoadNetData ( 'gateway', $Output );
				$Out ['Netcard'] [] = $Param;
			}
		}
		//获取DNS数据
		$Output = array ();
		$cmd = 'bash idste-dns-cfg';
		exec ( $cmd, $Output );

		if (! empty ( $Output )) {
			$Item = strtolower ( $Output [0] );
			$arr = explode ( ' ', $Item );

			if (count ( $arr ) >= 2 && strtolower ( trim ( $arr [0] ) ) == 'dns-nameservers') {
				$Out ['DNS'] ['First'] = $arr [1];

				if (count ( $arr ) >= 3) {
					$Out ['DNS'] ['Second'] = $arr [2];
				}
			}
		}

		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $Out );
	}

	/**
	 * 更新网络参数
	 */
	public function actionUpdateNetConfig() {

		/**
		 * Post的参数
		 * {
		 "NetCard":[
		 {
		 "Id":"网卡编号， eth0网卡0，eth1网卡1",
		 "Ip":"Ip地址0",
		 "Mask":"子网掩码",
		 "GetwayIsDefault":"是否是默认网关，1：是，0：不是",
		 "Getway":"网关"
		 }
		 ],
		 "Dns":{
		 "First":"首选DNS",
		 "Second":"备用DNS"
		 }
		 }
		 */

		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );

		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}

		//删除网卡信息
		for($i = 0; $i <= 1; $i ++) {
			$cmd = 'bash idste-eth-cfg eth' . $i . ' 0.0.0.0  2>&1';
			$code = exec ( $cmd, $OutPut );
		}
		
		//修改网络参数
		if (isset ( $DataParam ['NetCard'] )) { //修改网卡参数
			$GatwayCmd = '';
			
			foreach ( $DataParam ['NetCard'] as $item ) {
				if (empty ( $item ['Id'] ) || empty ( $item ['Ip'] ) || empty ( $item ['Mask'] )) {
					continue;
				}
				//命令 idste-eth-cfg [eth] [ip address] [net mask] [gateway]
				$arr = array ();
				$arr [] = $item ['Id'];
				$arr [] = $item ['Ip'];
				$arr [] = $item ['Mask'];
				
				if (isset ( $item ['GetwayIsDefault'] ) && $item ['GetwayIsDefault'] == 1) {
					$arr [] = $item ['Getway'];
					
					$GatwayCmd = 'bash idste-eth-cfg ' . implode ( ' ', $arr ) . '  2>&1';
					continue;
				}
				$cmd = 'bash idste-eth-cfg ' . implode ( ' ', $arr ) . '  2>&1';
				$code = exec ( $cmd, $OutPut );
			}
			
			if (!empty($GatwayCmd)) {
				$code = exec ( $GatwayCmd, $OutPut );
			}
		}
		//删除原来的DNS信息
		exec('bash idste-dns-cfg 0.0.0.0');
		
		//修改DNS
		if (isset ( $DataParam ['Dns'] )) {
			$DNS = $DataParam ['Dns'];
			//命令idste-dns-cfg x.x.x.x [x.x.x.x]
			$temp = array ();
			
			if (! empty ( $DNS ['First'] )) {
				$temp [] = $DNS ['First'];
			}
			if (! empty ( $DNS ['Second'] )) {
				$temp [] = $DNS ['Second'];
			}
			if (! empty ( $temp )) {
				//				$cmd = 'idste-dns-cfg ' . implode ( ' ', $temp ) . ' 2>&1';
				$cmd = 'bash idste-dns-cfg ' . implode ( ' ', $temp ) . '';
				$code = exec ( $cmd, $OutPut );
			
		//				print_r($OutPut);
			}
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, $this->getStr ( 'appcommon', 'err_msg_modifynetcard_success' ), null );
	}

	/**
	 * 加载系统时间
	 */
	public function actionLoadSysTime() {

		exec ( 'date -R', $Output );
		$currentTime = '';

		if (! empty ( $Output )) {
			$currentTime = date ( 'Y-m-d H:i:s', strtotime ( $Output [0] ) );
		}

		//获取时间服务器
		$TimeServer = '';
		$Output = array ();
		exec ( 'bash ntpconf 2>&1', $Output );

		if (! empty ( $Output ) && is_array ( $Output )) {
			$TimeServer = trim ( $Output [0] );
		}

		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', array ('CurrentTime' => $currentTime, 'TimeServer' => $TimeServer ) );
	}
	/**
	 * 修改系统时间
	 */
	public function actionUpdateSysTime() {
		/**
		 * Post的参数
		 {
		 "SysTime":"系统时间（不修改则不传），格式：2015-11-30 19:49:51",
		 "TimeServer":"时间服务器，系统时间（不修改则不传）"
			}
		 */

		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );

		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$UserID = $this->GetPostOwnerID();
		
		if (is_null($UserID)) {
			$UserID = 0;
		}
		$cachedata = CacheUtil::GetCache ( CacheUtil::$USER_CACHE_ID . $UserID );

		if (! empty ( $DataParam ['SysTime'] )) { //手动设置系统时间
			if (strtotime ( $DataParam ['SysTime'] ) > 0) {
				$Output = array ();
				$cmd = 'sudo date -s ' . date ( 'm/d/Y', strtotime ( $DataParam ['SysTime'] ) ) . ' 2>&1';
				exec ( $cmd, $Output );
				//				print_r ( $Output );
				//				echo '<br/><br/>';


				$Output = array ();
				$cmd = 'sudo date -s ' . date ( 'H:i:s', strtotime ( $DataParam ['SysTime'] ) ) . ' 2>&1';
				exec ( $cmd, $Output );
				//				print_r ( $Output );
				//				echo '<br/><br/>';


				$Output = array ();
				$cmd = 'sudo /sbin/hwclock -w 2>&1';
				exec ( $cmd, $Output );
					
				//				print_r ( $Output );
				//				echo '<br/><br/>';
			}
		}

		if (! empty ( $DataParam ['TimeServer'] )) { //设置时间服务器
			$Output = array ();
			$cmd = 'bash ntpconf ' . trim ( $DataParam ['TimeServer'] ) . ' 2>&1';
			exec ( $cmd, $Output );

			//			print_r ( $Output );
			//			echo '<br/><br/>';
		}
		CacheUtil::SetCache( CacheUtil::$USER_CACHE_ID . $UserID, $cachedata);

		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '执行完成', null );
	}

	/**
	 * 重启系统
	 */
	public function actionRestartSystem() {

		exec ( 'sudo /sbin/reboot 2>&1', $Output );
		//		print_r ( $Output );
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '执行完成', null );
	}
	/**
	 * 关机
	 */
	public function actionShutdown() {

		exec ( 'sudo /sbin/shutdown -h now 2>&1', $Output );
		//		print_r ( $Output );
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '执行完成', null );
	}

	/**
	 * 加载静态路由
	 */
	public function actionListRoute() {

		$cmd = 'bash idste-route-cfg 2>&1';
		exec ( $cmd, $Output );
		$Out = array ();

		if (! empty ( $Output ) && is_array ( $Output )) {
			foreach ( $Output as $Item ) {
				$arr = explode ( ' ', $Item );
				//GwDevFalg 1:gw，2：dev，GwDevFalg=1则GwDev是Ip，GwDevFlag=2则GwDev是设备eth0或eth1
				$Param = array ('Net' => '', 'NetMask' => '', 'GwDevFalg' => 1, 'GwDev' => '' );

				for($i = 0; $i < count ( $arr ); $i ++) {
					if (strtolower ( trim ( $arr [$i] ) ) == '-net') {
						$Param ['Net'] = $arr [$i + 1];
						$i ++;
					} else if (strtolower ( trim ( $arr [$i] ) ) == 'netmask') {
						$Param ['NetMask'] = $arr [$i + 1];
						$i ++;
					} else if (strtolower ( trim ( $arr [$i] ) ) == 'gw') {
						$Param ['GwDevFalg'] = 1;
						$Param ['GwDev'] = $arr [$i + 1];
						$i ++;
					} else if (strtolower ( trim ( $arr [$i] ) ) == 'dev') {
						$Param ['GwDevFalg'] = 2;
						$Param ['GwDev'] = $arr [$i + 1];
						$i ++;
					}
				}

				if (! empty ( $Param ['Net'] ) && ! empty ( $Param ['NetMask'] ) && ! empty ( $Param ['GwDev'] )) {
					$Out [] = $Param;
				}
			}
		}

		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $Out );
	}

	/**
	 * 增加静态路由
	 */
	public function actionAddRoute() {

		/**
		 Post的参数
		 {
		 "Net":"子网号 192.167.1.100",
		 "NetMask":"掩码 255.255.255.0",
		 "GwDevFalg":"1：Ip标志，2：设备标志",
		 "GwDev":"GwDevFalg=1为Ip，GwDevFalg=2为设备号，eth0或eth1"
		 }

		 */

		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );

		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$Net = '';
		if (isset ( $DataParam ['Net'] )) {
			$Net = $DataParam ['Net'];
		}
		$NetMask = '';
		if (isset ( $DataParam ['NetMask'] )) {
			$NetMask = $DataParam ['NetMask'];
		}
		$GwDevFalg = 0;
		if (isset ( $DataParam ['GwDevFalg'] ) && is_numeric ( $DataParam ['GwDevFalg'] )) {
			$GwDevFalg = $DataParam ['GwDevFalg'];
		}
		$GwDev = '';

		if (isset ( $DataParam ['GwDev'] )) {
			$GwDev = $DataParam ['GwDev'];
		}

		if (empty ( $Net ) || empty ( $NetMask ) || empty ( $GwDev ) || ! in_array ( $GwDevFalg, array (1, 2 ) )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$cmd = 'bash idste-route-cfg add -net ' . $Net . ' netmask ' . $NetMask . ' ' . ($GwDevFalg == 1 ? 'gw' : 'dev') . ' ' . $GwDev . ' 2>&1';
		exec ( $cmd, $Output );
		//		echo $cmd;
		//		print_r($Output);
		//		echo '<br/>';
		//
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '添加完成', null );
		return;
	}

	/**
	 * 修改静态路由
	 */
	public function actionModifyRoute() {

		/**
		 Post的参数
		 {
		 "OldNet":"子网号 192.167.1.100",
		 "OldNetMask":"掩码 255.255.255.0",
		 "Net":"子网号 192.167.1.100",
		 "NetMask":"掩码 255.255.255.0",
		 "GwDevFalg":"1：Ip标志，2：设备标志",
		 "GwDev":"GwDevFalg=1为Ip，GwDevFalg=2为设备号，eth0或eth1"
		 }
		 */

		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );

		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$OldNet = '';
		if (isset ( $DataParam ['OldNet'] )) {
			$OldNet = $DataParam ['OldNet'];
		}
		$OldNetMask = '';
		if (isset ( $DataParam ['OldNetMask'] )) {
			$OldNetMask = $DataParam ['OldNetMask'];
		}
		$Net = '';
		if (isset ( $DataParam ['Net'] )) {
			$Net = $DataParam ['Net'];
		}
		$NetMask = '';
		if (isset ( $DataParam ['NetMask'] )) {
			$NetMask = $DataParam ['NetMask'];
		}
		$GwDevFalg = 0;
		if (isset ( $DataParam ['GwDevFalg'] ) && is_numeric ( $DataParam ['GwDevFalg'] )) {
			$GwDevFalg = $DataParam ['GwDevFalg'];
		}
		$GwDev = '';

		if (isset ( $DataParam ['GwDev'] )) {
			$GwDev = $DataParam ['GwDev'];
		}
		if (empty ( $OldNet ) || empty ( $OldNetMask ) || empty ( $Net ) || empty ( $NetMask ) || empty ( $GwDev ) || ! in_array ( $GwDevFalg, array (1, 2 ) )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//删除路由
		$cmd = 'bash idste-route-cfg del -net ' . $OldNet . ' netmask ' . $OldNetMask . ' 2>&1';
		exec ( $cmd, $Output );
		//		echo $cmd;
		//		print_r($Output);
		//		echo '<br/>';


		//添加路由
		$cmd = 'bash idste-route-cfg add -net ' . $Net . ' netmask ' . $NetMask . ' ' . ($GwDevFalg == 1 ? 'gw' : 'dev') . ' ' . $GwDev . ' 2>&1';
		exec ( $cmd, $Output );
		//		echo $cmd;
		//		print_r($Output);
		//		echo '<br/>';


		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '修改完成', null );
		return;
	}

	/**
	 * 删除静态路由
	 */
	public function actionDelRoute() {

		/**
		 Post的参数
		 {
		 "Net":"子网号 192.167.1.100",
		 "NetMask":"掩码 255.255.255.0",
		 }
		 */

		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );

		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$Net = '';
		if (isset ( $DataParam ['Net'] )) {
			$Net = $DataParam ['Net'];
		}
		$NetMask = '';
		if (isset ( $DataParam ['NetMask'] )) {
			$NetMask = $DataParam ['NetMask'];
		}

		if (empty ( $Net ) || empty ( $NetMask )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$cmd = 'bash idste-route-cfg del -net ' . $Net . ' netmask ' . $NetMask;
		exec ( $cmd );

		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '删除完成', null );
		return;
	}

}