<?php

/**
 * This is the model class for table "BroadcastMode".
 *
 * The followings are the available columns in table 'BroadcastMode':
 * @property integer $idBroadcastMode
 * @property string $ModeName
 * @property integer $Priority
 * @property integer $Enabled
 * @property string $StartTime
 * @property string $StopTime
 * @property integer $TimeStyle
 * @property integer $Active
 */
class BroadcastMode extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'BroadcastMode';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('Priority, Enabled, TimeStyle, Active', 'numerical', 'integerOnly'=>true),
			array('ModeName', 'length', 'max'=>50),
			array('StartTime, StopTime', 'safe'),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('idBroadcastMode, ModeName, Priority, Enabled, StartTime, StopTime, TimeStyle, Active', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'idBroadcastMode' => 'Id Broadcast Mode',
			'ModeName' => 'Mode Name',
			'Priority' => 'Priority',
			'Enabled' => 'Enabled',
			'StartTime' => 'Start Time',
			'StopTime' => 'Stop Time',
			'TimeStyle' => 'Time Style',
			'Active' => 'Active',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('idBroadcastMode',$this->idBroadcastMode);
		$criteria->compare('ModeName',$this->ModeName,true);
		$criteria->compare('Priority',$this->Priority);
		$criteria->compare('Enabled',$this->Enabled);
		$criteria->compare('StartTime',$this->StartTime,true);
		$criteria->compare('StopTime',$this->StopTime,true);
		$criteria->compare('TimeStyle',$this->TimeStyle);
		$criteria->compare('Active',$this->Active);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return BroadcastMode the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
