<?php
class DevConfig extends CFormModel {

	public $DevID; //设备id
	public $DeviceName; //设备名字
	public $Cfg_ProjectorType; //投影仪型号
	public $Cfg_Remark; //物理位置
	public $Cfg_System; //系统启用和系统开/关机方式，0：禁用，1：启用，0：面板，16：刷卡，32：插卡，48：联动
	public $Cfg_AutoBroadcast; //模拟广播，1：启用，0：禁用
	public $Cfg_ExtAmp; //开机联动，16：投影仪，32：电脑，64：麦克风；多选的时候则为每个值相加的和，如：投影仪 + 电脑 = 48
	//Cfg_ExtentDev;
	public $Cfg_VGAResolution; //分辨率，0：1920*1080@60HZ;1:1440*900@60HZ;2:1336*780@60HZ;3:1280*800@60HZ;4:1024*768@60HZ;800*600@60HZ;
    public $Cfg_Inner_Edid; //预制分辨率
	public $Cfg_BrdTurnoffDelay; //音频输入关闭延迟0 - 255
	public $Cfg_ScrnScrollTime; //屏幕升降时间0-65535
	public $Cfg_PoweroffDelay; //开关延迟0-65535
	public $Cfg_DefAudioVol; //音频增益，0-63，关机后保持音量这个值为255
	public $Cfg_DefMicVol; //麦克风增益，0-63，关机后保持音量这个值为255
	public $Cfg_DefAvSrc; //默认视频输入， 0：上次设定，1：电脑，2：笔记本，3：展台
	public $Cfg_Reserved; //计算机/笔记本/展台/视频广播通道，（通道1为0通道2为1）掩码依次为：1/4/16/64；这个值与掩码与的结果大于0为1，否则为0
	public $Cfg_AudioAmp; //音频增益 0:0db,1:3.75db,2:7.5db,3:11.35db
	public $Cfg_AudioTreble; //音频低音 0- 15
	public $Cfg_AudioBass; //音频高音 0 - 15
	public $Cfg_MicAmp; //麦克风增益 0:0db,1:3.75db,2:7.5db,3:11.35db
	public $Cfg_MicTreble; //麦克风低音  0- 15
	public $Cfg_MicBass; //麦克风高音  0- 15
	public $Cfg_BroadVol; //广播音量 0 - 63
	public $Cfg_Reserved3; //bit0：用于HDMI音频是否内置，0表示用内置HDMI音频，1表示用模拟音频;bit1：用于食品广播时是否软件增强亮度，0:表示无软件亮度增强，1表示软件亮度增强;bit2：用于是否做麦克风SDP增强
	/*Projector Parameters*/
	public $CheckBit; //校验位 0:无校验，1：奇校验，2：偶校验
	public $StopBit; //发码次数 0：3次,:1：2次,:2：1次
	public $DataBit; //发码间隔 0:5s,1:8s,2:10s,3:15s
	public $BaudRate; //波特率  0:300, 1:600,2:1200,3:2400,4:4800,5:9600,6:19200,7:38400,8:43000,9:56000,10:57600,11:115200
	public $CmdOpen; //投影机码-开机
	public $CmdClose; //投影机码-关机
	public $CmdFromPc; //投影机码-通道1
	public $CmdFromVideo; //投影机码-通道2


	public $IpAddress; //


	//拆分后的数据
	//Cfg_Reserved3拆分
	public $Cfg_Reserved3_hdmi; //bit0：用于HDMI音频是否内置，0表示用内置HDMI音频，1表示用模拟音频
	public $Cfg_Reserved3_video; //bit1：用于视频广播时是否软件增强亮度，0:表示无软件亮度增强，1表示软件亮度增强
	public $Cfg_Reserved3_dsp; //bit2：用于是否做麦克风SDP增强
	public $Cfg_Reserved3_MIC1_SWITCH = 0; //bit3：是否打开有线麦克风1的幻象电源
	public $Cfg_Reserved3_MIC2_SWITCH = 0; //bit4：是否打开有线麦克风2的幻象电源
	public $Cfg_Reserved3_dsp_select = 0; //bit5-6：麦克风DSP音效选项


	//
	public $Cfg_Reserved_jsj; //计算机通道，1为0通道2为1
	public $Cfg_Reserved_bjb; //笔记本通道，1为0通道2为1
	public $Cfg_Reserved_zt; //展台通道，1为0通道2为1
	public $Cfg_Reserved_spgb; //视频广播通道，1为0通道2为1


	//
	public $Cfg_System_enable; //系统启用禁用,1:启用，0：禁用
	public $Cfg_System_openstyle; //系统开/关机方式，0：禁用，1：启用，0：面板，16：刷卡，32：插卡，48：联动


	public $CmdOpenDesc; //投影机码-开机
	public $CmdCloseDesc; //投影机码-关机
	public $CmdFromPcDesc; //投影机码-通道1
	public $CmdFromVideoDesc; //投影机码-通道2


	//$Cfg_AutoBroadcast 拆分
	public $Cfg_AutoBroadcast_MN; //模拟广播，1：启用，0：禁用 （bit1）
	public $Cfg_AutoBroadcast_MIC1; //MIC1增益 bit2-4
	public $Cfg_AutoBroadcast_MIC2; //MIC2增益（bit5-7）


	/**
	 * 4个小端字节转换成int
	 * @param $arr
	 * @param $startindex
	 */
	public function BitToInt($arr, $startindex) { //4为
		$res = intval ( $arr [$startindex] );

		if (isset ( $arr [$startindex + 1] )) {
			$res += intval ( $arr [$startindex + 1] ) * 256;
		}
		if (isset ( $arr [$startindex + 2] )) {
			$res += intval ( $arr [$startindex + 2] ) * 65536;
		}
		if (isset ( $arr [$startindex + 3] )) {
			$res += intval ( $arr [$startindex + 3] ) * 16777216;
		}

		return $res;
	}
	/**
	 * int转换成4个小端字节
	 * @param $arr
	 * @param $startindex
	 */
	public function IntToBit($Param) { //4位
		$res = array (0, 0, 0, 0 );

		$data = $Param;
		$res [3] = floor ( $data / 16777216 );
		$data -= $res [3] * 16777216;
		$res [2] = floor ( $data / 65536 );
		$data -= $res [2] * 65536;
		$res [1] = floor ( $data / 256 );
		$data -= $res [2] * 256;
		$res [0] = $data;

		return $res;
	}

	/**
	 * 拆分数组
	 * @param $arr
	 * @param $pos
	 * @param $size
	 */
	public function sliceArr($arr, $pos, $size) {

		$res = array ();

		for($i = $pos; $i < $pos + $size; $i ++) {
			if (isset ( $arr [$i] )) {
				$res [] = $arr [$i];
			}
		}

		return $res;
	}

	/**
	 * 解析设备配置
	 * @param $Dev_Configuration 设置配置存储的数据
	 */
	public function Parse($Dev_Configuration) {

		if (is_null ( $Dev_Configuration ) || trim ( $Dev_Configuration ) == '') {
			return false;
		}
		$arr = unpack ( "C*", $Dev_Configuration );

		for($i = 0; $i < 10; $i ++) {
			array_push ( $arr, 0 );
		}

		if (count ( $arr ) < 480) {
			return false;
		}
		$pos = 1;
		$this->DeviceName = ToolUtil::charsetToUTF8 ( ToolUtil::decToStr ( $this->sliceArr ( $arr, $pos, 32 ) ) );
		$pos += 32;
		$this->Cfg_Remark = ToolUtil::charsetToUTF8 ( ToolUtil::decToStr ( $this->sliceArr ( $arr, $pos, 96 ) ) );
		$pos += 96;
		$this->Cfg_System = $arr [$pos ++];
		$this->Cfg_AutoBroadcast = $arr [$pos ++];
		$this->Cfg_AutoBroadcast_MN = $this->Cfg_AutoBroadcast & 3; //模拟广播，1：启用，0：禁用 （bit1）
		$this->Cfg_AutoBroadcast_MIC1 = ($this->Cfg_AutoBroadcast >> 2) & 7; //MIC1增益 bit2-4
		$this->Cfg_AutoBroadcast_MIC2 = ($this->Cfg_AutoBroadcast >> 5) & 7; //MIC2增益（bit5-7）
		$this->Cfg_ExtAmp = $arr [$pos ++];
		$this->Cfg_VGAResolution = $arr [$pos ++]; //Cfg_ExtentDev;
		$this->Cfg_BrdTurnoffDelay = $this->BitToInt ( $arr, $pos );
		$pos += 4;
		$this->Cfg_ScrnScrollTime = $this->BitToInt ( $arr, $pos );
		$pos += 4;
		$this->Cfg_PoweroffDelay = $this->BitToInt ( $arr, $pos );
		$pos += 4;
		$this->Cfg_ProjectorType = ToolUtil::charsetToUTF8 ( ToolUtil::decToStr ( $this->sliceArr ( $arr, $pos, 64 ) ) );
		$pos += 64;

		/*Projector Parameters*/
		$this->CheckBit = $arr [$pos ++];
		$this->StopBit = $arr [$pos ++];
		$this->DataBit = $arr [$pos ++];
		$this->BaudRate = $arr [$pos ++];

		$this->CmdOpen = ToolUtil::decToHex ( $this->sliceArr ( $arr, $pos, 64 ) ); //需要转换成二进制
		$pos += 64;
		$this->CmdClose = ToolUtil::decToHex ( $this->sliceArr ( $arr, $pos, 64 ) ); //需要转换成二进制
		$pos += 64;
		$this->CmdFromVideo = ToolUtil::decToHex ( $this->sliceArr ( $arr, $pos, 64 ) ); //需要转换成二进制
		$pos += 64;
		$this->CmdFromPc = ToolUtil::decToHex ( $this->sliceArr ( $arr, $pos, 64 ) ); //需要转换成二进制
		$pos += 64;

		$this->CmdOpenDesc = $this->CodeProcess ( $this->CmdOpen ); //投影机码-开机
		$this->CmdCloseDesc = $this->CodeProcess ( $this->CmdClose ); //投影机码-关机
		$this->CmdFromPcDesc = $this->CodeProcess ( $this->CmdFromVideo ); //投影机码-通道1
		$this->CmdFromVideoDesc = $this->CodeProcess ( $this->CmdFromPc ); //投影机码-通道2


		$this->Cfg_DefAudioVol = $arr [$pos ++];
		$this->Cfg_DefMicVol = $arr [$pos ++];
		$this->Cfg_DefAvSrc = $arr [$pos ++];
		$this->Cfg_Reserved = $arr [$pos ++];
		$this->Cfg_AudioAmp = $arr [$pos ++];
		$this->Cfg_AudioTreble = $arr [$pos ++];
		$this->Cfg_AudioBass = $arr [$pos ++];
		$this->Cfg_MicAmp = $arr [$pos ++];
		$this->Cfg_MicTreble = $arr [$pos ++];
		$this->Cfg_MicBass = $arr [$pos ++];
		$this->Cfg_BroadVol = $arr [$pos ++];
		$this->Cfg_Reserved3 = $arr [$pos ++];

		$this->Cfg_Reserved3_hdmi = $this->Cfg_Reserved3 & 1; //(($this->Cfg_Reserved3 << 2) & 7) >> 2; //bit0：用于HDMI音频是否内置，0表示用内置HDMI音频，1表示用模拟音频
		$this->Cfg_Reserved3_video = ($this->Cfg_Reserved3 & 2) >> 1; //(($this->Cfg_Reserved3 << 1) & 7) >> 2; //bit1：用于视频广播时是否软件增强亮度，0:表示无软件亮度增强，1表示软件亮度增强
		$this->Cfg_Reserved3_dsp = ($this->Cfg_Reserved3 & 4) >> 2; //$this->Cfg_Reserved3 >> 2; //bit2：用于是否做麦克风SDP增强
		$this->Cfg_Reserved3_MIC1_SWITCH = ($this->Cfg_Reserved3 & 8) >> 3; // //bit3：是否打开有线麦克风1的幻象电源
		$this->Cfg_Reserved3_MIC2_SWITCH = ($this->Cfg_Reserved3 & 16) >> 4; // //bit4：是否打开有线麦克风2的幻象电源
        $this->Cfg_Reserved3_dsp_select = ($this->Cfg_Reserved3 & 96) >> 5; //bit5-6：麦克风DSP音效选项
        $this->Cfg_Inner_Edid = ($this->Cfg_Reserved3 & 0x80) >> 7; //预制分辨率

		$this->Cfg_Reserved_jsj = (($this->Cfg_Reserved << 6) & 255) >> 6; //计算机通道，通道1：0；通道2：1
		$this->Cfg_Reserved_bjb = (($this->Cfg_Reserved << 4) & 255) >> 6; //笔记本通道，通道1：0；通道2：1
		$this->Cfg_Reserved_zt = (($this->Cfg_Reserved << 2) & 255) >> 6; //展台通道，通道1：0；通道2：1
		$this->Cfg_Reserved_spgb = (($this->Cfg_Reserved) & 255) >> 6; //视频广播通道，通道1：0；通道2：1


		$this->Cfg_System_enable = $this->Cfg_System & 1; //系统启用禁用,1:启用，0：禁用
		$this->Cfg_System_openstyle = $this->Cfg_System - $this->Cfg_System_enable; //系统开/关机方式，0：禁用，1：启用，0：面板，16：刷卡，32：插卡，48：联动


		//		$pos ++;
	}
	/**
	 * 从JSON解析数据
	 * @param $Configuration
	 */
	public function ParseFromJson($Configuration) {

		$arr = $Configuration;

		if (! is_array ( $arr )) {
			$arr = CJSON::decode ( $Configuration );
		}
		if (is_null ( $arr )) {
			return false;
		}
		if (! isset ( $arr ['DevID'] ))
		return false;
		$this->DevID = $arr ['DevID'];
		if (! isset ( $arr ['IpAddress'] ))
		return false;
		$this->IpAddress = $arr ['IpAddress'];
		if (! isset ( $arr ['DeviceName'] ))
		return false;
		$this->DeviceName = mb_strcut($arr ['DeviceName'], 0, 32);;
		if (! isset ( $arr ['Cfg_Remark'] ))
		return false;
		$this->Cfg_Remark = mb_strcut($arr ['Cfg_Remark'], 0, 96);
		if (! isset ( $arr ['Cfg_System'] ))
		return false;

		$this->Cfg_System_enable = isset ( $arr ['Cfg_System_enable'] ) ? $arr ['Cfg_System_enable'] : 0; //系统启用禁用,1:启用，0：禁用
		$this->Cfg_System_openstyle = isset ( $arr ['Cfg_System_openstyle'] ) ? $arr ['Cfg_System_openstyle'] : 0; //系统开/关机方式，0：禁用，1：启用，0：面板，16：刷卡，32：插卡，48：联动


		$this->Cfg_System_enable = $this->Cfg_System_enable == 1 ? 1 : 0;

		if (! in_array ( $this->Cfg_System_openstyle, array (0, 16, 32, 48 ) )) {
			$this->Cfg_System_openstyle = 0;
		}

		$this->Cfg_System = $this->Cfg_System_enable + $this->Cfg_System_openstyle;

		if (! isset ( $arr ['Cfg_AutoBroadcast_MN'] ))
		return false;
		$this->Cfg_AutoBroadcast_MN = $arr ['Cfg_AutoBroadcast_MN']; //模拟广播，1：启用，0：禁用 （bit1）
		$this->Cfg_AutoBroadcast_MN = $this->Cfg_AutoBroadcast_MN == 1 ? 1 : 0;

		if (! isset ( $arr ['Cfg_AutoBroadcast_MIC1'] ))
		return false;
		$this->Cfg_AutoBroadcast_MIC1 = $arr ['Cfg_AutoBroadcast_MIC1']; //MIC1增益 bit2-4
		$this->Cfg_AutoBroadcast_MIC1 = $this->Cfg_AutoBroadcast_MIC1 >= 7 ? 7 : $this->Cfg_AutoBroadcast_MIC1;
		$this->Cfg_AutoBroadcast_MIC1 = $this->Cfg_AutoBroadcast_MIC1 <= 0 ? 0 : $this->Cfg_AutoBroadcast_MIC1;
		if (! isset ( $arr ['Cfg_AutoBroadcast_MIC2'] ))
		return false;
		$this->Cfg_AutoBroadcast_MIC2 = $arr ['Cfg_AutoBroadcast_MIC2']; //MIC2增益（bit5-7）
		$this->Cfg_AutoBroadcast_MIC2 = $this->Cfg_AutoBroadcast_MIC2 >= 7 ? 7 : $this->Cfg_AutoBroadcast_MIC2;
		$this->Cfg_AutoBroadcast_MIC2 = $this->Cfg_AutoBroadcast_MIC2 <= 0 ? 0 : $this->Cfg_AutoBroadcast_MIC2;
		//
		//		if (! isset ( $arr ['Cfg_AutoBroadcast'] ))
		//			return false;
		$this->Cfg_AutoBroadcast = $this->Cfg_AutoBroadcast_MN + ($this->Cfg_AutoBroadcast_MIC1 << 2) + ($this->Cfg_AutoBroadcast_MIC2 << 5);
		//		$arr ['Cfg_AutoBroadcast'];
		if (! isset ( $arr ['Cfg_ExtAmp'] ))
		return false;
		$this->Cfg_ExtAmp = $arr ['Cfg_ExtAmp'];
		if (! isset ( $arr ['Cfg_VGAResolution'] ))
		return false;
		$this->Cfg_VGAResolution = $arr ['Cfg_VGAResolution']; //Cfg_ExtentDev;
		if (! isset ( $arr ['Cfg_BrdTurnoffDelay'] ))
		return false;
		$this->Cfg_BrdTurnoffDelay = $arr ['Cfg_BrdTurnoffDelay'];
		$this->Cfg_BrdTurnoffDelay = $this->Cfg_BrdTurnoffDelay <= 0 ? 0 : $this->Cfg_BrdTurnoffDelay;
		$this->Cfg_BrdTurnoffDelay = $this->Cfg_BrdTurnoffDelay >= 255 ? 255 : $this->Cfg_BrdTurnoffDelay;
		if (! isset ( $arr ['Cfg_ScrnScrollTime'] ))
		return false;
		$this->Cfg_ScrnScrollTime = $arr ['Cfg_ScrnScrollTime'];
		$this->Cfg_ScrnScrollTime = $this->Cfg_ScrnScrollTime <= 0 ? 0 : $this->Cfg_ScrnScrollTime;
		$this->Cfg_ScrnScrollTime = $this->Cfg_ScrnScrollTime >= 65535 ? 65535 : $this->Cfg_ScrnScrollTime;

		if (! isset ( $arr ['Cfg_PoweroffDelay'] ))
		return false;
		$this->Cfg_PoweroffDelay = $arr ['Cfg_PoweroffDelay'];
		$this->Cfg_PoweroffDelay = $this->Cfg_PoweroffDelay <= 0 ? 0 : $this->Cfg_PoweroffDelay;
		$this->Cfg_PoweroffDelay = $this->Cfg_PoweroffDelay >= 65535 ? 65535 : $this->Cfg_PoweroffDelay;

		if (! isset ( $arr ['Cfg_ProjectorType'] ))
		return false;
		$this->Cfg_ProjectorType = $arr ['Cfg_ProjectorType'];

		/*Projector Parameters*/
		if (! isset ( $arr ['CheckBit'] ))
		return false;
		$this->CheckBit = $arr ['CheckBit'];
		if (! isset ( $arr ['StopBit'] ))
		return false;
		$this->StopBit = $arr ['StopBit'];
		if (! isset ( $arr ['DataBit'] ))
		return false;
		$this->DataBit = $arr ['DataBit'];
		if (! isset ( $arr ['BaudRate'] ))
		return false;
		$this->BaudRate = $arr ['BaudRate'];

		if (! isset ( $arr ['CmdOpen'] ))
		return false;
		$this->CmdOpen = $arr ['CmdOpen'];
		if (! isset ( $arr ['CmdClose'] ))
		return false;
		$this->CmdClose = $arr ['CmdClose'];
		if (! isset ( $arr ['CmdFromVideo'] ))
		return false;
		$this->CmdFromVideo = $arr ['CmdFromVideo'];
		if (! isset ( $arr ['CmdFromPc'] ))
		return false;
		$this->CmdFromPc = $arr ['CmdFromPc'];

		if (! isset ( $arr ['Cfg_DefAudioVol'] ))
		return false;
		$this->Cfg_DefAudioVol = $arr ['Cfg_DefAudioVol'];
		$this->Cfg_DefAudioVol = $this->Cfg_DefAudioVol <= 0 ? 0 : $this->Cfg_DefAudioVol;
		//		$this->Cfg_DefAudioVol = $this->Cfg_DefAudioVol >= 63 ? 63 : $this->Cfg_DefAudioVol;


		if (! isset ( $arr ['Cfg_DefMicVol'] ))
		return false;
		$this->Cfg_DefMicVol = $arr ['Cfg_DefMicVol'];
		$this->Cfg_DefMicVol = $this->Cfg_DefMicVol <= 0 ? 0 : $this->Cfg_DefMicVol;
		//		$this->Cfg_DefMicVol = $this->Cfg_DefMicVol >= 63 ? 63 : $this->Cfg_DefMicVol;


		if (! isset ( $arr ['Cfg_DefAvSrc'] ))
		return false;
		$this->Cfg_DefAvSrc = $arr ['Cfg_DefAvSrc'];

		$this->Cfg_Reserved_jsj = isset ( $arr ['Cfg_Reserved_jsj'] ) ? $arr ['Cfg_Reserved_jsj'] : 0; //(($this->Cfg_Reserved << 6) & 255) >> 6; //计算机通道，通道1：0；通道2：1
		$this->Cfg_Reserved_bjb = isset ( $arr ['Cfg_Reserved_bjb'] ) ? $arr ['Cfg_Reserved_bjb'] : 0; //(($this->Cfg_Reserved << 4) & 255) >> 6; //笔记本通道，通道1：0；通道2：1
		$this->Cfg_Reserved_zt = isset ( $arr ['Cfg_Reserved_zt'] ) ? $arr ['Cfg_Reserved_zt'] : 0; //(($this->Cfg_Reserved << 2) & 255) >> 6; //展台通道，通道1：0；通道2：1
		$this->Cfg_Reserved_spgb = isset ( $arr ['Cfg_Reserved_spgb'] ) ? $arr ['Cfg_Reserved_spgb'] : 0; //(($this->Cfg_Reserved) & 255) >> 6; //视频广播通道，通道1：0；通道2：1


		$this->Cfg_Reserved_jsj = $this->Cfg_Reserved_jsj == 1 ? 1 : 0; //(($this->Cfg_Reserved << 6) & 255) >> 6; //计算机通道，通道1：0；通道2：1
		$this->Cfg_Reserved_bjb = $this->Cfg_Reserved_bjb == 1 ? 1 : 0; //(($this->Cfg_Reserved << 4) & 255) >> 6; //笔记本通道，通道1：0；通道2：1
		$this->Cfg_Reserved_zt = $this->Cfg_Reserved_zt == 1 ? 1 : 0; //(($this->Cfg_Reserved << 2) & 255) >> 6; //展台通道，通道1：0；通道2：1
		$this->Cfg_Reserved_spgb = $this->Cfg_Reserved_spgb == 1 ? 1 : 0; //(($this->Cfg_Reserved) & 255) >> 6; //视频广播通道，通道1：0；通道2：1


		$this->Cfg_Reserved = $this->Cfg_Reserved_jsj + ($this->Cfg_Reserved_bjb << 2) + ($this->Cfg_Reserved_zt << 4) + ($this->Cfg_Reserved_spgb << 6);

		if (! isset ( $arr ['Cfg_AudioAmp'] ))
		return false;
		$this->Cfg_AudioAmp = $arr ['Cfg_AudioAmp'];
		if (! isset ( $arr ['Cfg_AudioTreble'] ))
		return false;
		$this->Cfg_AudioTreble = $arr ['Cfg_AudioTreble'];
		$this->Cfg_AudioTreble = $this->Cfg_AudioTreble <= 0 ? 0 : $this->Cfg_AudioTreble;
		$this->Cfg_AudioTreble = $this->Cfg_AudioTreble >= 15 ? 15 : $this->Cfg_AudioTreble;

		if (! isset ( $arr ['Cfg_AudioBass'] ))
		return false;
		$this->Cfg_AudioBass = $arr ['Cfg_AudioBass'];
		$this->Cfg_AudioBass = $this->Cfg_AudioBass <= 0 ? 0 : $this->Cfg_AudioBass;
		$this->Cfg_AudioBass = $this->Cfg_AudioBass >= 15 ? 15 : $this->Cfg_AudioBass;

		if (! isset ( $arr ['Cfg_MicAmp'] ))
		return false;
		$this->Cfg_MicAmp = $arr ['Cfg_MicAmp'];
		if (! isset ( $arr ['Cfg_MicTreble'] ))
		return false;
		$this->Cfg_MicTreble = $arr ['Cfg_MicTreble'];
		$this->Cfg_MicTreble = $this->Cfg_MicTreble <= 0 ? 0 : $this->Cfg_MicTreble;
		$this->Cfg_MicTreble = $this->Cfg_MicTreble >= 15 ? 15 : $this->Cfg_MicTreble;

		if (! isset ( $arr ['Cfg_MicBass'] ))
		return false;
		$this->Cfg_MicBass = $arr ['Cfg_MicBass'];
		$this->Cfg_MicBass = $this->Cfg_MicBass <= 0 ? 0 : $this->Cfg_MicBass;
		$this->Cfg_MicBass = $this->Cfg_MicBass >= 15 ? 15 : $this->Cfg_MicBass;

		if (! isset ( $arr ['Cfg_BroadVol'] ))
		return false;
		$this->Cfg_BroadVol = $arr ['Cfg_BroadVol'];
		$this->Cfg_BroadVol = $this->Cfg_BroadVol <= 0 ? 0 : $this->Cfg_BroadVol;
		$this->Cfg_BroadVol = $this->Cfg_BroadVol >= 63 ? 63 : $this->Cfg_BroadVol;

		$this->Cfg_Reserved3_hdmi = 1; //(($this->Cfg_Reserved3 << 2) & 7) >> 2; //bit0：用于HDMI音频是否内置，0表示用内置HDMI音频，1表示用模拟音频
		$this->Cfg_Reserved3_video = 0; //(($this->Cfg_Reserved3 << 1) & 7) >> 2; //bit1：用于视频广播时是否软件增强亮度，0:表示无软件亮度增强，1表示软件亮度增强
		$this->Cfg_Reserved3_dsp = 0; //$this->Cfg_Reserved3 >> 2; //bit2：用于是否做麦克风SDP增强
		$this->Cfg_Reserved3_MIC1_SWITCH = 0; // //bit3：是否打开有线麦克风1的幻象电源
		$this->Cfg_Reserved3_MIC2_SWITCH = 0; // //bit4：是否打开有线麦克风2的幻象电源
		$this->Cfg_Reserved3_dsp_select = 0;
		$this->Cfg_Inner_Edid = 0;

		if (isset ( $arr ['Cfg_Reserved3_hdmi'] )) {
			$this->Cfg_Reserved3_hdmi = $arr ['Cfg_Reserved3_hdmi'];
			$this->Cfg_Reserved3_hdmi = $this->Cfg_Reserved3_hdmi == 0 ? 0 : 1;
		}

		if (isset ( $arr ['Cfg_Reserved3_video'] )) {
			$this->Cfg_Reserved3_video = $arr ['Cfg_Reserved3_video'];
			$this->Cfg_Reserved3_video = $this->Cfg_Reserved3_video == 1 ? 1 : 0;
		}

		if (isset ( $arr ['Cfg_Reserved3_dsp'] )) {
			$this->Cfg_Reserved3_dsp = $arr ['Cfg_Reserved3_dsp'];
			$this->Cfg_Reserved3_dsp = $this->Cfg_Reserved3_dsp == 1 ? 1 : 0;
		}
		if (isset ( $arr ['Cfg_Reserved3_MIC1_SWITCH'] )) {
			$this->Cfg_Reserved3_MIC1_SWITCH = $arr ['Cfg_Reserved3_MIC1_SWITCH'];
			$this->Cfg_Reserved3_MIC1_SWITCH = $this->Cfg_Reserved3_MIC1_SWITCH == 1 ? 1 : 0;
		}
		if (isset ( $arr ['Cfg_Reserved3_MIC2_SWITCH'] )) {
			$this->Cfg_Reserved3_MIC2_SWITCH = $arr ['Cfg_Reserved3_MIC2_SWITCH'];
			$this->Cfg_Reserved3_MIC2_SWITCH = $this->Cfg_Reserved3_MIC2_SWITCH == 1 ? 1 : 0;
		}
		if (isset ( $arr ['Cfg_Reserved3_dsp_select'] )) {
			$this->Cfg_Reserved3_dsp_select = $arr ['Cfg_Reserved3_dsp_select'];
		}
        if (isset ( $arr ['Cfg_Inner_Edid'] )) {
            $this->Cfg_Inner_Edid = $arr ['Cfg_Inner_Edid'];
        }
		$this->Cfg_Reserved3 = $this->Cfg_Reserved3_hdmi + ($this->Cfg_Reserved3_video << 1) + ($this->Cfg_Reserved3_dsp << 2)
		+ ($this->Cfg_Reserved3_MIC1_SWITCH << 3) + ($this->Cfg_Reserved3_MIC2_SWITCH << 4) + ($this->Cfg_Reserved3_dsp_select << 5) + ($this->Cfg_Inner_Edid << 7);

		return true;
	}

	/**
	 * 数组添加
	 * @param $descArr
	 * @param $srcArr
	 * @param $start
	 * @param $length
	 */
	public function arrayAdd($descArr, $srcArr, $start, $length) {

		$count = count ( $srcArr );

		for($i = 0; $i < $count; $i ++) {
			//			$descArr ["" . ($start + $i)] = 0;
			//
			//			if ($count > $i) {
			$descArr ["" . ($start + $i)] = $srcArr [$i];

			//			}
		}

		return $descArr;
	}

	/**
	 * 将配置数据转换成存储数据
	 */
	public function ToStr() {

		$arr = array ();

		for($i = 0; $i < 480; $i ++) {
			$arr [] = "";
		}
		$pos = 0;

		$arr = $this->arrayAdd ( $arr, ToolUtil::getb2132Bytes ( $this->DeviceName ), $pos, 32 );
		$pos += 32;
		$arr = $this->arrayAdd ( $arr, ToolUtil::getb2132Bytes ( $this->Cfg_Remark ), $pos, 96 );
		$pos += 96;
		$arr ["" . ($pos ++)] = $this->Cfg_System;
		$arr ["" . ($pos ++)] = $this->Cfg_AutoBroadcast;
		$arr ["" . ($pos ++)] = $this->Cfg_ExtAmp;
		$arr ["" . ($pos ++)] = $this->Cfg_VGAResolution;
		$arr = $this->arrayAdd ( $arr, $this->IntToBit ( $this->Cfg_BrdTurnoffDelay ), $pos, 4 );
		$pos += 4;
		$arr = $this->arrayAdd ( $arr, $this->IntToBit ( $this->Cfg_ScrnScrollTime ), $pos, 4 );
		$pos += 4;
		$arr = $this->arrayAdd ( $arr, $this->IntToBit ( $this->Cfg_PoweroffDelay ), $pos, 4 );
		$pos += 4;
		$arr = $this->arrayAdd ( $arr, ToolUtil::getb2132Bytes ( $this->Cfg_ProjectorType ), $pos, 64 );
		$pos += 64;

		/*Projector Parameters*/
		$arr ["" . ($pos ++)] = $this->CheckBit;
		$arr ["" . ($pos ++)] = $this->StopBit;
		$arr ["" . ($pos ++)] = $this->DataBit;
		$arr ["" . ($pos ++)] = $this->BaudRate;

		$CmdOpen = ToolUtil::getBytes ( $this->CmdOpen );
		$CmdClose = ToolUtil::getBytes ( $this->CmdClose );
		$CmdFromVideo = ToolUtil::getBytes ( $this->CmdFromVideo );
		$CmdFromPc = ToolUtil::getBytes ( $this->CmdFromPc );

		$arr = $this->arrayAdd ( $arr, $CmdOpen, $pos, 64 );
		$pos += 64;
		$arr = $this->arrayAdd ( $arr, $CmdClose, $pos, 64 );
		$pos += 64;
		$arr = $this->arrayAdd ( $arr, $CmdFromVideo, $pos, 64 );
		$pos += 64;
		$arr = $this->arrayAdd ( $arr, $CmdFromPc, $pos, 64 );
		$pos += 64;

		$arr ["" . ($pos ++)] = $this->Cfg_DefAudioVol;
		$arr ["" . ($pos ++)] = $this->Cfg_DefMicVol;
		$arr ["" . ($pos ++)] = $this->Cfg_DefAvSrc;
		$arr ["" . ($pos ++)] = $this->Cfg_Reserved;
		$arr ["" . ($pos ++)] = $this->Cfg_AudioAmp;
		$arr ["" . ($pos ++)] = $this->Cfg_AudioTreble;
		$arr ["" . ($pos ++)] = $this->Cfg_AudioBass;
		$arr ["" . ($pos ++)] = $this->Cfg_MicAmp;
		$arr ["" . ($pos ++)] = $this->Cfg_MicTreble;
		$arr ["" . ($pos ++)] = $this->Cfg_MicBass;
		$arr ["" . ($pos ++)] = $this->Cfg_BroadVol;
		$arr ["" . ($pos ++)] = $this->Cfg_Reserved3;

		$res = "";

		foreach ( $arr as $key => $item ) {
			$temp = dechex ( $item );

			if (strlen ( $temp ) > 2) {
				$temp = substr ( $temp, 0, 2 );
			} else {
				$temp = str_pad ( $temp, 2, "0", STR_PAD_LEFT );
			}
			$res .= $temp;
		}

		return $res;
	}
	/**
	 *
	 * Enter description here ...
	 * @param unknown_type $cmd
	 */
	private function CodeProcess($cmd) {

		if (strlen ( $cmd ) < 3)
		return $cmd;
		$length = substr ( $cmd, 0, 2 );
		$actualLength = strlen ( substr ( $cmd, 2 ) );
		$len = hexdec ( $length );

		if ($len == $actualLength / 2) {
			return substr ( $cmd, 2 );
		} else if ($len < $actualLength / 2) {
			return substr ( $cmd, 2, $len * 2 );
		} else {
			$addZero = '';

			for($i = 0; $i < $len * 2 - $actualLength; $i ++) {
				$addZero .= '0';
			}
			return substr ( $cmd, 2 ) . $addZero;
		}
	}
}
