<?php

/**
 * This is the model class for table "DeviceStatistic".
 *
 * The followings are the available columns in table 'DeviceStatistic':
 * @property string $DeviceID
 * @property string $StatisticDay
 * @property string $PowerConsumed
 * @property string $UsedTime
 */
class DeviceStatistic extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'DeviceStatistic';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('DeviceID, StatisticDay', 'required'),
			array('DeviceID', 'length', 'max'=>50),
			array('PowerConsumed, UsedTime', 'length', 'max'=>128),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('DeviceID, StatisticDay, PowerConsumed, UsedTime', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'DeviceID' => 'Device',
			'StatisticDay' => 'Statistic Day',
			'PowerConsumed' => 'Power Consumed',
			'UsedTime' => 'Used Time',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('DeviceID',$this->DeviceID,true);
		$criteria->compare('StatisticDay',$this->StatisticDay,true);
		$criteria->compare('PowerConsumed',$this->PowerConsumed,true);
		$criteria->compare('UsedTime',$this->UsedTime,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return DeviceStatistic the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
