<?php

/**
 * This is the model class for table "DeviceStatus".
 *
 * The followings are the available columns in table 'DeviceStatus':
 * @property string $DeviceID
 * @property integer $DeviceType
 * @property integer $DeviceStatus
 * @property string $IpAddress
 * @property integer $ShouldSessionID
 * @property integer $ActualSessionID
 * @property integer $State_SysPower
 * @property integer $State_ProjectorStatus
 * @property integer $State_ProjectorLampStatus
 * @property integer $State_ExDevice1Status
 * @property integer $State_ExDevice2Status
 * @property integer $State_CurrProjectorSrc
 * @property integer $State_CurrAudio
 * @property integer $State_CurrAudioVolume
 * @property integer $State_CurrMicVolume
 * @property integer $State_FaultStatus
 * @property integer $State_MicState
 * @property integer $State_Mute
 * @property integer $State_CentralUsedTime
 * @property integer $State_ProjectorUsedTime
 * @property integer $State_LightUsedTime
 * @property integer $Cfg_System
 * @property string $Cfg_Remark
 * @property integer $netid
 * @property integer $NetworkID
 * @property integer $BrdPort
 * @property string $RfDevStatus
 */
class DeviceStatus extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'DeviceStatus';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('DeviceID', 'required'),
			array('DeviceType, DeviceStatus, ShouldSessionID, ActualSessionID, State_SysPower, State_ProjectorStatus, State_ProjectorLampStatus, State_ExDevice1Status, State_ExDevice2Status, State_CurrProjectorSrc, State_CurrAudio, State_CurrAudioVolume, State_CurrMicVolume, State_FaultStatus, State_MicState, State_Mute, State_CentralUsedTime, State_ProjectorUsedTime, State_LightUsedTime, Cfg_System, netid, NetworkID, BrdPort', 'numerical', 'integerOnly'=>true),
			array('DeviceID, IpAddress', 'length', 'max'=>50),
			array('Cfg_Remark', 'length', 'max'=>96),
			array('RfDevStatus', 'length', 'max'=>16),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('DeviceID, DeviceType, DeviceStatus, IpAddress, ShouldSessionID, ActualSessionID, State_SysPower, State_ProjectorStatus, State_ProjectorLampStatus, State_ExDevice1Status, State_ExDevice2Status, State_CurrProjectorSrc, State_CurrAudio, State_CurrAudioVolume, State_CurrMicVolume, State_FaultStatus, State_MicState, State_Mute, State_CentralUsedTime, State_ProjectorUsedTime, State_LightUsedTime, Cfg_System, Cfg_Remark, netid, NetworkID, BrdPort, RfDevStatus', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'DeviceID' => 'Device',
			'DeviceType' => 'Device Type',
			'DeviceStatus' => 'Device Status',
			'IpAddress' => 'Ip Address',
			'ShouldSessionID' => 'Should Session',
			'ActualSessionID' => 'Actual Session',
			'State_SysPower' => 'State Sys Power',
			'State_ProjectorStatus' => 'State Projector Status',
			'State_ProjectorLampStatus' => 'State Projector Lamp Status',
			'State_ExDevice1Status' => 'State Ex Device1 Status',
			'State_ExDevice2Status' => 'State Ex Device2 Status',
			'State_CurrProjectorSrc' => 'State Curr Projector Src',
			'State_CurrAudio' => 'State Curr Audio',
			'State_CurrAudioVolume' => 'State Curr Audio Volume',
			'State_CurrMicVolume' => 'State Curr Mic Volume',
			'State_FaultStatus' => 'State Fault Status',
			'State_MicState' => 'State Mic State',
			'State_Mute' => 'State Mute',
			'State_CentralUsedTime' => 'State Central Used Time',
			'State_ProjectorUsedTime' => 'State Projector Used Time',
			'State_LightUsedTime' => 'State Light Used Time',
			'Cfg_System' => 'Cfg System',
			'Cfg_Remark' => 'Cfg Remark',
			'netid' => 'Netid',
			'NetworkID' => 'Network',
			'BrdPort' => 'Brd Port',
			'RfDevStatus' => 'Rf Dev Status',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('DeviceID',$this->DeviceID,true);
		$criteria->compare('DeviceType',$this->DeviceType);
		$criteria->compare('DeviceStatus',$this->DeviceStatus);
		$criteria->compare('IpAddress',$this->IpAddress,true);
		$criteria->compare('ShouldSessionID',$this->ShouldSessionID);
		$criteria->compare('ActualSessionID',$this->ActualSessionID);
		$criteria->compare('State_SysPower',$this->State_SysPower);
		$criteria->compare('State_ProjectorStatus',$this->State_ProjectorStatus);
		$criteria->compare('State_ProjectorLampStatus',$this->State_ProjectorLampStatus);
		$criteria->compare('State_ExDevice1Status',$this->State_ExDevice1Status);
		$criteria->compare('State_ExDevice2Status',$this->State_ExDevice2Status);
		$criteria->compare('State_CurrProjectorSrc',$this->State_CurrProjectorSrc);
		$criteria->compare('State_CurrAudio',$this->State_CurrAudio);
		$criteria->compare('State_CurrAudioVolume',$this->State_CurrAudioVolume);
		$criteria->compare('State_CurrMicVolume',$this->State_CurrMicVolume);
		$criteria->compare('State_FaultStatus',$this->State_FaultStatus);
		$criteria->compare('State_MicState',$this->State_MicState);
		$criteria->compare('State_Mute',$this->State_Mute);
		$criteria->compare('State_CentralUsedTime',$this->State_CentralUsedTime);
		$criteria->compare('State_ProjectorUsedTime',$this->State_ProjectorUsedTime);
		$criteria->compare('State_LightUsedTime',$this->State_LightUsedTime);
		$criteria->compare('Cfg_System',$this->Cfg_System);
		$criteria->compare('Cfg_Remark',$this->Cfg_Remark,true);
		$criteria->compare('netid',$this->netid);
		$criteria->compare('NetworkID',$this->NetworkID);
		$criteria->compare('BrdPort',$this->BrdPort);
		$criteria->compare('RfDevStatus',$this->RfDevStatus,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return DeviceStatus the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
