<?php

/**
 * This is the model class for table "MsgTasks".
 *
 * The followings are the available columns in table 'MsgTasks':
 * @property integer $MsgTaskID
 * @property string $PlayedTime
 * @property integer $TimeStyle
 * @property integer $Duration
 * @property string $Content
 */
class MsgTasks extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'MsgTasks';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('MsgTaskID', 'required'),
			array('MsgTaskID, TimeStyle, Duration', 'numerical', 'integerOnly'=>true),
			array('Content', 'length', 'max'=>256),
			array('PlayedTime', 'safe'),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('MsgTaskID, PlayedTime, TimeStyle, Duration, Content', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'MsgTaskID' => 'Msg Task',
			'PlayedTime' => 'Played Time',
			'TimeStyle' => 'Time Style',
			'Duration' => 'Duration',
			'Content' => 'Content',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('MsgTaskID',$this->MsgTaskID);
		$criteria->compare('PlayedTime',$this->PlayedTime,true);
		$criteria->compare('TimeStyle',$this->TimeStyle);
		$criteria->compare('Duration',$this->Duration);
		$criteria->compare('Content',$this->Content,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return MsgTasks the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
