<?php
/*****************************************
 * srs对接接口
 ****************************************/
class CameraController extends WebAdminBaseController {
    public static $srsAction = array('on_publish', 'on_unpublish', 'on_connect', 'on_close');
    public static $srsApp = array('bw803', 'camera');
	public function actionSrsHook() {
        $body = json_decode(CHttpRequest::getRawBody(), true);
		$action = $body['action'];
        $app = $body['app'];
        //app是否合法
        if(!in_array($app, self::$srsApp)){
            echo '1';
            return;
        }

        //bw803处理
        if($app == 'bw803'){
            echo '0';
            return;
        }

        //事件是否合法
        if(!in_array($action, self::$srsAction)){
            echo '0';
            return;
        }

        $id = $body['client_id'];
        if(!is_numeric($id)){
            echo '1';
            return;
        }

        //get stream name and cache it
        if($action != 'on_close' && $action != 'on_connect'){
            $stream = $body['stream'];
        }
        else if($action == 'on_connect'){ //connect
            if($body['pageUrl'] == ''){
                echo '0';
                return;
            }
            else{
                $url = explode('=', $body['pageUrl']);
                if(count($url) == 2){
                    $stream = $url[1];
                }
                else{
                    echo '1';
                    return;
                }
            }
            Yii::app()->cache->set('srs'. $id, $stream);
        }
        else{ //close
            $stream = Yii::app()->cache->get('srs'. $id);
            if(false == $stream){
                echo '0';
                return;
            }
            Yii::app()->cache->delete('srs'. $id);
        }

        //流名称是否存在非法字符
        if(preg_match('/[^0-9a-z]/i', $stream) || strlen($stream) != 32){
            echo '1';
            return;
        }

        $sql = '';
        switch($action){
            case 'on_publish':
                $sql = "update IpCameraRtmp set pushId='$id', pullCnt=0  where `key` = '$stream'";
                break;
            case 'on_unpublish':
                $sql = "delete from IpCameraRtmp where `pushId` = '$id'";
                break;
            case 'on_connect':
                $sql = "update IpCameraRtmp set pullCnt =pullCnt + 1 where `key` = '$stream' and pushId >= 0";
                break;
            case 'on_close':
                $sql = "select pullCnt as cnt from IpCameraRtmp where `key` = '$stream'";
                $ret = DBMethodUtils::findData($sql);
                if(is_null($ret) || $ret['cnt'] == 1){
                    self::stopRtmpStream($stream);
                }
                $sql = "update IpCameraRtmp set pullCnt =pullCnt - 1 where `key` = '$stream' and pushId >= 0";
                break;
            default:
                echo '0';
                return;
        }
        if(0 === DBMethodUtils::RunSql($sql))
            echo '1';
        else
            echo '0';
        return;
    }

    public static function stopRtmpStream($stream){
        $cmd = 'ps aux | grep ' . $stream . ' | grep -v grep | awk \'{print $2}\' |  xargs kill -9';
        exec($cmd);
    }
}
