<?php
/*************************************************
 * 模块描述：
 * 定义任务管理模块的功能
 ************************************************/
class TaskController extends WebAdminBaseController {
	
	//定时任务排序字段映射关系
	public $SessionSortNameArr = array ('sessionname' => 'SessionName', //任务名字
'priority' => 'Priority', //优先级
'playtime' => 'PlayTime', //执行时间
'sysenabled' => 'SysEnabled', //设备控制
'rfdevctrl' => 'RfDevCtrl', //扩展设备状态
'circlelength' => 'CircleLength' ); //播出时长
	

	//模板排序字段映射
	public $TemplateSortNameArr = array ('templatename' => 'TemplateName' ); //模板名字
	

	//模板排序字段映射
	public $ModeSortNameArr = array ('modename' => 'ModeName', //模式名字
'priority' => 'Priority' ); //优先级
	

	/*************************************************************************/
	/**
	 * 加载任务树
	 */
	public function actionListTaskTree() {
		
		$UserId = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserId ) && $UserId < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		$tree = array ();
		
		//定时任务，成员列表
		$sql = "SELECT User_ID as id, User_Name as text, 0 as Parent FROM Users WHERE User_ID > 0;";
		
		if ($UserId > 0) {
			$sql = "SELECT User_ID as id, User_Name as text, 0 as Parent FROM Users WHERE User_ID = '" . $UserId . "';";
		}
		$timeTaskUser = DBMethodUtils::listData ( $sql );
		$timeTask = TaskUtil::PackTaskTreeParent ( 0, $this->getStr ( 'appcommon', 'session_time' ), 'Task/ListTimeTasks', $timeTaskUser );
		$tree [0] = $timeTask;
		//		//任务模板
		//		$template = array ();
		//		try {
		//			$sql = "SELECT idTaskTemplate as id, IF (idTaskTemplate=0, '" . $this->getStr ( 'appcommon', 'default' ) . "', TemplateName) AS text, 1 as Parent, Enabled FROM TaskTemplate";
		//			$template = DBMethodUtils::listData ( $sql );
		//		} catch ( Exception $e ) {
		//
		//		}
		//		$tree [1] = TaskUtil::PackTaskTreeParent ( 1, $this->getStr ( 'appcommon', 'session_template' ), 'Task/ListTimeTasks', $template );
		//		//运行模式
		//		$tree [2] = TaskUtil::PackTaskTreeParent ( 2, $this->getStr ( 'appcommon', 'session_runingmode' ), 'Task/ListRuningModes', TaskUtil::LoadBrodcastModes ( 1, 1 ) );
		//		//备用模式
		//		$tree [3] = TaskUtil::PackTaskTreeParent ( 3, $this->getStr ( 'appcommon', 'session_reservemode' ), 'Task/ListReserveModes', TaskUtil::LoadBrodcastModes ( 0, 2 ) );
		//		//手动广播
		//		$tree [4] = TaskUtil::PackTaskTreeParent ( 4, $this->getStr ( 'appcommon', 'session_manual' ), 'Task/ListManualTasks', null );
		//		//实时采播
		//		$tree [5] = TaskUtil::PackTaskTreeParent ( 5, $this->getStr ( 'appcommon', 'session_realtimemining' ), 'Task/ListRealTimeMining', null );
		

		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $tree );
	}
	
	/**
	 * 编辑任务
	 */
	public function actionEditSession() {
		$UserId = $this->GetPostOwnerID ();
		$res = TaskUtil::EditSessions ( $UserId );
		
		echo $this->PackResponseDataAll ( $res );
	}
	
	/**
	 * 编辑任务
	 */
	public function actionEditSessionForApp() {
		
		$UserId = $this->GetPostOwnerID ();
		$res = TaskUtil::EditSessions ( $UserId, true );
		
		echo $this->PackResponseDataAll ( $res );
	}
	
	/**
	 * 编辑时间表
	 */
	public function actionEditTimeTable() {
		
		$UserId = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserId ) && $UserId < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		//播出时间表,格式：[{'ScheduleID':'任务ID','SessionID':'任务ID','PlayTime':'播出时间，时分秒','TempFlag':'状态，0：正常，1：插播，2：暂停','WeekDay':'星期0-6'}]
		$DataParam = null;
		
		if (isset ( $_POST ['DataParam'] )) {
			$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		}
		if (is_null ( $DataParam ) || count ( $DataParam ) <= 0) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//参数正常可以开始编辑
		foreach ( $DataParam as $item ) {
			if (empty ( $item ['SessionID'] ) || ! isset ( $item ['PlayTime'] ) || ! isset ( $item ['TempFlag'] )) {
				continue;
			}
			if (! ToolUtil::JudgeTimeFormat ( $item ['PlayTime'] ) || $item ['TempFlag'] < 0 || $item ['TempFlag'] > 2) {
				continue;
			}
			if (isset ( $item ['weekDay'] )) {
				//判断星期时间是否存在
				$Sql = 'SELECT COUNT(*) c FROM PlaySessionTime WHERE SessionID = :SessionID AND WeekDay =  :WeekDay AND PlayTime=:PlayTime';
				$TempData = DBMethodUtils::findData ( $Sql, array (':SessionID' => $item ['SessionID'], ':WeekDay' => $item ['weekDay'], ':PlayTime' => '2012-03-03 ' . $item ['PlayTime'] ) );
				
				if ($TempData ['c'] > 0) {
					continue;
				}
			}
			if (empty ( $item ['ScheduleID'] ) && isset ( $item ['weekDay'] ) && $item ['weekDay'] >= 0 && $item ['weekDay'] <= 6) { //需要新建
				//判断这个时间是否已经存在			
				$Sql = 'INSERT INTO PlaySessionTime (SessionID, WeekDay,PlayTime,TempFlag) values (:SessionID, :WeekDay,:PlayTime, :TempFlag) 
					on duplicate key update TempFlag = values(TempFlag)';
				DBMethodUtils::RunSql ( $Sql, array (':SessionID' => $item ['SessionID'], ':WeekDay' => $item ['weekDay'], ':PlayTime' => '2012-03-03 ' . $item ['PlayTime'], ':TempFlag' => $item ['TempFlag'] ) );
			} else {
				//更新数据
				$sql = 'UPDATE PlaySessionTime SET PlayTime=:PlayTime, TempFlag=:TempFlag WHERE ScheduleID=:ScheduleID AND SessionID=:SessionID';
				DBMethodUtils::RunSql ( $sql, array (':SessionID' => $item ['SessionID'], ':WeekDay' => $item ['weekDay'], ':PlayTime' => '2012-03-03 ' . $item ['PlayTime'], ':TempFlag' => $item ['TempFlag'], ':ScheduleID' => $item ['ScheduleID'] ) );
			}
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '编辑成功', null );
	}
	/////////////////////////////////////////////////////////
	// 定时任务
	/////////////////////////////////////////////////////////
	/**
	 * 获取定时任务列表
	 */
	public function actionListTimeTasks() {
		
		$UserId = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserId ) && $UserId < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$ParamArr = array ();
		$sql = "SELECT a.SessionID, a.ScheduleID, DATE_FORMAT(a.PlayTime,'%H:%i:%S') as PlayTime, b.CircleLength, a.TempFlag,
			IF(" . (is_null ( $UserId ) ? 0 : $UserId) . " <= 0, IF((ISNULL(uu.User_Name) OR LENGTH(uu.User_Name) < 1), b.SessionName, CONCAT(uu.User_Name, ':',b.SessionName)), b.SessionName) SessionName
			, b.SessionType, b.Priority, b.StreamType, b.SysEnabled, b.RfDevCtrl, dd.Pause,mf.FileName, IF(ISNULL(pl.PlayListCount), 0, pl.PlayListCount) AS PlayListCount 
			FROM PlaySessionTime a LEFT JOIN PlaySessions b ON a.SessionID=b.SessionID 
			LEFT JOIN PlayingSessions dd ON a.SessionID=dd.SessionID AND a.ScheduleID=dd.ScheduleID LEFT JOIN PlayingSessions ps ON a.SessionID=ps.SessionID 
			LEFT JOIN MediaFiles mf ON ps.PlayingFileID=mf.MediaID LEFT JOIN Users uu ON b.Owner=uu.User_ID
			LEFT JOIN (SELECT COUNT(*) AS PlayListCount, SessionID FROM PlayListFiles GROUP BY SessionID) pl ON a.SessionID=pl.SessionID
			WHERE SessionType IN (0,8)";
		
		//任务类型筛选,0:控制任务，1：广播任务，2：都选，3：都不选
		if (isset ( $DataParam ['SelectStreamType'] ) && is_numeric ( $DataParam ['SelectStreamType'] )) {
			
			switch ($DataParam ['SelectStreamType']) {
				case 0 : //控制任务
					$sql = $sql . " AND b.StreamType&7 = 0";
					break;
				case 1 : //广播任务
					$sql = $sql . " AND b.StreamType&7 != 0";
					break;
				case 2 : //所有任务
					break;
				case 3 : //都不选
					$sql = $sql . " AND b.StreamType&7 = -1";
					break;
				default :
					break;
			}
		}
		$OwnerWhere = array ();
		
		if ($UserId > 0) { //非最高权限管理员
			$OwnerWhere [] = " b.Owner = '" . $UserId . "'";
		}
		$Owner = - 1;
		
		if (isset ( $DataParam ['Owner'] ) && is_numeric ( $DataParam ['Owner'] )) { //按照任务所属人筛选
			$Owner = $DataParam ['Owner'];
		}
		
		//任务创建者的id
		if (! is_null ( $Owner ) && $Owner > 0) {
			$OwnerWhere [] = " b.Owner = '" . $UserId . "'";
		}
		if (! empty ( $OwnerWhere )) {
			$sql .= ' AND (' . implode ( ' OR ', $OwnerWhere ) . ')';
		}
		//按照星期筛选
		$byweekday = false;
		
		if (isset ( $DataParam ['WeekDay'] )) {
			$WeekDay = $DataParam ['WeekDay'];
			
			if (is_numeric ( $WeekDay )) {
				$sql = $sql . " AND WeekDay = '" . $WeekDay . "'";
				$byweekday = true;
			}
		}
		if (is_null ( $UserId )) { //TODO 需要考虑是否需要模板
			//按照模板筛选(定时任务不需要传递这个值)
			if (isset ( $DataParam ['Template'] ) && is_numeric ( $DataParam ['Template'] )) {
				$ParamArr [':Template'] = $DataParam ['Template'];
				$sql .= " and Template=:Template";
			} else {
				$sql .= " and Template=(SELECT InfoValue FROM BaseInfo WHERE InfomationID=257)";
			}
		}
		
		//搜索关键字,按照名字搜索
		if (isset ( $DataParam ['SearchKey'] ) && "" != trim ( $DataParam ['SearchKey'] )) {
			$sql .= " AND SessionName like CONCAT('%', :SearchKey, '%')";
			$ParamArr [':SearchKey'] = $DataParam ['SearchKey'];
		}
		$sql = $sql . " GROUP BY a.SessionID,DATE_FORMAT(a.PlayTime,'%H:%i:%S')";
		
		//排序
		if (isset ( $DataParam ['SortName'] ) && isset ( $DataParam ['SortOrder'] )) {
			$SortName = $DataParam ['SortName'];
			$SortOrder = $DataParam ['SortOrder'];
			
			if (! empty ( $this->SessionSortNameArr [strtolower ( $SortName )] ) && ! empty ( $this->SortOrderArr [strtolower ( $SortOrder )] )) {
				$sql .= " ORDER BY " . $this->SessionSortNameArr [strtolower ( $SortName )] . " " . $this->SortOrderArr [strtolower ( $SortOrder )];
			} else {
				$sql .= " ORDER BY PlayTime ASC";
			}
		} else {
			$sql .= " ORDER BY PlayTime ASC";
		}
		
		//分页数据
		if (isset ( $DataParam ['Start'] ) && isset ( $DataParam ['Size'] )) {
			$start = $DataParam ['Start'];
			$size = $DataParam ['Size'];
			
			if (is_numeric ( $start ) && is_numeric ( $size ) && $start >= 0 && $size > 0) {
				$sql = $sql . " LIMIT " . $start . "," . $size;
			}
		}
		$result = DBMethodUtils::listData ( $sql, $ParamArr );
		
		if (is_null ( $result ) || count ( $result ) <= 0) {
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', array () );
			return;
		}
		if ($byweekday) {
			//筛选的是一周的某一天
			$newmodel = array ();
			$tempid = 1;
			
			foreach ( $result as $item ) {
				$newitem = array ();
				$newitem ["TempId"] = ($tempid ++);
				$newitem ["SessionID"] = $item ["SessionID"]; //	默认为0，主键ID
				$newitem ["SessionName"] = $item ["SessionName"]; //任务名称
				$newitem ["SessionType"] = $item ["SessionType"]; //	0: 自动广播或控制任务；1：由PC呼叫台或者音频广播站创建的任务；2：手动广播任务
				$newitem ["Priority"] = $item ["Priority"]; //	优先级
				$newitem ["ScheduleID"] = $item ["ScheduleID"];
				$newitem ["PlayTime"] = $item ["PlayTime"]; //任务指定的播放时间，仅使用时分秒
				$newitem ['SteamTypeDown'] = $item ['StreamType'] - round ( $item ['StreamType'] / 128 ) * 128; //00控制任务，01音频，10视屏，11音视频，一般用11来表示视频。(StreamType低4为来判断)
				$newitem ["TempFlag"] = $item ["TempFlag"]; //是否临时任务，1临时任务，0非临时任务，2暂停，临时任务按照指定的时间执行一次完就删除这条记录
				$newitem ["Pause"] = $item ["Pause"]; //播出状态（仅广播才有），1暂停，0正在播放,null:没有播出状态
				$newitem ["FileName"] = $item ["FileName"]; //正在播放的文件的名字
				$newitem ["PlayListCount"] = $item ["PlayListCount"]; //播放文件数目
				

				if ($newitem ['SteamTypeDown'] == 0) {
					//控制任务需要获取设备状态
					//设备控制，系统启禁用状态，1启用，0禁用，仅控制任务才使用这个字段，null为没有控制
					$newitem ['SysEnabled'] = $item ['SysEnabled'];
					//扩展电源
					if (! is_null ( $item ['RfDevCtrl'] )) {
						//扩展设备信息
						$expandSource = ExpandUtil::LoadExpandDev ();
						//扩展设备模式
						$expandMode = ExpandUtil::LoadExpandMode ();
						
						$DeviceCtrl = DeviceUtil::DepackRfDevCtrl ( $expandSource, $item ['RfDevCtrl'], $expandMode );
						
						$newitem ['DeviceCtrl'] = $DeviceCtrl;
					}
				}
				$newmodel [count ( $newmodel )] = $newitem;
			}
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $newmodel );
		} else { //查看的是一周的全部
			$newmodel = array ();
			$tempid = 1;
			
			foreach ( $result as $item ) {
				$newitem = array ();
				
				$newitem ["SessionID"] = $item ["SessionID"]; //	默认为0，主键ID
				$newitem ["SessionName"] = $item ["SessionName"]; //任务名称
				$newitem ["SessionType"] = $item ["SessionType"]; //	0: 自动广播或控制任务；1：由PC呼叫台或者音频广播站创建的任务；2：手动广播任务
				$newitem ["Priority"] = $item ["Priority"]; //	优先级
				$newitem ["PlayTime"] = $item ["PlayTime"]; //任务指定的播放时间，仅使用时分秒
				$newitem ['SteamTypeDown'] = $item ['StreamType'] - round ( $item ['StreamType'] / 128 ) * 128; //00控制任务，01音频，10视屏，11音视频，一般用11来表示视频。(StreamType低4为来判断)
				//				$newitem ["TempFlag"] = $item ["TempFlag"]; //是否临时任务，1临时任务，0非临时任务，2暂停，临时任务按照指定的时间执行一次完就删除这条记录
				$newitem ["PlayListCount"] = $item ["PlayListCount"]; //播放文件数目
				

				//获取播放时间
				for($i = 0; $i <= 6; $i ++) {
					$newitem ['Player_Weekday_' . $i] = null;
				}
				$sql = "SELECT ScheduleID, SessionID,WeekDay,TempFlag, DATE_FORMAT(PlayTime,'%H:%i:%S') as PlayTime FROM PlaySessionTime
				WHERE SessionID='" . $item ['SessionID'] . "' AND DATE_FORMAT(PlayTime,'%H:%i:%S')='" . $item ["PlayTime"] . "'";
				$PlayTimes = DBMethodUtils::listData ( $sql );
				
				//新建的一行，key1：周数，value：
				$newarr = array ();
				
				if (! is_null ( $PlayTimes )) {
					foreach ( $PlayTimes as $PlayTimesItem ) {
						$PlayTimesArr = array ("ScheduleID" => $PlayTimesItem ['ScheduleID'], "WeekDay" => $PlayTimesItem ['WeekDay'], "TempFlag" => $PlayTimesItem ['TempFlag'] );
						
						if (! empty ( $newitem ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] )) {
							//说明这一天已经有任务了，需要复制一条数据添加
							$hasadd = false;
							
							for($i = 0; $i < count ( $newarr ); $i ++) {
								if (! isset ( $newarr [$i] ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] ) || is_null ( $newarr [$i] ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] )) {
									//直接添加
									$newarr [$i] ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] = $PlayTimesArr;
									
									$hasadd = true;
								}
							}
							if (! $hasadd) {
								//没有添加，需要复制一条记录
								$createitem = $newitem;
								
								for($i = 0; $i <= 6; $i ++) {
									$createitem ['Player_Weekday_' . $i] = null;
								}
								$createitem ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] = $PlayTimesArr;
								
								$newarr [count ( $newarr )] = $createitem;
							}
						} else {
							//这一天没有任务，可以添加
							$newitem ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] = $PlayTimesArr;
						}
					}
				}
				$newitem ["TempId"] = ($tempid ++);
				$newmodel [count ( $newmodel )] = $newitem;
				
				if (count ( $newarr ) > 0) {
					foreach ( $newarr as $newarritem ) {
						$newarritem ["TempId"] = ($tempid ++);
						$newmodel [count ( $newmodel )] = $newarritem;
					}
				}
			}
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $newmodel );
		}
	}
	
	/////////////////////////////////////////////////////////
	// 任务模板
	/////////////////////////////////////////////////////////
	/**
	 * 获取模板列表
	 */
	public function actionListTemplates() {
		
		$UserId = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserId ) && $UserId < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sql = "SELECT idTaskTemplate, IF (idTaskTemplate=0, '默认', TemplateName) AS TemplateName, IF(!ISNULL(b.InfoValue), 1, 0) AS Enabled FROM TaskTemplate a
			LEFT JOIN BaseInfo b ON a.idTaskTemplate=b.InfoValue AND InfomationID=257";
		
		if (! empty ( $DataParam ['SortName'] ) && ! empty ( $DataParam ['SortOrder'] )) {
			if (! empty ( $this->TemplateSortNameArr [strtolower ( $DataParam ['SortName'] )] ) && ! empty ( $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )] )) {
				$sql .= " ORDER BY " . $this->TemplateSortNameArr [strtolower ( $DataParam ['SortName'] )] . " " . $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )];
			}
		}
		
		$result = DBMethodUtils::listData ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $result );
	}
	
	/**
	 * 编辑模板
	 */
	public function actionEditTemplate() {
		
		$UserId = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserId ) && $UserId < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		//模板ID，如果是新建则不需要传值
		$TemplateID = null;
		
		if (isset ( $DataParam ['TemplateID'] )) {
			$TemplateID = $DataParam ['TemplateID'];
		}
		//模板名字
		$TemplateName = "";
		
		if (! isset ( $DataParam ['TemplateName'] ) || is_null ( $DataParam ['TemplateName'] ) || "" == trim ( $DataParam ['TemplateName'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$TemplateName = $DataParam ['TemplateName'];
		
		if (! is_null ( $TemplateID ) && is_numeric ( $TemplateID )) {
			//说明是修改模板
			$sql = 'Update TaskTemplate SET TemplateName=:TemplateName WHERE idTaskTemplate=:idTaskTemplate';
			
			if (DBMethodUtils::RunSql ( $sql, array (":TemplateName" => $TemplateName, ":idTaskTemplate" => $TemplateID ) ) > 0) {
				echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '修改模板成功', null );
			} else {
				echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '修改模板失败', null );
			}
		} else {
			//新建模板
			$TaskTemplate = new TaskTemplate ();
			$TaskTemplate->TemplateName = $TemplateName;
			$TaskTemplate->Enabled = 0;
			
			if ($TaskTemplate->save ()) {
				echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '新建模板成功', null );
				return;
			}
			
			echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '新建模板失败', null );
		}
	}
	
	/**
	 * 模板启用/停用
	 */
	public function actionTemplateEnabled() {
		
		$UserId = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserId ) && $UserId < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		if (! isset ( $DataParam ['TemplateID'] ) || ! isset ( $DataParam ['OpenFlag'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//模板ID
		$TemplateID = $DataParam ['TemplateID'];
		//开始或关闭标识，0：关闭，1：开启
		$OpenFlag = $DataParam ['OpenFlag'];
		
		$sql = "SELECT * FROM TaskTemplate WHERE idTaskTemplate=:idTaskTemplate";
		$TaskTemplate = DBMethodUtils::findData ( $sql, array (":idTaskTemplate" => $TemplateID ) );
		
		if (is_null ( $TaskTemplate )) {
			echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '模板不存在，请确认！', null );
			return;
		}
		if ($OpenFlag == 1) { //开启
			$sql = "UPDATE BaseInfo SET InfoValue=:InfoValue WHERE InfomationID=257";
			DBMethodUtils::RunSql ( $sql, array (":InfoValue" => $TaskTemplate ['idTaskTemplate'] ) );
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '启用模板成功', null );
		} else { //关闭模板
			$sql = "UPDATE BaseInfo SET InfoValue='-1' WHERE InfomationID=257 AND InfoValue=:InfoValue";
			DBMethodUtils::RunSql ( $sql, array (":InfoValue" => $TaskTemplate ['idTaskTemplate'] ) );
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '停用模板成功', null );
		}
	}
	
	/**
	 * 删除模板
	 */
	public function actionDeleteTemplate() {
		
		$UserId = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserId ) && $UserId < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		if (! isset ( $DataParam ['TemplateIDs'] ) || is_null ( $DataParam ['TemplateIDs'] ) || "" == trim ( $DataParam ['TemplateIDs'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//需要删除的模板ID，格式：1，2，3
		$TemplateIDs = implode ( ",", ToolUtil::getValidData ( $DataParam ['TemplateIDs'], ",", true ) );
		
		//查询出模板内的任务，然后删除任务
		$sql = "SELECT * FROM PlaySessions WHERE Template IN(" . implode ( ",", $TemplateIDs ) . ")";
		$Sessions = DBMethodUtils::listData ( $sql );
		
		$SessionIDs = "";
		if (! is_null ( $Sessions )) {
			foreach ( $Sessions as $item ) {
				$SessionIDs .= "," . $item ['SessionID'];
			}
			$SessionIDs = strlen ( $SessionIDs ) > 0 ? substr ( $SessionIDs, 1 ) : $SessionIDs;
		}
		TaskUtil::DeleteSessionByIDs ( $SessionIDs );
		
		//删除模板
		$sql = "DELETE FROM TaskTemplate WHERE idTaskTemplate IN(" . $TemplateIDs . ")";
		DBMethodUtils::RunSql ( $sql );
		
		//更新当前正在使用的模板
		$sql = "UPDATE BaseInfo SET InfoValue='-1' WHERE InfomationID=257 AND InfoValue IN(" . $TemplateIDs . ")";
		DBMethodUtils::RunSql ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '删除模板成功', null );
	}
	
	/////////////////////////////////////////////////////////
	//模式
	/////////////////////////////////////////////////////////
	/**
	 * 获取运行模式列表
	 */
	public function actionListRuningModeList() {
		
		$UserId = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserId ) && $UserId < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sql = 'SELECT * FROM BroadcastMode WHERE Enabled=1';
		
		if (! empty ( $DataParam ['SortName'] ) && ! empty ( $DataParam ['SortOrder'] )) {
			if (! empty ( $this->ModeSortNameArr [strtolower ( $DataParam ['SortName'] )] ) && ! empty ( $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )] )) {
				$sql .= " ORDER BY " . $this->ModeSortNameArr [strtolower ( $DataParam ['SortName'] )] . " " . $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )];
			}
		}
		
		$result = DBMethodUtils::listData ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $result );
	}
	
	/**
	 * 获取备用模式列表
	 */
	public function actionListReserveModeList() {
		
		$UserId = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserId ) && $UserId < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sql = 'SELECT * FROM BroadcastMode WHERE Enabled=0';
		
		if (! empty ( $DataParam ['SortName'] ) && ! empty ( $DataParam ['SortOrder'] )) {
			if (! empty ( $this->ModeSortNameArr [strtolower ( $DataParam ['SortName'] )] ) && ! empty ( $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )] )) {
				$sql .= " ORDER BY " . $this->ModeSortNameArr [strtolower ( $DataParam ['SortName'] )] . " " . $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )];
			}
		}
		$result = DBMethodUtils::listData ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $result );
	}
	
	/**
	 * 获取运行模式任务
	 */
	public function actionListRuningBroadcastmodes() {
		
		$UserId = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserId ) && $UserId < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//模式ID
		$ModeID = - 1;
		
		if (isset ( $DataParam ['ModeID'] )) {
			$ModeID = $DataParam ['ModeID'];
			
			if (! is_numeric ( $ModeID )) {
				$ModeID = - 1;
			}
		}
		//任务类型筛选,0:控制任务，1：广播任务，2：都选，3：都不选
		$StreamType = null;
		
		if (isset ( $DataParam ['SelectStreamType'] )) {
			$StreamType = $DataParam ['SelectStreamType'];
		}
		//排序
		$SortName = '';
		$SortOrder = '';
		
		if (isset ( $DataParam ['SortName'] ) && isset ( $DataParam ['SortOrder'] ) && ! empty ( $DataParam ['SortName'] ) && ! empty ( $DataParam ['SortOrder'] )) {
			$SortOrder = $DataParam ['SortOrder'];
			
			if (isset ( $this->SessionSortNameArr [strtolower ( $DataParam ['SortName'] )] )) {
				$SortName = $this->SessionSortNameArr [strtolower ( $DataParam ['SortName'] )];
			}
			
			if (isset ( $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )] )) {
				$SortOrder = $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )];
			}
		}
		//分页数据
		$page = "";
		
		if (isset ( $DataParam ['Start'] ) && isset ( $DataParam ['Size'] )) {
			$start = $DataParam ['Start'];
			$size = $DataParam ['Size'];
			
			if (is_numeric ( $start ) && is_numeric ( $size ) && $start >= 0 && $size > 0) {
				$page = " LIMIT " . $start . "," . $size;
			}
		}
		
		$result = TaskUtil::LoadModeTask ( 1, $ModeID, $page, $UserId, $StreamType, $SortName, $SortOrder );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $result );
	}
	
	/**
	 * 获取备用模式任务
	 */
	public function actionListReserveBroadcastmodes() {
		
		$UserId = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserId ) && $UserId < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		//模式ID
		$ModeID = - 1;
		
		if (isset ( $DataParam ['ModeID'] )) {
			$ModeID = $DataParam ['ModeID'];
			
			if (! is_numeric ( $ModeID )) {
				$ModeID = - 1;
			}
		}
		//任务类型筛选,0:控制任务，1：广播任务，2：都选，3：都不选
		$StreamType = null;
		
		if (isset ( $DataParam ['SelectStreamType'] )) {
			$StreamType = $DataParam ['SelectStreamType'];
		}
		//排序
		$SortName = '';
		$SortOrder = '';
		
		if (isset ( $DataParam ['SortName'] ) && isset ( $DataParam ['SortOrder'] ) && ! empty ( $DataParam ['SortName'] ) && ! empty ( $DataParam ['SortOrder'] )) {
			$SortOrder = $DataParam ['SortOrder'];
			
			if (isset ( $this->SessionSortNameArr [strtolower ( $DataParam ['SortName'] )] )) {
				$SortName = $this->SessionSortNameArr [strtolower ( $DataParam ['SortName'] )];
			}
			
			if (isset ( $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )] )) {
				$SortOrder = $this->SortOrderArr [strtolower ( $DataParam ['SortOrder'] )];
			}
		}
		//分页数据
		$page = "";
		
		if (isset ( $DataParam ['Start'] ) && isset ( $DataParam ['Size'] )) {
			$start = $DataParam ['Start'];
			$size = $DataParam ['Size'];
			
			if (is_numeric ( $start ) && is_numeric ( $size ) && $start >= 0 && $size > 0) {
				$page = " LIMIT " . $start . "," . $size;
			}
		}
		
		$result = TaskUtil::LoadModeTask ( 0, $ModeID, $page, $UserId, $StreamType, $SortName, $SortOrder );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $result );
	}
	
	/**
	 * 编辑模式（增加或修改）
	 */
	public function actionEditBroadcastmode() {
		
		/*
		 {
		 "idBroadcastMode":"广播模式ID",
		 "ModeName":"模式名",
		 "Priority":"优先级，默认是10",
		 "Enabled":"可用状态，默认是0不可用（备用模式），1可用（运行模式）。",
		 "StartTime":"开始时间,2015-10-28 18:00:00",
		 "StopTime":"结束时间,2015-11-28 18:00:00",
		 "TimeStyle":"时间类型，0的意思是通过开始时间和结束时间来代替一天的开始和结束（StartTime，StopTime使用年月日时分秒），另外的意思是周期性的，8位字节的低7位来代表一周7天，bit1星期一，bit2星期二，bit7表示星期天，以此类推（StartTime，StopTime仅使用时分秒）。默认是0仅一天",
		 "BrdModeMember":[
		 {
		 "DeviceID":"设备id（字符串）"
		 },
		 {
		 "DeviceID":"设备id（字符串）"
		 }
		 ]
		 }
		 */
		$UserId = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserId ) && $UserId < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		
		if (! isset ( $_POST ['DataParam'] ) || is_null ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam ) || ! isset ( $DataParam ['idBroadcastMode'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$idBroadcastMode = $DataParam ['idBroadcastMode'];
		$new = false;
		
		if (is_numeric ( $idBroadcastMode ) && $idBroadcastMode > 0) {
			//修改模式
			$new = false;
			
			$UpdateParam = array ();
			$UpdateParam ["ModeName"] = $DataParam ["ModeName"]; //模式名",
			

			$UpdateParam ["Priority"] = $DataParam ["Priority"]; //优先级，默认是10",
			$UpdateParam ["Enabled"] = $DataParam ["Enabled"]; //可用状态，默认是0不可用（备用模式），1可用（运行模式）。",
			$UpdateParam ["StartTime"] = $DataParam ["StartTime"]; //开始时间,2015-10-28 18:00:00",
			$UpdateParam ["StopTime"] = $DataParam ["StopTime"]; //结束时间,2015-11-28 18:00:00",
			$UpdateParam ["TimeStyle"] = $DataParam ["TimeStyle"]; //时间类型，0的意思是通过开始时间和结束时间来代替一天的开始和结束（StartTime，StopTime使用年月日时分秒），另外的意思是周期性的，8位字节的低7位来代表一周7天，bit1星期一，bit2星期二，bit7表示星期天，以此类推（StartTime，StopTime仅使用时分秒）。默认是0仅一天",
			

			BroadcastMode::model ()->updateByPk ( $idBroadcastMode, $UpdateParam );
		} else {
			//新建模式
			$new = true;
			
			$BroadcastMode = new BroadcastMode ();
			
			$BroadcastMode->ModeName = $DataParam ["ModeName"]; //模式名",
			$BroadcastMode->Priority = $DataParam ["Priority"]; //优先级，默认是10",
			$BroadcastMode->Enabled = $DataParam ["Enabled"]; //可用状态，默认是0不可用（备用模式），1可用（运行模式）。",
			$BroadcastMode->StartTime = $DataParam ["StartTime"]; //开始时间,2015-10-28 18:00:00",
			$BroadcastMode->StopTime = $DataParam ["StopTime"]; //结束时间,2015-11-28 18:00:00",
			$BroadcastMode->TimeStyle = $DataParam ["TimeStyle"]; //时间类型，0的意思是通过开始时间和结束时间来代替一天的开始和结束（StartTime，StopTime使用年月日时分秒），另外的意思是周期性的，8位字节的低7位来代表一周7天，bit1星期一，bit2星期二，bit7表示星期天，以此类推（StartTime，StopTime仅使用时分秒）。默认是0仅一天",
			

			if (! $BroadcastMode->save ()) {
				
				echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '新建模式失败', null );
				return;
			}
			$idBroadcastMode = $BroadcastMode ['idBroadcastMode'];
		}
		//处理模式成员
		if (isset ( $DataParam ['BrdModeMember'] ) && ! is_null ( $DataParam ['BrdModeMember'] )) {
			$BrdModeMember = $DataParam ['BrdModeMember'];
			$UseDevIDs = "";
			
			foreach ( $BrdModeMember as $item ) {
				if (isset ( $item ['DeviceID'] )) {
					$UseDevIDs .= "," . $item ['DeviceID'];
				}
			}
			$UseDevIDs = strlen ( $UseDevIDs ) > 0 ? substr ( $UseDevIDs, 1 ) : $UseDevIDs;
			
			if (strlen ( $UseDevIDs ) > 0) {
				//删除不用的成员
				$sql = "DELETE FROM BrdModeMember WHERE BrdModeID=:BrdModeID AND DeviceID NOT IN(" . $UseDevIDs . ")";
				DBMethodUtils::RunSql ( $sql, array (":BrdModeID" => $idBroadcastMode ) );
			} else {
				$sql = "DELETE FROM BrdModeMember WHERE BrdModeID=:BrdModeID";
				DBMethodUtils::RunSql ( $sql, array (":BrdModeID" => $idBroadcastMode ) );
			}
			//查找已经拥有的成员
			$sql = "SELECT * FROM BrdModeMember WHERE BrdModeID=:BrdModeID";
			$DBDevices = DBMethodUtils::listData ( $sql, array (":BrdModeID" => $idBroadcastMode ) );
			
			$existMem = array ();
			
			if (! is_null ( $DBDevices ) && count ( $DBDevices ) > 0) {
				foreach ( $DBDevices as $item ) {
					$existMem [$item ['DeviceID']] = $item ['DeviceID'];
				}
			}
			foreach ( $BrdModeMember as $item ) {
				//添加接收成员
				if (isset ( $existMem [$item ['DeviceID']] ) && ! is_null ( $existMem [$item ['DeviceID']] )) {
					continue;
				}
				$BrdModeMember = new BrdModeMember ();
				$BrdModeMember->DeviceID = $item ['DeviceID'];
				$BrdModeMember->BrdModeID = $idBroadcastMode;
				
				$BrdModeMember->save ();
			}
		} else {
			//删除模式的所有成员
			$sql = "DELETE FROM BrdModeMember WHERE BrdModeID=:BrdModeID";
			DBMethodUtils::RunSql ( $sql, array (":BrdModeID" => $idBroadcastMode ) );
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, ($new ? '新建' : '修改') . '模式成功', null );
	}
	
	/**
	 * 删除模式
	 */
	public function actionDeleteBroadcastmode() {
		
		$UserId = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserId ) && $UserId < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		if (! isset ( $DataParam ['idBroadcastModes'] ) || is_null ( $DataParam ['idBroadcastModes'] ) || "" == trim ( $DataParam ['idBroadcastModes'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//模式id，格式：1，2，3
		$idBroadcastModes = implode ( ",", ToolUtil::getValidData ( $DataParam ['idBroadcastModes'], ",", true ) );
		
		//查询出模式内的任务，然后删除任务
		$sql = "SELECT * FROM PlaySessions WHERE BrdMode IN(" . $idBroadcastModes . ")";
		$Sessions = DBMethodUtils::listData ( $sql );
		
		$SessionIDs = "";
		if (! is_null ( $Sessions )) {
			foreach ( $Sessions as $item ) {
				$SessionIDs .= "," . $item ['SessionID'];
			}
			$SessionIDs = strlen ( $SessionIDs ) > 0 ? substr ( $SessionIDs, 1 ) : $SessionIDs;
		}
		TaskUtil::DeleteSessionByIDs ( $SessionIDs );
		
		//删除模式成员
		$sql = "DELETE FROM BrdModeMember WHERE BrdModeID IN(" . $idBroadcastModes . ")";
		DBMethodUtils::RunSql ( $sql );
		
		//删除模式
		$sql = "DELETE FROM BroadcastMode WHERE idBroadcastMode IN(" . $idBroadcastModes . ")";
		DBMethodUtils::RunSql ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '删除模式成功', null );
	}
	
	/**
	 * 模式手动开始/手动停止
	 */
	public function actionBroadcastmodeOnOrOff() {
		
		$UserId = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserId ) && $UserId < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		//管理员可手动启动或者停止模式的运行；
		if (! isset ( $DataParam ['idBroadcastModes'] ) || is_null ( $DataParam ['idBroadcastModes'] ) || trim ( $DataParam ['idBroadcastModes'] ) == '') {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//模式id，格式：1，2，3
		$idBroadcastModes = implode ( ",", ToolUtil::getValidData ( $DataParam ['idBroadcastModes'], ",", true ) );
		
		if (! isset ( $DataParam ['Active'] ) || ! is_numeric ( $DataParam ['Active'] ) || ($DataParam ['Active'] != 0 && $DataParam ['Active'] != 1)) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//开始/停止标识，1：开始，0：停止
		$Active = $DataParam ['Active'];
		$Active = $Active == 0 ? 0 : 1;
		
		//更新模式状态
		$sql = "UPDATE BroadcastMode SET Active='" . $Active . "' WHERE idBroadcastMode IN(" . $idBroadcastModes . ")";
		DBMethodUtils::RunSql ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, ($Active == 0 ? '手动停止' : '手动开始') . '参数异常', null );
	}
	
	/**
	 * 模式启用/停用
	 */
	public function actionBroadcastmodeEnabled() {
		
		$UserId = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserId ) && $UserId < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		if (! isset ( $DataParam ['idBroadcastModes'] ) || is_null ( $DataParam ['idBroadcastModes'] ) || "" == trim ( $DataParam ['idBroadcastModes'] ) || ($DataParam ['Enabled'] != 0 && $DataParam ['Enabled'] != 1)) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//模式id，格式：1，2，3
		$idBroadcastModes = implode ( ",", ToolUtil::getValidData ( $DataParam ['idBroadcastModes'], ",", true ) );
		
		if (! isset ( $DataParam ['Enabled'] ) || ! is_numeric ( $DataParam ['Enabled'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//启用/停用标识，1：启用，0：停用
		$Enabled = $DataParam ['Enabled'];
		$Enabled = $Enabled == 0 ? 0 : 1;
		
		//更新模式状态
		$sql = "UPDATE BroadcastMode SET Enabled='" . $Enabled . "' WHERE idBroadcastMode IN(" . $idBroadcastModes . ")";
		DBMethodUtils::RunSql ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, ($Enabled == 0 ? '停用' : '启用') . '参数异常', null );
	}
	
	/**
	 * 粘贴任务模式
	 */
	public function actionPasteSessionMode() {
		
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		if (! isset ( $DataParam ['OldModeIDs'] ) || is_null ( $DataParam ['OldModeIDs'] ) || trim ( $DataParam ['OldModeIDs'] ) == '') {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		if (! isset ( $DataParam ['Enable'] ) || ! is_numeric ( $DataParam ['Enable'] ) || $DataParam ['Enable'] != 0 && $DataParam ['Enable'] != 1) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//拆分模式ID
		$arr = explode ( ',', $DataParam ['OldModeIDs'] );
		
		if (is_null ( $arr ) || count ( $arr ) <= 0) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		foreach ( $arr as $item ) {
			if (! is_numeric ( $item )) {
				continue;
			}
			try {
				//粘贴模式
				$sql = 'call sp_copy_mode(' . $item . ', ' . ($DataParam ['Enable'] == 1 ? 'true' : 'false') . ')';
				DBMethodUtils::RunSql ( $sql );
			} catch ( Exception $e ) {
			
			}
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '模式粘贴成功', null );
		return;
	}
	/////////////////////////////////////////////////////////
	//手动任务
	/////////////////////////////////////////////////////////
	/**
	 * 获取手动任务
	 */
	public function actionListManualTasks() {
		
		$UserId = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserId ) && $UserId < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sql = "SELECT a.SessionID AS TempId, a.SessionID, a.SessionName, a.SessionType, a.Priority, a.CircleLength, a.StreamType, c.FileName, 
				b.CurrFileProgress, b.CurrTotalProgress, dd.Pause, IF(ISNULL(pl.PlayListCount), 0, pl.PlayListCount) AS PlayListCount
				
		      FROM PlaySessions a LEFT JOIN PlayingSessions b ON a.SessionID=b.SessionID LEFT JOIN MediaFiles c ON b.PlayingFileID=c.MediaID
			 LEFT JOIN PlayingSessions dd ON a.SessionID=dd.SessionID 
			 LEFT JOIN (SELECT COUNT(*) AS PlayListCount, SessionID FROM PlayListFiles GROUP BY SessionID) pl ON a.SessionID=pl.SessionID WHERE a.SessionType IN(2,9)";
		
		//排序
		if (isset ( $DataParam ['SortName'] ) && isset ( $DataParam ['SortOrder'] )) {
			$SortName = $DataParam ['SortName'];
			$SortOrder = $DataParam ['SortOrder'];
			
			if (! empty ( $this->SessionSortNameArr [strtolower ( $SortName )] ) && ! empty ( $this->SortOrderArr [strtolower ( $SortOrder )] )) {
				$sql .= " ORDER BY " . $this->SessionSortNameArr [strtolower ( $SortName )] . " " . $this->SortOrderArr [strtolower ( $SortOrder )];
			}
		}
		
		//分页数据
		if (isset ( $DataParam ['Start'] ) && isset ( $DataParam ['Size'] )) {
			$start = $DataParam ['Start'];
			$size = $DataParam ['Size'];
			
			if (is_numeric ( $start ) && is_numeric ( $size ) && $start >= 0 && $size > 0) {
				$sql = $sql . " LIMIT " . $start . "," . $size;
			}
		}
		$result = DBMethodUtils::listData ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $result );
	}
	
	/////////////////////////////////////////////////////////
	//实时采播
	/////////////////////////////////////////////////////////
	/**
	 * 获取实时采播
	 */
	public function actionListRealTimeMining() {
		
		$UserId = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserId ) && $UserId < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sql = "SELECT a.SessionID, b.User_Desc as SessionName, a.SessionType, a.Priority, a.CircleLength
			FROM PlaySessions a LEFT JOIN Users b ON a.PlayerID = b.UsbKey WHERE SessionType IN(1)";
		
		//排序
		if (isset ( $DataParam ['SortName'] ) && isset ( $DataParam ['SortOrder'] )) {
			$SortName = $DataParam ['SortName'];
			$SortOrder = $DataParam ['SortOrder'];
			
			if (! empty ( $this->SessionSortNameArr [strtolower ( $SortName )] ) && ! empty ( $this->SortOrderArr [strtolower ( $SortOrder )] )) {
				$sql .= " ORDER BY " . $this->SessionSortNameArr [strtolower ( $SortName )] . " " . $this->SortOrderArr [strtolower ( $SortOrder )];
			}
		}
		
		//分页数据
		if (isset ( $DataParam ['Start'] ) && isset ( $DataParam ['Size'] )) {
			$start = $DataParam ['Start'];
			$size = $DataParam ['Size'];
			
			if (is_numeric ( $start ) && is_numeric ( $size ) && $start >= 0 && $size > 0) {
				$sql = $sql . " LIMIT " . $start . "," . $size;
			}
		}
		$result = DBMethodUtils::listData ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $result );
	}
	
	///////////////////////////////////////////////
	public function actionTaskInfo() {
		
		$taskInfo = array ();
		
		//基本信息
		$baseInfo = array ();
		//任务id
		$baseInfo ['SessionID'] = "任务ID,如果是新建则为空字符串";
		//任务名称
		$baseInfo ['SessionName'] = "任务名字";
		//任务类型,0: 自动广播或控制任务；1：由PC呼叫台或者音频广播站创建的任务；2：手动广播任务
		$baseInfo ['SessionType'] = "0: 自动广播或控制任务；1：由PC呼叫台或者音频广播站创建的任务；2：手动广播任务";
		//优先级
		$baseInfo ['Priority'] = "优先级（整数）";
		
		//强制接收标识(StreamType高4为来判断，最高位：1：强制，0：不强制)
		$baseInfo ['SteamTypeUp'] = "强制接收，1：强制，0：不强制";
		//00控制任务，01音频，10视屏，11音视频，一般用11来表示视频。(StreamType低4为来判断)
		$baseInfo ['SteamTypeDown'] = "0控制任务，1音频，2视屏，3音视频，一般用3来表示视频";
		$taskInfo ['BaseInfo'] = $baseInfo;
		
		//模式(不是模式任务则不需要传递这个值，也可以传空)
		$mode = array ();
		$mode ['BrdMode'] = "是否广播模式任务，>0广播模式ID 是模式任务，null表示非模式任务";
		$mode ['MemmberMode'] = "默认为0,是否使用模式成员，1使用模式成员，0不使用";
		$taskInfo ['Mode'] = $mode;
		
		//广播任务（不是广播任务则不需要传递这个值，也可以传空）
		$Brodcast = array ();
		//音量调节
		$Brodcast ['AudioGain'] = "音频增益，单个任务的音量调节。";
		//播放时间，秒
		$Brodcast ['CircleLength'] = "默认为0，播放时长；秒";
		//播放列表
		$Brodcast ['PlayFileList'] = array (array ('FileID' => "文件ID（整数）" ), array ('FileID' => "文件ID（整数）" ) );
		$taskInfo ['Brodcast'] = $Brodcast;
		
		//控制任务（不是制任务则不需要传递这个值，也可以传空）
		$DeviceCtrl = array ();
		//设备控制，系统启禁用状态，1启用，0禁用，仅控制任务才使用这个字段，null为没有控制
		$DeviceCtrl ['SysEnabled'] = "设备控制，系统启禁用状态，1启用，0禁用，仅控制任务才使用这个字段，null为没有控制";
		//扩展电源,没有控制则传空
		$DeviceCtrl ['RfDevCtrl'] = array (array ("PwrID" => "扩展设备ID", "Mode" => "模式：0：关闭电源；电源：1：打开电源，4：本地模式，其他无效；空调：1~4对应空调4种模式" ) );
		$taskInfo ['DeviceCtrl'] = $DeviceCtrl;
		
		//接收成员(模式，如果选择了模式成员，则可以不传值)
		$taskInfo ['SessionDevice'] = array (array ('DeviceID' => "设备id（字符串）" ), array ('DeviceID' => "设备id（字符串）" ) );
		
		//执行时间（手动任务可以不用传值）
		$taskInfo ['PlayTime'] = array (array ('ScheduleID' => '执行时间ID（整数）', 'WeekDay' => "星期编号，0：星期一，6：星期天", 'PlayTime' => "播出时间，仅时分秒，如：12:10:00", 'TempFlag' => '是否临时任务，1临时任务，0非临时任务，2暂停，临时任务按照指定的时间执行一次完就删除这条记录', 'Pause' => '0 :停止, 1:播放，2：暂停' ) );
		
		echo CJSON::encode ( $taskInfo );
	}
	
	public function actionBroadcastmodeInfo() {
		
		$mode = array ();
		$mode ['idBroadcastMode'] = '广播模式ID';
		$mode ['ModeName'] = '模式名';
		$mode ['Priority'] = '优先级，默认是10';
		$mode ['Enabled'] = '可用状态，默认是0不可用（备用模式），1可用（运行模式）。';
		$mode ['StartTime'] = '开始时间,2015-10-28 18:00:00';
		$mode ['StopTime'] = '结束时间,2015-11-28 18:00:00';
		$mode ['TimeStyle'] = '时间类型，0的意思是通过开始时间和结束时间来代替一天的开始和结束（StartTime，StopTime使用年月日时分秒），另外的意思是周期性的，8位字节的低7位来代表一周7天，bit1星期一，bit2星期二，bit7表示星期天，以此类推（StartTime，StopTime仅使用时分秒）。默认是0仅一天';
		
		//模式成员
		$mode ['BrdModeMember'] = array (array ('DeviceID' => "设备id（字符串）" ), array ('DeviceID' => "设备id（字符串）" ) );
		
		echo CJSON::encode ( $mode );
	}
	
	public function actionSessionBroadcastOptInfo() {
		
		$mode = array ();
		$mode [count ( $mode )] = array ('SessionID' => '任务ID', 'ScheduleID' => '播出时间ID' );
		
		echo CJSON::encode ( $mode );
	}
	
	//////////////////////////////////////////////////////////////////
	// WEB
	//////////////////////////////////////////////////////////////////
	/**
	 * 获取定时任务列表
	 */
	public function actionListTimeTasksForWeb() {
		
		$UserId = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserId ) && $UserId < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sql = "SELECT a.SessionID, a.ScheduleID, DATE_FORMAT(a.PlayTime,'%H:%i:%S') as PlayTime, b.CircleLength, a.TempFlag,
			IF(" . (is_null ( $UserId ) ? 0 : $UserId) . " <= 0, IF((ISNULL(uu.User_Name) OR LENGTH(uu.User_Name) < 1), b.SessionName, CONCAT(uu.User_Name, ':',b.SessionName)), b.SessionName) SessionName
			, b.SessionType, b.Priority, b.StreamType, b.SysEnabled, b.RfDevCtrl, dd.Pause,mf.FileName, IF(ISNULL(pl.PlayListCount), 0, pl.PlayListCount) AS PlayListCount 
			FROM PlaySessionTime a LEFT JOIN PlaySessions b ON a.SessionID=b.SessionID 
			LEFT JOIN PlayingSessions dd ON a.SessionID=dd.SessionID AND a.ScheduleID=dd.ScheduleID LEFT JOIN PlayingSessions ps ON a.SessionID=ps.SessionID 
			LEFT JOIN MediaFiles mf ON ps.PlayingFileID=mf.MediaID LEFT JOIN Users uu ON b.Owner=uu.User_ID
			LEFT JOIN (SELECT COUNT(*) AS PlayListCount, SessionID FROM PlayListFiles GROUP BY SessionID) pl ON a.SessionID=pl.SessionID
			WHERE SessionType IN (0,8)";
		
		//任务类型筛选,0:控制任务，1：广播任务，2：都选，3：都不选
		if (isset ( $DataParam ['SelectStreamType'] ) && is_numeric ( $DataParam ['SelectStreamType'] )) {
			
			switch ($DataParam ['SelectStreamType']) {
				case 0 : //控制任务
					$sql = $sql . " AND b.StreamType&7 = 0";
					break;
				case 1 : //广播任务
					$sql = $sql . " AND b.StreamType&7 != 0";
					break;
				case 2 : //所有任务
					break;
				case 3 : //都不选
					$sql = $sql . " AND b.StreamType&7 = -1";
					break;
				default :
					break;
			}
		}
		$OwnerWhere = array ();
		
		if ($UserId > 0) { //非最高权限管理员
			$OwnerWhere [] = " b.Owner = '" . $UserId . "'";
		}
		$Owner = - 1;
		
		if (isset ( $DataParam ['Owner'] ) && is_numeric ( $DataParam ['Owner'] )) { //按照任务所属人筛选
			$Owner = $DataParam ['Owner'];
		}
		
		//任务创建者的id
		if (! is_null ( $Owner ) && $Owner > 0) {
			$OwnerWhere [] = " b.Owner = '" . $UserId . "'";
		}
		if (! empty ( $OwnerWhere )) {
			$sql .= ' AND (' . implode ( ' OR ', $OwnerWhere ) . ')';
		}
		//按照星期筛选
		$byweekday = false;
		
		if (isset ( $DataParam ['WeekDay'] )) {
			$WeekDay = $DataParam ['WeekDay'];
			
			if (is_numeric ( $WeekDay )) {
				$sql = $sql . " AND WeekDay = '" . $WeekDay . "'";
				$byweekday = true;
			}
		}
		if (is_null ( $UserId )) { //TODO 需要考虑是否需要模板
			//按照模板筛选(定时任务不需要传递这个值)
			if (isset ( $DataParam ['Template'] ) && is_numeric ( $DataParam ['Template'] )) {
				$sql .= " and Template='" . $DataParam ['Template'] . "'";
			} else {
				$sql .= " and Template=(SELECT InfoValue FROM BaseInfo WHERE InfomationID=257)";
			}
		}
		$ParamArr = array ();
		
		//搜索关键字,按照名字搜索
		if (isset ( $DataParam ['SearchKey'] ) && "" != trim ( $DataParam ['SearchKey'] )) {
			$sql .= " AND SessionName like CONCAT('%', :SearchKey, '%')";
			$ParamArr [':SearchKey'] = $DataParam ['SearchKey'];
		}
		$sql = $sql . " GROUP BY a.SessionID,DATE_FORMAT(a.PlayTime,'%H:%i:%S')";
		
		//获取总数
		$Count = 0;
		$CountSql = 'SELECT COUNT(*) c FROM (' . $sql . ') CC';
		$TempData = DBMethodUtils::findData ( $CountSql, $ParamArr );
		
		if (! empty ( $TempData )) {
			$Count = $TempData ['c'];
		}
		
		//排序
		$SortFlag = false;
		
		if (! empty ( $_POST ['sort'] ) && ! empty ( $_POST ['order'] )) {
			$Sort = $_POST ['sort'];
			$Order = $_POST ['order'];
			
			//可排序的字段
			$SortCol = array ("PlayTime", "SessionName", "Priority", "SysEnabled" );
			
			//			if ($Sort == "text") {
			//				$Sort = "Dev_Name";
			//			} else if ($Sort == "State_Online") {
			//				$Sort = "State_SysPower";
			//			} else 
			if (! in_array ( $Sort, $SortCol )) {
				$Sssql = "SELECT * FROM PwrDisplaySet WHERE Name='" . $Sort . "'";
				$tempdata = DBMethodUtils::findData ( $Sssql );
				
				if (! empty ( $tempdata )) {
					$Sort = "RfDevCtrl";
				}
			}
			$SortCol [] = "RfDevCtrl";
			
			if (in_array ( strtolower ( $Order ), array ('asc', 'desc' ) ) && in_array ( $Sort, $SortCol )) {
				$sql .= " ORDER BY " . $Sort . " " . $Order;
				$SortFlag = true;
			}
		}
		
		if (! $SortFlag) {
			$sql .= " ORDER BY PlayTime ASC";
		}
		
		//		//排序
		//		if (isset ( $DataParam ['SortName'] ) && isset ( $DataParam ['SortOrder'] )) {
		//			$SortName = $DataParam ['SortName'];
		//			$SortOrder = $DataParam ['SortOrder'];
		//			
		//			if (! empty ( $this->SessionSortNameArr [strtolower ( $SortName )] ) && ! empty ( $this->SortOrderArr [strtolower ( $SortOrder )] )) {
		//				$sql .= " ORDER BY " . $this->SessionSortNameArr [strtolower ( $SortName )] . " " . $this->SortOrderArr [strtolower ( $SortOrder )];
		//			} else {
		//				$sql .= " ORDER BY PlayTime ASC";
		//			}
		//		} else {
		//			$sql .= " ORDER BY PlayTime ASC";
		//		}
		//分页数据
		if (isset ( $_POST ['page'] ) && isset ( $_POST ['rows'] ) && is_numeric ( $_POST ['page'] ) && is_numeric ( $_POST ['rows'] )) {
			$page = $_POST ['page'];
			$size = $_POST ['rows'];
			$start = ($page - 1) * $size;
			$sql = $sql . " LIMIT " . $start . "," . $size;
		}
		//		
		//		//分页数据
		//		if (isset ( $DataParam ['Start'] ) && isset ( $DataParam ['Size'] )) {
		//			$start = $DataParam ['Start'];
		//			$size = $DataParam ['Size'];
		//			
		//			if (is_numeric ( $start ) && is_numeric ( $size ) && $start >= 0 && $size > 0) {
		//				$sql = $sql . " LIMIT " . $start . "," . $size;
		//			}
		//		}
		$result = DBMethodUtils::listData ( $sql, $ParamArr );
		
		if (is_null ( $result ) || count ( $result ) <= 0) {
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', array () );
			return;
		}
		if ($byweekday) {
			//筛选的是一周的某一天
			$newmodel = array ();
			$tempid = 1;
			
			foreach ( $result as $item ) {
				$newitem = array ();
				$newitem ["TempId"] = ($tempid ++);
				$newitem ["SessionID"] = $item ["SessionID"]; //	默认为0，主键ID
				$newitem ["SessionName"] = $item ["SessionName"]; //任务名称
				$newitem ["SessionType"] = $item ["SessionType"]; //	0: 自动广播或控制任务；1：由PC呼叫台或者音频广播站创建的任务；2：手动广播任务
				$newitem ["Priority"] = $item ["Priority"]; //	优先级
				$newitem ["ScheduleID"] = $item ["ScheduleID"];
				$newitem ["PlayTime"] = $item ["PlayTime"]; //任务指定的播放时间，仅使用时分秒
				$newitem ['SteamTypeDown'] = $item ['StreamType'] - round ( $item ['StreamType'] / 128 ) * 128; //00控制任务，01音频，10视屏，11音视频，一般用11来表示视频。(StreamType低4为来判断)
				$newitem ["TempFlag"] = $item ["TempFlag"]; //是否临时任务，1临时任务，0非临时任务，2暂停，临时任务按照指定的时间执行一次完就删除这条记录
				$newitem ["Pause"] = $item ["Pause"]; //播出状态（仅广播才有），1暂停，0正在播放,null:没有播出状态
				$newitem ["FileName"] = $item ["FileName"]; //正在播放的文件的名字
				$newitem ["PlayListCount"] = $item ["PlayListCount"]; //播放文件数目
				

				if ($newitem ['SteamTypeDown'] == 0) {
					//控制任务需要获取设备状态
					//设备控制，系统启禁用状态，1启用，0禁用，仅控制任务才使用这个字段，null为没有控制
					$newitem ['SysEnabled'] = $item ['SysEnabled'];
					//扩展电源
					if (! is_null ( $item ['RfDevCtrl'] )) {
						//扩展设备信息
						$expandSource = ExpandUtil::LoadExpandDev ();
						//扩展设备模式
						$expandMode = ExpandUtil::LoadExpandMode ();
						
						$DeviceCtrl = DeviceUtil::DepackRfDevCtrl ( $expandSource, $item ['RfDevCtrl'], $expandMode );
						
						$newitem ['DeviceCtrl'] = $DeviceCtrl;
					}
				}
				$newmodel [count ( $newmodel )] = $newitem;
			}
			//获取总数
			$Out = array ('Total' => $Count, 'Rows' => $newmodel );
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $Out );
		} else { //查看的是一周的全部
			$newmodel = array ();
			$tempid = 1;
			
			foreach ( $result as $item ) {
				$newitem = array ();
				
				$newitem ["SessionID"] = $item ["SessionID"]; //	默认为0，主键ID
				$newitem ["SessionName"] = $item ["SessionName"]; //任务名称
				$newitem ["SessionType"] = $item ["SessionType"]; //	0: 自动广播或控制任务；1：由PC呼叫台或者音频广播站创建的任务；2：手动广播任务
				$newitem ["Priority"] = $item ["Priority"]; //	优先级
				$newitem ["PlayTime"] = $item ["PlayTime"]; //任务指定的播放时间，仅使用时分秒
				$newitem ['SteamTypeDown'] = $item ['StreamType'] - round ( $item ['StreamType'] / 128 ) * 128; //00控制任务，01音频，10视屏，11音视频，一般用11来表示视频。(StreamType低4为来判断)
				//				$newitem ["TempFlag"] = $item ["TempFlag"]; //是否临时任务，1临时任务，0非临时任务，2暂停，临时任务按照指定的时间执行一次完就删除这条记录
				$newitem ["PlayListCount"] = $item ["PlayListCount"]; //播放文件数目
				

				//获取播放时间
				for($i = 0; $i <= 6; $i ++) {
					$newitem ['Player_Weekday_' . $i] = null;
				}
				$sql = "SELECT ScheduleID, SessionID,WeekDay,TempFlag, DATE_FORMAT(PlayTime,'%H:%i:%S') as PlayTime FROM PlaySessionTime
				WHERE SessionID='" . $item ['SessionID'] . "' AND DATE_FORMAT(PlayTime,'%H:%i:%S')='" . $item ["PlayTime"] . "'";
				$PlayTimes = DBMethodUtils::listData ( $sql );
				
				//新建的一行，key1：周数，value：
				$newarr = array ();
				
				if (! is_null ( $PlayTimes )) {
					foreach ( $PlayTimes as $PlayTimesItem ) {
						$PlayTimesArr = array ("ScheduleID" => $PlayTimesItem ['ScheduleID'], "WeekDay" => $PlayTimesItem ['WeekDay'], "TempFlag" => $PlayTimesItem ['TempFlag'] );
						
						if (! empty ( $newitem ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] )) {
							//说明这一天已经有任务了，需要复制一条数据添加
							$hasadd = false;
							
							for($i = 0; $i < count ( $newarr ); $i ++) {
								if (! isset ( $newarr [$i] ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] ) || is_null ( $newarr [$i] ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] )) {
									//直接添加
									$newarr [$i] ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] = $PlayTimesArr;
									
									$hasadd = true;
								}
							}
							if (! $hasadd) {
								//没有添加，需要复制一条记录
								$createitem = $newitem;
								
								for($i = 0; $i <= 6; $i ++) {
									$createitem ['Player_Weekday_' . $i] = null;
								}
								$createitem ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] = $PlayTimesArr;
								
								$newarr [count ( $newarr )] = $createitem;
							}
						} else {
							//这一天没有任务，可以添加
							$newitem ['Player_Weekday_' . $PlayTimesItem ['WeekDay']] = $PlayTimesArr;
						}
					}
				}
				$newitem ["TempId"] = ($tempid ++);
				$newmodel [count ( $newmodel )] = $newitem;
				
				if (count ( $newarr ) > 0) {
					foreach ( $newarr as $newarritem ) {
						$newarritem ["TempId"] = ($tempid ++);
						$newmodel [count ( $newmodel )] = $newarritem;
					}
				}
			}
			//获取总数
			$Out = array ('Total' => $Count, 'Rows' => $newmodel );
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $Out );
		}
	}
	
	/**
	 * 获取任务时间表(暂时不做)
	 */
	public function actionListTaskTimeTable() {
		
		$DataParam = $this->LoadDataParam ();
		
		if (empty ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//获取用户
		$UserId = $this->GetPostOwnerID ();
		//类型
		$Type = $this->GetDataParam ( $DataParam, 'Type', - 1, true );
		//二级类型
		$SecondType = $this->GetDataParam ( $DataParam, 'SecondType', - 1, true );
		//父节点类型（仅用户任务需要，空为获取用户列表）
		$ParentId = $this->GetDataParam ( $DataParam, 'ParentId', - 1, true );
		
		$SelectStreamType = $this->GetDataParam ( $DataParam, 'SelectStreamType', - 1, true );
		
		$Owner = $this->GetDataParam ( $DataParam, 'Owner', - 1, true );
		
		$WeekDay = $this->GetDataParam ( $DataParam, 'WeekDay', - 1, true );
		
		$Template = $this->GetDataParam ( $DataParam, 'Template', - 1, true );
		
		$SearchKey = $this->GetDataParam ( $DataParam, 'SearchKey', '' );
		
		if ($SecondType == ATaskUtil::MENU_SECONDE_TYPE_TIMED) { //定时任务
			//////////////////////////////////////////////////
			// admin：查看系统创建的任务
			// 普通用户：查看自己创建的任务
			//////////////////////////////////////////////////
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", ATaskUtil::ListTimedTaskTimeTable ( $UserId, $SelectStreamType, $Owner, $WeekDay, $Template, $SearchKey ) );
			return;
		} else if ($SecondType == ATaskUtil::MENU_SECONDE_TYPE_HADN) { //手动任务（仅admin）
			if (is_null ( $UserId )) {
				echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", array () );
				return;
			}
		} else if ($SecondType == ATaskUtil::MENU_SECONDE_TYPE_USER) { //用户任务（仅admin）
			if (is_null ( $UserId )) {
				if ($ParentId > 0) { //获取用户定时任务
					echo $this->ListTimedTaskTimeTable ( $UserId, $SelectStreamType, $UserId, $WeekDay, $Template, $SearchKey );
					return;
				} else {
					$sql = "SELECT User_ID as id, User_Name as text, 0 as Parent FROM Users WHERE User_ID > 0;";
					$timeTaskUser = DBMethodUtils::listData ( $sql );
					
					echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", $timeTaskUser );
				}
			
			}
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, "参数异常", null );
	}
	
	//////////////////////////////////////////////////////////////////
	

	/**
	 * 获取一级任务菜单
	 */
	public function actionListFirtMenu() {
		
		//用户id
		$UserId = $this->GetPostOwnerID ();
		
		$Arr = array ();
		
		$Arr [] = array ('Type' => ATaskUtil::MENU_TYPE_TASK_MANAGER, 'Name' => $this->getStr ( 'appcommon', 'task_menu_task_manager' ) ); //任务管理
		

		if (is_null ( $UserId )) {
			$Arr [] = array ('Type' => ATaskUtil::MENU_TYPE_TASK_TEMPLATE, 'Name' => $this->getStr ( 'appcommon', 'task_menu_task_template' ) ); //任务模板
			$Arr [] = array ('Type' => ATaskUtil::MENU_TYPE_TASK_MODE_RUN, 'Name' => $this->getStr ( 'appcommon', 'task_menu_task_mode_run' ) ); //运行模式
			$Arr [] = array ('Type' => ATaskUtil::MENU_TYPE_TASK_MODE_STOPED, 'Name' => $this->getStr ( 'appcommon', 'task_menu_task_mode_stoped' ) ); //备用模式
		}
		if ($this->JudgeBroadcastPrivaliege ( $UserId )) { //具有广播权限需要显示实时采播
			$Arr [] = array ('Type' => ATaskUtil::MENU_TYPE_TASK_SSCB, 'Name' => $this->getStr ( 'appcommon', 'task_menu_task_sscb' ) ); //实时采播
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $Arr );
	}
	
	/**
	 * 获取二级菜单
	 */
	public function actionListSecondeMenu() {
		
		/*****************************************************
		 * 任务管理包括：定时任务、手动任务（仅admin）、用户任务（仅admin）
		 *****************************************************/
		$DataParam = $this->LoadDataParam ();
		
		if (empty ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//获取用户
		$UserId = $this->GetPostOwnerID ();
		//类型
		$Type = $this->GetDataParam ( $DataParam, 'Type', - 1, true );
		
		if ($Type == ATaskUtil::MENU_TYPE_TASK_MANAGER) { //任务管理
			$Arr = array ();
			//定时任务、
			$Arr [] = array ('Type' => $Type, 'SecondType' => ATaskUtil::MENU_SECONDE_TYPE_TIMED, 'Name' => $this->getStr ( 'appcommon', 'task_menu_second_task_timed' ) );
			if (is_null ( $UserId )) {
				//手动任务（仅admin）
				$Arr [] = array ('Type' => $Type, 'SecondType' => ATaskUtil::MENU_SECONDE_TYPE_HADN, 'Name' => $this->getStr ( 'appcommon', 'task_menu_second_task_hand' ) );
				//用户任务（仅admin）
				$Arr [] = array ('Type' => $Type, 'SecondType' => ATaskUtil::MENU_SECONDE_TYPE_USER, 'Name' => $this->getStr ( 'appcommon', 'task_menu_second_task_user' ) );
			}
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", $Arr );
			return;
		} else if ($Type == ATaskUtil::MENU_TYPE_TASK_TEMPLATE) { //任务模板
			//获取任务模板
			$sql = "SELECT :Type AS Type, idTaskTemplate AS SecondType,  IF(idTaskTemplate = 0, '" . $this->getStr ( 'appcommon', 'task_menu_second__defaault_template' ) . "', TemplateName) AS Name,
				 IF(ISNULL(c.InfoValue), 0, 1) AS Enabled FROM TaskTemplate a 
			LEFT JOIN (SELECT COUNT(*) AS TaskCount, Template FROM PlaySessions GROUP BY Template) b ON a.idTaskTemplate = b.Template
			LEFT JOIN BaseInfo c ON c.InfomationID = 0x101 AND c.InfoValue = a.idTaskTemplate
			ORDER BY  IF(ISNULL(c.InfoValue), 0, 1) DESC, idTaskTemplate ASC";
			$Arr = DBMethodUtils::listData ( $sql, array (":Type" => $Type ) );
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", $Arr );
			return;
		} else if ($Type == ATaskUtil::MENU_TYPE_TASK_MODE_RUN) { //运行模式
			$sql = "SELECT :Type AS Type, idBroadcastMode AS SecondType, ModeName AS Name, Active FROM BroadcastMode WHERE Enabled = '1'ORDER BY Active DESC, idBroadcastMode ASC";
			$Arr = DBMethodUtils::listData ( $sql, array (":Type" => $Type ) );
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", $Arr );
			return;
		} else if ($Type == ATaskUtil::MENU_TYPE_TASK_MODE_STOPED) { //备用模式
			$sql = "SELECT :Type AS Type, idBroadcastMode AS SecondType, ModeName AS Name, Active FROM BroadcastMode WHERE Enabled = '0'";
			$Arr = DBMethodUtils::listData ( $sql, array (":Type" => $Type ) );
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", $Arr );
			return;
		} else if ($Type == ATaskUtil::MENU_TYPE_TASK_SSCB) { //实时采播
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", null );
			return;
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, "", null );
	}
	
	/**
	 * 获取任务列表数据
	 */
	public function actionListTasks() {
		
		$DataParam = $this->LoadDataParam ();
		
		if (empty ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$UserId = $this->GetPostOwnerID (); //获取用户
		$Type = $this->GetDataParam ( $DataParam, 'Type', - 1, true ); //类型(一级菜单Type)
		$SecondType = $this->GetDataParam ( $DataParam, 'SecondType', - 1, true ); //二级类型（二级菜单SecondType）
		$Sort = $this->GetDataParam ( $DataParam, "Sort", "" ); //排序字段
		$Order = $this->GetDataParam ( $DataParam, "Order", - "" ); //排序方式，ASC升序，DESC降序
		$Start = $this->GetDataParam ( $DataParam, "Start", - 1, true ); //起始位置
		$Size = $this->GetDataParam ( $DataParam, "Size", - 1, true ); //获取条数
		

		$SelectStreamType = $this->GetDataParam ( $DataParam, 'SelectStreamType', - 1, true ); //任务类型，0:控制任务，1：广播任务，2：都选，3：都不选
		

		//任务管理
		$WeekDay = $this->GetDataParam ( $DataParam, 'WeekDay', - 1, true ); //选择星期，0-6：星期一到星期天，空为全选
		

		//任务管理-用户任务
		$Owner = $this->GetDataParam ( $DataParam, 'Owner', - 1, true ); //任务所属用户
		

		//任务模板
		$Template = $SecondType; //模板id，为二级菜单SecondType
		

		//任务模式(运行/备用模式)
		$Mode = $SecondType; //模式id， 为二级菜单SecondType
		

		$SearchKey = $this->GetDataParam ( $DataParam, 'SearchKey', '' );
		
		if ($Type == ATaskUtil::MENU_TYPE_TASK_MANAGER) { //任务管理
			$Out = ATaskUtil::taskMgrList ( $UserId, $SecondType, $SelectStreamType, $Owner, $WeekDay, $SearchKey, $Sort, $Order, $Start, $Size );
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", $Out );
			return;
		} else if ($Type == ATaskUtil::MENU_TYPE_TASK_TEMPLATE) { //任务模板
			$Out = ATaskUtil::templateList ( $UserId, $SelectStreamType, $Template, $WeekDay, $SearchKey, $Sort, $Order, $Start, $Size );
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", $Out );
			return;
		} else if ($Type == ATaskUtil::MENU_TYPE_TASK_MODE_RUN) { //运行模式
			$Out = ATaskUtil::enabledModeList ( $UserId, $Mode, $SelectStreamType, $Sort, $Order, $Start, $Size );
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", $Out );
			return;
		} else if ($Type == ATaskUtil::MENU_TYPE_TASK_MODE_STOPED) { //备用模式
			$Out = ATaskUtil::disableModeList ( $UserId, $Mode, $SelectStreamType, $Sort, $Order, $Start, $Size );
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", $Out );
			return;
		} else if ($Type == ATaskUtil::MENU_TYPE_TASK_SSCB) { //实时采播
			$Out = ATaskUtil::realtimeList ( $UserId, $Sort, $Order, $Start, $Size );
			
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", $Out );
			return;
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, "参数异常", null );
	}
	
	/**
	 * 手动广播更新 
	 */
	public function actionUpdateHandTask() {
		
		$sql = "SELECT a.SessionID AS TempId, a.SessionID, a.SessionName, a.SessionType, a.Priority, a.CircleLength, a.StreamType, c.FileName, 
				b.CurrFileProgress, b.CurrTotalProgress, dd.Pause, IF(ISNULL(pl.PlayListCount), 0, pl.PlayListCount) AS PlayListCount
		      FROM PlaySessions a LEFT JOIN PlayingSessions b ON a.SessionID=b.SessionID LEFT JOIN MediaFiles c ON b.PlayingFileID=c.MediaID
			 LEFT JOIN PlayingSessions dd ON a.SessionID=dd.SessionID 
			 LEFT JOIN (SELECT COUNT(*) AS PlayListCount, SessionID FROM PlayListFiles GROUP BY SessionID) pl ON a.SessionID=pl.SessionID WHERE a.SessionType IN(2,9) 
			 AND NOT ISNULL(b.CurrFileProgress) AND NOT ISNULL(b.CurrTotalProgress)";
		$result = DBMethodUtils::listData ( $sql );
		
		if (! empty ( $result )) {
			foreach ( $result as $key => $value ) {
				$result [$key] ['SteamTypeDown'] = $value ['StreamType'] - round ( $value ['StreamType'] / 128 ) * 128;
			}
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $result );
	}
	
	/**
	 * 获取播放列表
	 */
	public function actionListPlayList() {
		$DataParam = $this->LoadDataParam ();
		
		if (empty ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//获取用户
		$UserId = $this->GetPostOwnerID ();
		
		if (! isset ( $DataParam ['SessionID'] ) || ! is_numeric ( $DataParam ['SessionID'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sessionID = $DataParam ['SessionID'];
		
		//播放列表
		$sql = "SELECT a.FileID, a.SequenceID, b.FileName, b.TotalTime FROM PlayListFiles a LEFT JOIN
				MediaFiles b ON a.FileID=b.MediaID WHERE SessionID='" . $sessionID . "' ORDER BY SequenceID";
		$playList = DBMethodUtils::listData ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $playList );
	}
	
	/**
	 * 获取任务接收成员
	 */
	public function actionListSessionDevices() {
		
		$DataParam = $this->LoadDataParam ();
		
		if (empty ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//获取用户
		$UserId = $this->GetPostOwnerID ();
		$sessionID = $this->GetDataParam ( $DataParam, 'SessionID', - 1, true );
		
		$sql = "SELECT * FROM PlaySessions WHERE SessionID=" . $sessionID;
		$PlaySession = DBMethodUtils::findData ( $sql );
		
		if (empty ( $PlaySession )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sessionDevices = array ();
		
		if (is_numeric ( $PlaySession ['BrdMode'] ) && $PlaySession ['BrdMode'] > 0 && is_numeric ( $PlaySession ['MemberMode'] ) && $PlaySession ['MemberMode'] == 1) { //模式任务,并且是模式成员
			$sessionDevices = ASysTaskUtil::LoadModeDevice ( $PlaySession ['BrdMode'], $UserId );
		} else {
			$sessionDevices = TaskUtil::LoadSessionDevice ( $sessionID, $UserId );
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $sessionDevices );
	}
	
	/**
	 * 获取任务接收成员(新建时需要)
	 */
	public function actionListSessionDevicesForNew() {
		
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			// 用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		$Out = array ();
		$Out ['Use_Device_Tree'] = SystemUtil::LoadUserDeviceTree ( $UserID, 0, 1 ); //使用设备列表
		

		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $Out );
	}
	
	/**
	 * 加载模式成员（新建模式任务需要）
	 */
	public function actionListModeDevices() {
		
		////////////////////////////////////////////////////////////////
		// 仅admin可以操作
		///////////////////////////////////////////////////////////////
		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			// 用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		
		if (! is_null ( $UserID )) {
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NO_PERMISSION, '对不起，您没有操作权限！', null );
			return;
		}
		//获取DataParam
		$DataParam = $this->LoadDataParam ();
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$ModeId = $this->GetDataParam ( $DataParam, 'ModeId', - 1, true ); //模式id
		

		$UserID = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserID ) && $UserID < 0) {
			// 用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		//加载模式信息
		$Mode = BroadcastMode::model ()->findByPk ( $ModeId );
		
		$Out = array ();
		$Out ['Priority'] = 0;
		
		if (! empty ( $Mode )) {
			$Out ['Priority'] = $Mode->Priority;
		}
		$Out ['Member'] = ATaskUtil::LoadModeDevice ( $ModeId, $UserID );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $Out );
	}
	
	/**
	 * 加载任务数据
	 */
	public function actionLoadPlaySession() {
		
		$DataParam = $this->LoadDataParam ();
		
		if (empty ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//获取用户
		$UserId = $this->GetPostOwnerID ();
		
		if (! isset ( $DataParam ['SessionID'] ) || ! is_numeric ( $DataParam ['SessionID'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sessionID = $DataParam ['SessionID'];
		
		//获取任务基本信息
		$sql = "SELECT * FROM PlaySessions WHERE SessionID=" . $sessionID;
		
		if ($UserId > 0) {
			$sql .= ' AND Owner="' . $UserId . '"';
		}
		$PlaySession = DBMethodUtils::findData ( $sql );
		
		if (is_null ( $PlaySession )) {
			echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '任务不存在！', null );
			return;
		}
		$taskInfo = array ();
		
		//任务基本信息
		$baseInfo = array ();
		//任务id
		$baseInfo ['SessionID'] = $PlaySession ['SessionID'];
		//任务名称
		$baseInfo ['SessionName'] = $PlaySession ['SessionName'];
		//任务类型,0: 自动广播或控制任务；1：由PC呼叫台或者音频广播站创建的任务；2：手动广播任务
		$baseInfo ['SessionType'] = $PlaySession ['SessionType'];
		//优先级
		$baseInfo ['Priority'] = $PlaySession ['Priority'];
		
		//强制接收标识(StreamType高4为来判断，最高位：1：强制，0：不强制)
		$baseInfo ['SteamTypeUp'] = round ( $PlaySession ['StreamType'] / 128 );
		//00控制任务，01音频，10视屏，11音视频，一般用11来表示视频。(StreamType低4为来判断)
		$baseInfo ['SteamTypeDown'] = $PlaySession ['StreamType'] - round ( $PlaySession ['StreamType'] / 128 ) * 128;
		//所属用户id
		$baseInfo ['Owner'] = $PlaySession ['Owner'];
		$taskInfo ['BaseInfo'] = $baseInfo;
		$taskInfo ['Mode'] = null;
		$taskInfo ['Brodcast'] = null;
		$taskInfo ['DeviceCtrl'] = null;
		
		if (! is_null ( $PlaySession ['BrdMode'] ) && $PlaySession ['BrdMode'] > 0) {
			//加载模式信息
			$Mode = BroadcastMode::model ()->findByPk ( $PlaySession ['BrdMode'] );
			
			if (! empty ( $Mode )) {
				//模式
				$mode = array ();
				$mode ['BrdMode'] = $PlaySession ['BrdMode']; //是否广播模式任务，>0广播模式ID 是模式任务，null表示非模式任务
				$mode ['MemmberMode'] = $PlaySession ['MemberMode']; //默认为0,是否使用模式成员，1使用模式成员，0不使用
				$mode ['Priority'] = $Mode->Priority;
				$taskInfo ['Mode'] = $mode;
			}
		}
		
		if ($baseInfo ['SteamTypeDown'] == 1 || $baseInfo ['SteamTypeDown'] == 2 || $baseInfo ['SteamTypeDown'] == 3) {
			//广播任务
			$Brodcast = array ();
			//音量调节
			$Brodcast ['AudioGain'] = $PlaySession ['AudioGain'];
			//播放时间，秒
			$Brodcast ['CircleLength'] = $PlaySession ['CircleLength'];
			//播放模式,媒体播放方式，0顺序播放，1随机播放，默认是0，广播任务才用
			$Brodcast ['PlayMode'] = $PlaySession ['PlayMode'];
			//播放列表
			$sql = "SELECT a.FileID, a.SequenceID, b.FileName, b.TotalTime FROM PlayListFiles a LEFT JOIN
				MediaFiles b ON a.FileID=b.MediaID WHERE SessionID='" . $sessionID . "' ORDER BY SequenceID";
			$Brodcast ['PlayFileList'] = DBMethodUtils::listData ( $sql );
			
			$taskInfo ['Brodcast'] = $Brodcast;
		} else if ($baseInfo ['SteamTypeDown'] == 0) {
			//控制任务
			$DeviceCtrl = array ();
			//设备控制，系统启禁用状态，1启用，0禁用，仅控制任务才使用这个字段，null为没有控制
			$DeviceCtrl ['SysEnabled'] = $PlaySession ['SysEnabled'];
			
			//扩展设备信息
			$expandSource = ExpandUtil::LoadExpandDev ();
			//扩展设备模式
			$expandMode = ExpandUtil::LoadExpandMode ();
			
			//扩展电源
			$DeviceCtrl ['RfDevCtrl'] = DeviceUtil::DepackRfDevCtrl ( $expandSource, $PlaySession ['RfDevCtrl'], $expandMode );
			$taskInfo ['DeviceCtrl'] = $DeviceCtrl;
		}
		
		$tempUserId = $UserId;
		
		if (! is_null ( $PlaySession ['Owner'] )) {
			$tempUserId = $PlaySession ['Owner'];
		}
		$time = time ();
		//接收成员
		$sessionDevices = array ();
		
		if (is_numeric ( $PlaySession ['BrdMode'] ) && $PlaySession ['BrdMode'] > 0 && is_numeric ( $PlaySession ['MemberMode'] ) && $PlaySession ['MemberMode'] == 1) { //模式任务,并且是模式成员
			$sessionDevices = ASysTaskUtil::LoadModeDevice ( $PlaySession ['BrdMode'], $UserId );
		} else {
			$sessionDevices = TaskUtil::LoadSessionDevice ( $sessionID, $UserId );
		}
		$taskInfo ['SessionDevice'] = $sessionDevices;
		
		//执行时间
		$sql = "SELECT a.ScheduleID, WeekDay, DATE_FORMAT(PlayTime,'%H:%i:%S') as PlayTime, TempFlag, Pause FROM PlaySessionTime a
			LEFT JOIN PlayingSessions b ON a.SessionID=b.SessionID AND a.ScheduleID=b.ScheduleID WHERE a.SessionID='" . $sessionID . "'";
		$taskInfo ['PlayTime'] = DBMethodUtils::listData ( $sql );
		
		$config = array ();
		$config ['AirConditioningMode'] = ConfigUtil::LoadAirConditioningMode ();
		$config ['PowerMode'] = ConfigUtil::LoadPowerMode ();
		$config ['RfDevice'] = array ();
		$config ['AlternateDate'] = ConfigUtil::LoadAlternateDate ();
		
		if ($this->JudgeRfDevCtrPrivaliege ( $UserId )) {
			$config ['RfDevice'] = ExpandUtil::LoadExpandDev ();
		}
		$taskInfo ['Config'] = $config;
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $taskInfo );
	}
	
	/**
	 * 编辑（新增/修改）定时广播（包括：定时任务、模板任务、手动任务）
	 */
	public function actionEditBroadcast() {
		
		$DataParam = $this->LoadDataParam ();
		
		if (empty ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//获取用户
		$UserId = $this->GetPostOwnerID ();
		/*
		 {
		 "BaseInfo":{
		 "SessionID":"任务ID,如果是新建则为空字符串，任务批量格式为：1,2,3",
		 "SessionName":"任务名字",
		 "SessionType":"0: 自动广播或控制任务；1：由PC呼叫台或者音频广播站创建的任务；2：手动广播任务",
		 "Priority":"优先级（整数）",
		 "SteamTypeUp":"强制接收，1：强制，0：不强制",
		 "SteamTypeDown":"0控制任务，1音频，2视屏，3音视频，一般用3来表示视频",
		 "Template" : "当前选中模板id，非模板任务为空"
		 },
		 "Mode":{
		 "BrdMode":"是否广播模式任务，>0广播模式ID 是模式任务，null表示非模式任务",
		 "MemmberMode":"默认为0,是否使用模式成员，1使用模式成员，0不使用"
		 },
		 "Brodcast":{
		 "AudioGain":"音频增益，单个任务的音量调节。",
		 "CircleLength":"默认为0，播放时长；秒",
		 "PlayMode":"播放模式,媒体播放方式，0顺序播放，1随机播放，默认是0，广播任务才用",
		 "PlayFileList":[
		 {
		 "FileID":"文件ID（整数）"
		 },
		 {
		 "FileID":"文件ID（整数）"
		 }
		 ]
		 },
		 "DeviceCtrl":{
		 "SysEnabled":"设备控制，系统启禁用状态，1启用，0禁用，仅控制任务才使用这个字段，null为没有控制",
		 "RfDevCtrl":[
		 {
		 "PwrID":"扩展设备ID",
		 "Mode":"模式：0：关闭电源；电源：1：打开电源，4：本地模式，其他无效；空调：1~4对应空调4种模式"
		 }
		 ]
		 },
		 "SessionDevice":[
		 {
		 "DeviceID":"设备id（字符串）"
		 },
		 {
		 "DeviceID":"设备id（字符串）"
		 }
		 ],
		 "PlayTime":[
		 {
		 "ScheduleID":"执行时间ID（整数）",
		 "WeekDay":"星期编号，0：星期一，6：星期天",
		 "PlayTime":"播出时间，仅时分秒，如：12:10:00",
		 "TempFlag":"是否临时任务，1临时任务，0非临时任务，2暂停，临时任务按照指定的时间执行一次完就删除这条记录"
		 }
		 ]
		 }
		 */
		//基本信息
		if (! isset ( $DataParam ['BaseInfo'] )) {
			//基本信息不存在，不能继续操作
			echo $this->PackResponseData ( ErrcodeUtil::$SESSION_BASEINFO_ERR, '请输入正确的任务信息！', null );
			return;
		}
		$BaseInfo = $DataParam ['BaseInfo']; //基本信息
		$SessionID = $this->GetDataParam ( $BaseInfo, "SessionID", - 1, true ); //任务ID
		//查找任务
		$SessionModel = PlaySessions::model ()->findByPk ( $SessionID );
		
		//获取任务类型
		$tempsessiontype = - 1;
		
		if (! is_null ( $SessionModel )) {
			$tempsessiontype = $SessionModel->SessionType;
		}
		
		if (! isset ( $BaseInfo ['SessionType'] )) {
			$tempsessiontype = $BaseInfo ['SessionType'];
		}
		//判断是否有权限
		$TempRes = ATaskUtil::JudgeTaskPermission ( $UserId, $tempsessiontype );
		
		if (empty ( $TempRes )) {
			echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '', null );
			return;
		}
		if ($TempRes ['ErrCode'] != ErrcodeUtil::$SUCCESS) {
			echo $this->PackResponseData ( $TempRes ['ErrCode'], $TempRes ['ErrMsg'], $TempRes ['Data'] );
			return;
		}
		
		if (! is_null ( $SessionModel )) {
			$ParamArr = array ();
			$UpdateAttr = ATaskUtil::packUpdateArr ( $SessionModel, $BaseInfo, $ParamArr );
			
			if (empty ( $UpdateAttr )) {
				$UpdateAttr = array ();
			}
			if (isset ( $DataParam ['Mode'] ) && ! is_null ( $DataParam ['Mode'] )) { //模式任务
				$Mode = $DataParam ['Mode'];
				$UpdateAttr = ATaskUtil::packModeUpdateArr ( $Mode, $UpdateAttr, $ParamArr );
			}
			
			if (isset ( $DataParam ['Brodcast'] ) && ! is_null ( $DataParam ['Brodcast'] )) { //广播任务
				$Broadcast = $DataParam ['Brodcast'];
				$UpdateAttr = ATaskUtil::packBroadcastUpdateArr ( $Broadcast, $UpdateAttr, $ParamArr );
			}
			if (! empty ( $UpdateAttr )) {
				$sql = 'UPDATE PlaySessions SET ' . implode ( ',', $UpdateAttr ) . ' WHERE SessionID IN(' . $SessionID . ')';
				DBMethodUtils::RunSql ( $sql, $ParamArr );
			}
		} else {
			//新建任务
			if (! isset ( $BaseInfo ['SessionType'] )) {
				return $this->PackResponseData ( ErrcodeUtil::$SESSION_NEED_SESSIONTYPE, '请确定任务类型！', null );
				return;
			}
			$SessionType = $BaseInfo ['SessionType'];
			
			if ($SessionType == 1) {
				//实时采播，不能新建
				echo $this->PackResponseData ( ErrcodeUtil::$SESSION_SESSIONTYPE_ERR, '实时采播任务不能够手动添加', null );
				return;
			}
			//定时任务、模式任务必须要有执行时间；手动广播不需要执行时间
			if ($SessionType != 2 && $SessionType != 9) {
				//非手动任务必须要有执行时间
				if (! isset ( $DataParam ['PlayTime'] ) || is_null ( $DataParam ['PlayTime'] ) || count ( $DataParam ['PlayTime'] ) <= 0) {
					echo $this->PackResponseData ( ErrcodeUtil::$SESSION_NEED_PLAYTIME, '请设置播出时间', null );
					return;
				}
			}
			$SessionModel = ATaskUtil::packNewModel ( $UserId, $BaseInfo );
			
			if ((is_null ( $UserId ) || $UserId == 0) && $SessionModel->SessionType == 0 && ! is_numeric ( $SessionModel->Template )) { //没有启用任务模板
				echo $this->PackResponseData ( ErrcodeUtil::$SESSION_NO_TEMPLATE, '没有启用任务模板', null );
				return;
			}
			if (isset ( $DataParam ['Mode'] ) && ! is_null ( $DataParam ['Mode'] )) { //模式任务信息
				$Mode = $DataParam ['Mode'];
				$SessionModel = ATaskUtil::packModeNewModel ( $SessionModel, $Mode );
			}
			
			if (isset ( $DataParam ['Brodcast'] ) && ! is_null ( $DataParam ['Brodcast'] )) { //广播任务
				$Broadcast = $DataParam ['Brodcast'];
				$SessionModel = ATaskUtil::packBroadcastNewModel ( $SessionModel, $Broadcast );
			}
			if (! $SessionModel->save ()) {
				echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '新建任务失败', null );
				return;
			}
			$SessionID = $SessionModel->SessionID; //任务id
		}
		/*******************************************************************************/
		if (isset ( $DataParam ['Brodcast'] ) && ! is_null ( $DataParam ['Brodcast'] )) {
			//广播任务,处理播放列表
			if (isset ( $DataParam ['Brodcast'] ['PlayFileList'] )) { //有播放列表
				$PlayFileList = $DataParam ['Brodcast'] ['PlayFileList'];
				TaskUtil::DealBroadcastPlayFileList ( $SessionID, $PlayFileList );
			}
		}
		if (isset ( $DataParam ['SessionDevice'] ) && ! is_null ( $DataParam ['SessionDevice'] )) {
			//接收成员
			$SessionDevice = $DataParam ['SessionDevice'];
			TaskUtil::DealSessionDevice ( $SessionID, $SessionDevice );
		}
		
		if (isset ( $DataParam ['PlayTime'] ) && ! is_null ( $DataParam ['PlayTime'] )) {
			//播出时间
			$PlayTime = $DataParam ['PlayTime'];
			TaskUtil::DealPlayTime ( $SessionID, $PlayTime );
		}
		DBMethodUtils::RunSql ( 'call sp_session_clean_up()' );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '新建任务成功', null );
	
	}
	
	/**
	 * 编辑（新增/修改）定时控制任务（包括：定时任务、模板任务）
	 */
	public function actionEditCtrl() {
		
		$DataParam = $this->LoadDataParam ();
		
		if (empty ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//获取用户
		$UserId = $this->GetPostOwnerID ();
		
		/*
		 {
		 "BaseInfo":{
		 "SessionID":"任务ID,如果是新建则为空字符串，任务批量格式为：1,2,3",
		 "SessionName":"任务名字",
		 "SessionType":"0: 自动广播或控制任务；1：由PC呼叫台或者音频广播站创建的任务；2：手动广播任务",
		 "Priority":"优先级（整数）",
		 "SteamTypeUp":"强制接收，1：强制，0：不强制",
		 "SteamTypeDown":"0控制任务，1音频，2视屏，3音视频，一般用3来表示视频"
		 },
		 "Mode":{
		 "BrdMode":"是否广播模式任务，>0广播模式ID 是模式任务，null表示非模式任务",
		 "MemmberMode":"默认为0,是否使用模式成员，1使用模式成员，0不使用"
		 },
		 "Brodcast":{
		 "AudioGain":"音频增益，单个任务的音量调节。",
		 "CircleLength":"默认为0，播放时长；秒",
		 "PlayMode":"播放模式,媒体播放方式，0顺序播放，1随机播放，默认是0，广播任务才用",
		 "PlayFileList":[
		 {
		 "FileID":"文件ID（整数）"
		 },
		 {
		 "FileID":"文件ID（整数）"
		 }
		 ]
		 },
		 "DeviceCtrl":{
		 "SysEnabled":"设备控制，系统启禁用状态，1启用，0禁用，仅控制任务才使用这个字段，null为没有控制",
		 "RfDevCtrl":[
		 {
		 "PwrID":"扩展设备ID",
		 "Mode":"模式：0：关闭电源；电源：1：打开电源，4：本地模式，其他无效；空调：1~4对应空调4种模式"
		 }
		 ]
		 },
		 "SessionDevice":[
		 {
		 "DeviceID":"设备id（字符串）"
		 },
		 {
		 "DeviceID":"设备id（字符串）"
		 }
		 ],
		 "PlayTime":[
		 {
		 "ScheduleID":"执行时间ID（整数）",
		 "WeekDay":"星期编号，0：星期一，6：星期天",
		 "PlayTime":"播出时间，仅时分秒，如：12:10:00",
		 "TempFlag":"是否临时任务，1临时任务，0非临时任务，2暂停，临时任务按照指定的时间执行一次完就删除这条记录"
		 }
		 ]
		 }
		 */
		$DataParam = null;
		
		if (isset ( $_POST ['DataParam'] )) {
			$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		}
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		//基本信息
		if (! isset ( $DataParam ['BaseInfo'] )) {
			//基本信息不存在，不能继续操作
			echo $this->PackResponseData ( ErrcodeUtil::$SESSION_BASEINFO_ERR, '请输入正确的任务信息！', null );
			return;
		}
		$BaseInfo = $DataParam ['BaseInfo'];
		//任务ID
		$SessionID = $this->GetDataParam ( $BaseInfo, "SessionID", - 1, true );
		//查找任务
		$SessionModel = PlaySessions::model ()->findByPk ( $SessionID );
		
		$tempsessiontype = - 1;
		
		if (! is_null ( $SessionModel )) {
			$tempsessiontype = $SessionModel->SessionType;
		}
		
		if (! isset ( $BaseInfo ['SessionType'] )) {
			$tempsessiontype = $BaseInfo ['SessionType'];
		}
		
		//判断是否有权限
		$TempRes = ATaskUtil::JudgeTaskPermission ( $UserId, $tempsessiontype );
		
		if (empty ( $TempRes )) {
			echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '', null );
			return;
		}
		if ($TempRes ['ErrCode'] != ErrcodeUtil::$SUCCESS) {
			echo $this->PackResponseData ( $TempRes ['ErrCode'], $TempRes ['ErrMsg'], $TempRes ['Data'] );
			return;
		}
		
		if (! is_null ( $SessionModel )) {
			$ParamArr = array ();
			$UpdateAttr = ATaskUtil::packUpdateArr ( $SessionModel, $BaseInfo, $ParamArr );
			
			if (empty ( $UpdateAttr )) {
				$UpdateAttr = array ();
			}
			if (isset ( $DataParam ['Mode'] ) && ! is_null ( $DataParam ['Mode'] )) { //模式任务
				$Mode = $DataParam ['Mode'];
				$UpdateAttr = ATaskUtil::packModeUpdateArr ( $Mode, $UpdateAttr, $ParamArr );
			}
			
			if (isset ( $DataParam ['DeviceCtrl'] ) && ! is_null ( $DataParam ['DeviceCtrl'] )) { //控制任务		
				$DeviceCtrl = $DataParam ['DeviceCtrl'];
				$UpdateAttr = ATaskUtil::packCtrlUpdateArr ( $UserId, $DeviceCtrl, $UpdateAttr, $ParamArr );
			}
			
			if (! empty ( $UpdateAttr )) {
				$sql = 'UPDATE PlaySessions SET ' . implode ( ',', $UpdateAttr ) . ' WHERE SessionID IN(' . $SessionID . ')';
				DBMethodUtils::RunSql ( $sql, $ParamArr );
			}
		} else {
			//新建任务
			if (! isset ( $BaseInfo ['SessionType'] )) {
				echo $this->PackResponseData ( ErrcodeUtil::$SESSION_NEED_SESSIONTYPE, '请确定任务类型！', null );
				return;
			}
			$SessionType = $BaseInfo ['SessionType'];
			
			if ($SessionType == 1) {
				//实时采播，不能新建
				echo $this->PackResponseData ( ErrcodeUtil::$SESSION_SESSIONTYPE_ERR, '实时采播任务不能够手动添加', null );
				return;
			}
			//定时任务、模式任务必须要有执行时间；手动广播不需要执行时间
			if ($SessionType != 2 && $SessionType != 9) {
				//非手动任务必须要有执行时间
				if (! isset ( $DataParam ['PlayTime'] ) || is_null ( $DataParam ['PlayTime'] ) || count ( $DataParam ['PlayTime'] ) <= 0) {
					echo $this->PackResponseData ( ErrcodeUtil::$SESSION_NEED_PLAYTIME, '请设置播出时间', null );
					return;
				}
			}
			$SessionModel = ATaskUtil::packNewModel ( $UserId, $BaseInfo );
			
			if (empty ( $SessionModel )) {
				echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '', null );
				return;
			}
			
			if (isset ( $DataParam ['Mode'] ) && ! is_null ( $DataParam ['Mode'] )) { //模式任务信息
				$Mode = $DataParam ['Mode'];
				$SessionModel = ATaskUtil::packModeNewModel ( $SessionModel, $Mode );
			}
			if (isset ( $DataParam ['DeviceCtrl'] ) && ! is_null ( $DataParam ['DeviceCtrl'] )) {
				//控制任务
				$DeviceCtrl = $DataParam ['DeviceCtrl'];
				$SessionModel = ATaskUtil::packCtrlNewModel ( $UserId, $SessionModel, $DeviceCtrl );
			}
			
			if (! $SessionModel->save ()) {
				echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '新建任务失败', null );
				return;
			} else {
				if (! empty ( $DataParam ['DeviceCtrl'] ['RfDevCtrl'] ) && $this->JudgeRfDevCtrPrivaliege ( $UserId )) {
					TaskUtil::DealRfDevCtrl ( $SessionModel->RfDevCtrl, $DataParam ['DeviceCtrl'] ['RfDevCtrl'], $SessionModel->SessionID );
				}
			}
			$SessionID = $SessionModel->SessionID; //任务id
		}
		/*******************************************************************************/
		if (isset ( $DataParam ['SessionDevice'] ) && ! is_null ( $DataParam ['SessionDevice'] )) {
			//接收成员
			$SessionDevice = $DataParam ['SessionDevice'];
			TaskUtil::DealSessionDevice ( $SessionID, $SessionDevice );
		}
		if (isset ( $DataParam ['PlayTime'] ) && ! is_null ( $DataParam ['PlayTime'] )) {
			//播出时间
			$PlayTime = $DataParam ['PlayTime'];
			TaskUtil::DealPlayTime ( $SessionID, $PlayTime );
		}
		DBMethodUtils::RunSql ( 'call sp_session_clean_up()' );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '新建任务成功', null );
	}
	
	/**
	 * 删除任务
	 */
	public function actionDeleteSessions() {
		
		$DataParam = $this->LoadDataParam ();
		
		if (empty ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//获取用户
		$UserId = $this->GetPostOwnerID ();
		
		$SessionArr = array ();
		
		foreach ( $DataParam as $item ) {
			$SessionId = $item ['SessionID'];
			$ScheduleID = $item ['ScheduleID'];
			
			if (is_numeric ( $SessionId )) {
				$SessionArr [] = $SessionId;
			} else {
				continue;
			}
			if (! is_numeric ( $ScheduleID )) {
				continue;
			}
			//删除数据
			$sql = "call delete_task('" . $ScheduleID . "')";
			DBMethodUtils::RunSql ( $sql );
		}
		//获取任务没有执行时间的
		$SessionArr = array_unique ( $SessionArr );
		
		//删除实时采播
		if (! empty ( $SessionArr )) {
			$sql = 'SELECT a.*, c.IpAddress
				FROM PlaySessions a 
				LEFT JOIN (SELECT COUNT(*) PalyeTimeCount, SessionID FROM PlaySessionTime GROUP BY SessionID) b ON a.SessionID=b.SessionID
				LEFT JOIN PlayerStatus c ON a.PlayerID = c.PlayerID
			WHERE a.SessionID IN(' . implode ( ',', $SessionArr ) . ') AND (ISNULL(PalyeTimeCount) OR PalyeTimeCount <= 0)';
			
			$Sessions = DBMethodUtils::listData ( $sql );
			$temparr = array ();
			$PlayerIDArr = array ();
			
			foreach ( $Sessions as $item ) {
				$temparr [] = $item ['SessionID'];
				
				if (($item ['SessionType'] == 1 || $item ['SessionType'] == 10) && empty ( $item ['IpAddress'] )) {
					$PlayerIDArr [] = $item ['PlayerID'];
				}
			}
			if (! empty ( $PlayerIDArr )) {
				$sql = 'DELETE FROM Players where PlayerID IN(' . implode ( ",", $PlayerIDArr ) . ')';
				DBMethodUtils::RunSql ( $sql );
			}
			if (! empty ( $temparr )) {
				//删除整个任务
				TaskUtil::DeleteSessionByIDs ( implode ( ',', $temparr ) );
			}
		}
		$sql = "call sp_session_clean_up()";
		DBMethodUtils::RunSql ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '删除任务成功', null );
	}
	
	/**
	 * 播放任务
	 */
	public function actionPlaySession() {
		/*
		 [
		 {
		 "SessionID":"任务ID",
		 "ScheduleID":"播出时间ID,不传或为空表示没有时间限制"
		 }
		 ]
		 */
		$DataParam = $this->LoadDataParam ();
		
		if (empty ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//获取用户
		$UserId = $this->GetPostOwnerID ();
		//0 :停止, 1:播放，2：暂停
		$status = 1;
		//控制任务
		TaskUtil::CtrSession ( $UserId, $DataParam, $status );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '播出任务成功', null );
	}
	
	/**
	 * 暂停任务
	 */
	public function actionPasueSession() {
		/*
		 [
		 {
		 "SessionID":"任务ID",
		 "ScheduleID":"播出时间ID,不传或为空表示没有时间限制"
		 }
		 ]
		 */
		$DataParam = $this->LoadDataParam ();
		
		if (empty ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//获取用户
		$UserId = $this->GetPostOwnerID ();
		//0 :停止, 1:播放，2：暂停
		$status = 2;
		//控制任务
		TaskUtil::CtrSession ( $UserId, $DataParam, $status );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '任务暂停成功', null );
	}
	
	/**
	 * 停止任务
	 */
	public function actionStopSession() {
		
		/*
		 [
		 {
		 "SessionID":"任务ID",
		 "ScheduleID":"播出时间ID,不传或为空表示没有时间限制"
		 }
		 ]
		 */
		$DataParam = $this->LoadDataParam ();
		
		if (empty ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//获取用户
		$UserId = $this->GetPostOwnerID ();
		//0 :停止, 1:播放，2：暂停
		$status = 0;
		//控制任务
		TaskUtil::CtrSession ( $UserId, $DataParam, $status );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '任务停止成功', null );
	}
	
	/**
	 * 临时停播/取消临时停播
	 */
	public function actionTemporary() {
		
		/*
		 /*
		 [
		 {
		 "SessionID":"任务ID",
		 "ScheduleID":"播出时间ID",
		 "TempFlag" : "0:取消临时停闭，2：临时停播"
		 }
		 ]
		 */
		$UserId = $this->GetPostOwnerID ();
		
		if (! is_null ( $UserId ) && $UserId < 0) {
			//用户无效
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NEED_LOGIN, '还没有登陆，请确认！', null );
			return;
		}
		
		//参数内容
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam ) || count ( $DataParam ) <= 0) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		foreach ( $DataParam as $item ) {
			$TempFlag = $item ['TempFlag'];
			
			if ($TempFlag != 0 && $TempFlag != 2) {
				continue;
			}
			$sql = 'UPDATE PlaySessionTime SET TempFlag=:TempFlag WHERE ScheduleID=:ScheduleID AND SessionID=:SessionID';
			DBMethodUtils::RunSql ( $sql, array (':TempFlag' => $TempFlag, ':ScheduleID' => $item ['ScheduleID'], ':SessionID' => $item ['SessionID'] ) );
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '成功', null );
	}
	
	/**
	 * 加载实时采播配置
	 */
	public function actionLoadRealtimeConfig() {
		
		$DataParam = $this->LoadDataParam ();
		
		if (empty ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//获取用户
		$UserId = $this->GetPostOwnerID ();
		$SessionId = $this->GetDataParam ( $DataParam, 'SessionId', - 1, true );
		
		$sql = "SELECT * FROM PlaySessions WHERE SessionID = '" . $SessionId . "'";
		$Session = DBMethodUtils::findData ( $sql );
		
		if (empty ( $Session ) || empty ( $Session ['PlayerID'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '失败', null );
			return;
		}
		//加载播放器
		$sql = "SELECT * FROM Players WHERE PlayerID = '" . $Session ['PlayerID'] . "'";
		$Player = DBMethodUtils::findData ( $sql );
		
		if (empty ( $Player ) && $Player ['PlayerType'] != 1) {
			echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '失败', null );
			return;
		}
		//加载播放器按键设置
		$sql = "SELECT a.*, b.Name FROM PlayerKeys a
				LEFT JOIN DevClasses b ON a.GroupID = b.ClassID
				WHERE PlayerID = '" . $Session ['PlayerID'] . "'";
		$PlayerKeys = DBMethodUtils::listData ( $sql );
		
		$Out = array ();
		$Out ['SessionId'] = $SessionId; //任务id
		$Out ['Name'] = $Session ['SessionName']; //设备名称
		$Out ['Priority'] = $Session ['Priority']; //优先级
		$Out ['SteamTypeUp'] = 0;
		//		round ( $Session ['StreamType'] / 128 ); //1：强制，0：不强制
		

		if (($Session ['StreamType'] & 0x80) != 0) {
			$Out ['SteamTypeUp'] = 1;
		}
		//判断是否有分区
		$Out ['HasGroup'] = 1;
		
		if (substr ( $Session ['PlayerID'], 0, 2 ) == "38") {
			$Out ['HasGroup'] = 0;
		}
		//按键设置
		$Out ['Key_1'] = array ('Index' => 1, 'GroupID' => '', 'Name' => '' ); //按键1
		$Out ['Key_2'] = array ('Index' => 2, 'GroupID' => '', 'Name' => '' ); //按键2
		$Out ['Key_3'] = array ('Index' => 3, 'GroupID' => '', 'Name' => '' ); //按键3
		$Out ['Key_4'] = array ('Index' => 4, 'GroupID' => '', 'Name' => '' ); //按键4
		$Out ['Key_5'] = array ('Index' => 5, 'GroupID' => '', 'Name' => '' ); //按键5
		$Out ['Key_6'] = array ('Index' => 6, 'GroupID' => '', 'Name' => '' ); //按键6
		$Out ['Key_7'] = array ('Index' => 7, 'GroupID' => '', 'Name' => '' ); //按键7
		$Out ['Key_8'] = array ('Index' => 8, 'GroupID' => '', 'Name' => '' ); //按键8
		$Out ['Key_9'] = array ('Index' => 9, 'GroupID' => '', 'Name' => '' ); //按键9
		$Out ['Key_10'] = array ('Index' => 10, 'GroupID' => '', 'Name' => '' ); //按键10
		

		if (! empty ( $PlayerKeys )) {
			foreach ( $PlayerKeys as $item ) {
				$Id = $item ['PlayerKeyId'];
				$Index = $item ['Index'];
				$GroupID = $item ['GroupID'];
				$Name = $item ['Name'];
				
				if (isset ( $Out ['Key_' . $Index] )) {
					$Out ['Key_' . $Index] = array ('Index' => $Index, 'GroupID' => $GroupID, 'Name' => $Name );
				}
			}
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", $Out );
	}
	
	/**
	 * 更新实时采播配置
	 */
	public function actionUpdateRealtimeConfig() {
		
		$DataParam = $this->LoadDataParam ();
		
		if (empty ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		//获取用户
		$UserId = $this->GetPostOwnerID ();
		$SessionId = $this->GetDataParam ( $DataParam, 'SessionId', - 1, true ); //任务id
		$Name = $this->GetDataParam ( $DataParam, 'Name', '' ); //设备名称
		$Priority = $this->GetDataParam ( $DataParam, 'Priority', 0, true ); //优先级
		$SteamTypeUp = $this->GetDataParam ( $DataParam, 'SteamTypeUp', 0, true ); //1：强制，0：不强制
		

		//按键设置
		$Key_1 = $this->GetDataParam ( $DataParam, 'Key_1', 0, true ); //按键1
		$Key_2 = $this->GetDataParam ( $DataParam, 'Key_2', 0, true ); //按键2
		$Key_3 = $this->GetDataParam ( $DataParam, 'Key_3', 0, true ); //按键3
		$Key_4 = $this->GetDataParam ( $DataParam, 'Key_4', 0, true ); //按键4
		$Key_5 = $this->GetDataParam ( $DataParam, 'Key_5', 0, true ); //按键5
		$Key_6 = $this->GetDataParam ( $DataParam, 'Key_6', 0, true ); //按键6
		$Key_7 = $this->GetDataParam ( $DataParam, 'Key_7', 0, true ); //按键7
		$Key_8 = $this->GetDataParam ( $DataParam, 'Key_8', 0, true ); //按键8
		$Key_9 = $this->GetDataParam ( $DataParam, 'Key_9', 0, true ); //按键9
		$Key_10 = $this->GetDataParam ( $DataParam, 'Key_10', 0, true ); //按键10
		

		$sql = "SELECT * FROM PlaySessions WHERE SessionID = '" . $SessionId . "'";
		$Session = DBMethodUtils::findData ( $sql );
		
		if (empty ( $Session ) || empty ( $Session ['PlayerID'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '失败', null );
			return;
		}
		//加载播放器
		$sql = "SELECT * FROM Players WHERE PlayerID = '" . $Session ['PlayerID'] . "'";
		$Player = DBMethodUtils::findData ( $sql );
		
		if (empty ( $Player ) && $Player ['PlayerType'] != 1) {
			echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '失败', null );
			return;
		}
		//加载播放器按键设置
		$sql = "SELECT * FROM PlayerKeys WHERE PlayerID = '" . $Session ['PlayerID'] . "'";
		$PlayerKeys = DBMethodUtils::listData ( $sql );
		
		//更新任务信息
		//优先级
		$Priority = $Priority <= 0 ? 0 : $Priority;
		$Priority = $Priority >= 100 ? 100 : $Priority;
		
		//是否强制执行
		$StreamType = $Session ['StreamType'];
		
		if ($SteamTypeUp == 1) {
			$StreamType = $StreamType | 0x80;
		} else {
			$StreamType = $StreamType & ~ 0x80;
		}
		
		$SessionUpdateArr = array ();
		$SessionUpdateArr ['SessionName'] = $Name; //设备名称
		$SessionUpdateArr ['Priority'] = $Priority; //优先级
		$SessionUpdateArr ['StreamType'] = $StreamType;
		
		PlaySessions::model ()->updateByPk ( $SessionId, $SessionUpdateArr );
		
		//处理按键设置
		//已有的按键信息
		$HadMap = array ();
		
		if (! empty ( $PlayerKeys )) {
			foreach ( $PlayerKeys as $item ) {
				$HadMap [$item ['Index']] = $item;
			}
		}
		$IdArr = array ();
		$IdArr [] = ATaskUtil::upadteRealtimePlayerKey ( $Session ['PlayerID'], 1, $Key_1, $HadMap );
		$IdArr [] = ATaskUtil::upadteRealtimePlayerKey ( $Session ['PlayerID'], 2, $Key_2, $HadMap );
		$IdArr [] = ATaskUtil::upadteRealtimePlayerKey ( $Session ['PlayerID'], 3, $Key_3, $HadMap );
		$IdArr [] = ATaskUtil::upadteRealtimePlayerKey ( $Session ['PlayerID'], 4, $Key_4, $HadMap );
		$IdArr [] = ATaskUtil::upadteRealtimePlayerKey ( $Session ['PlayerID'], 5, $Key_5, $HadMap );
		$IdArr [] = ATaskUtil::upadteRealtimePlayerKey ( $Session ['PlayerID'], 6, $Key_6, $HadMap );
		$IdArr [] = ATaskUtil::upadteRealtimePlayerKey ( $Session ['PlayerID'], 7, $Key_7, $HadMap );
		$IdArr [] = ATaskUtil::upadteRealtimePlayerKey ( $Session ['PlayerID'], 8, $Key_8, $HadMap );
		$IdArr [] = ATaskUtil::upadteRealtimePlayerKey ( $Session ['PlayerID'], 9, $Key_9, $HadMap );
		$IdArr [] = ATaskUtil::upadteRealtimePlayerKey ( $Session ['PlayerID'], 10, $Key_10, $HadMap );
		
		//删除不用的按键
		$sql = "DELETE FROM PlayerKeys WHERE PlayerKeyId NOT IN(" . implode ( ",", $IdArr ) . ")";
		DBMethodUtils::RunSql ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, "", null );
	}
}	
