<?php
/*************************************************
 * 模块描述：
 * 定义用户相关的API
 ************************************************/
class UserController extends WebAdminBaseController {
	
	/**
	 * 创建SESSION ID
	 * @param $UserID
	 * @return type
	 */
	public function CreateSessionID($UserID) {
		
		$session = md5 ( time () . '_' . $UserID );
		
		return $session;
	}
	
	/**
	 * 创建SESSION ID
	 * @param $UserID
	 * @return type
	 */
	public function CreateSignKey($UserID) {
		
		$SignKey = md5 ( time () . '_' . $UserID . '_' . time () );
		
		return $SignKey;
	}
	///////////////////////////////////////////////////////////////////////////////
	

	/**
	 * 获取用户列表信息，但不包含管理员 
	 */
	public function actionListUsers() {
		
		$sql = "select User_ID, User_Name, User_Desc from Users where User_ID >0";
		$result = DBMethodUtils::listData ( $sql );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $result );
	}
	
	/**
	 * 修改登陆密码
	 */
	public function actionModifyPwd() {
		
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$UserID = $this->GetPostOwnerID ();
		
		if (is_null ( $UserID )) {
			$UserID = 0;
		}
		//通过原始密码修改
		if (! isset ( $DataParam ['OldPwd'] ) || ! isset ( $DataParam ['NewPwd'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$sql = 'SELECT * FROM Users WHERE User_ID=' . $DataParam ['UserID'] . ' AND Pass_Word=PASSWORD("' . $DataParam ['OldPwd'] . '")';
		$User = DBMethodUtils::findData ( $sql );
		
		if (is_null ( $User ) || ! isset ( $User ['User_ID'] )) { //密码错误
			echo $this->PackResponseData ( ErrcodeUtil::$USER_PASSWORD_ERR, '原始密码错误，请请确认', null );
			return;
		}
		//可以修改
		$sql = 'UPDATE Users SET Pass_Word=PASSWORD("' . $DataParam ['NewPwd'] . '") WHERE User_ID=' . $DataParam ['UserID'];
		$code = DBMethodUtils::RunSql ( $sql );
		
		$sql = 'SELECT * FROM Users WHERE User_ID=' . $DataParam ['UserID'] . ' AND Pass_Word=PASSWORD("' . $DataParam ['NewPwd'] . '")';
		$User = DBMethodUtils::findData ( $sql );
		
		if (! is_null ( $User )) {
			echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '修改成功，请重新登录', null );
		} else {
			echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '修改失败', null );
		}
	}
	
	/**
	 * 编辑用户信息，添加/修改  TODO 本次不做 2015-11-16
	 */
	public function actionEditUser() {
	
	}
	
	/**
	 * 删除用户  TODO 本次不做 2015-11-16
	 */
	public function actionDeleteUser() {
	
	}
	
	/**
	 * 编辑基本信息
	 */
	public function actionEditBaseInfo() {
	
	}
	
	/**
	 * 编辑扩展设备信息
	 */
	public function actionEditRfDevice() {
	
	}
	
	/**
	 * 清除日志
	 */
	public function actionClearLog() {
	
	}
	
	/***************************************************************************************/
	public function actionTest() {
		
		$sql = "SELECT * FROM Users WHERE User_Name='jwc' AND Pass_Word = PASSWORD('admin')";
		$user = DBMethodUtils::findData ( $sql );
		
		if (is_null ( $user )) {
			$result ['Status'] = 0;
			$result ['Desc'] = '账号或密码不正确';
		} else {
			$result ['Status'] = 1;
			$result ['Desc'] = CJSON::encode ( $user );
			
			$privilege = $user ['privilege'];
			echo '<br/>Device : ' . ($privilege & 1);
			echo '<br/>Session : ' . ($privilege & 256);
			echo '<br/>ReDevice : ' . ($privilege & 65536);
			echo "<br/>";
			//需要把用户的信息
			CacheUtil::SetCache ( $user ['User_Name'], CJSON::encode ( $user ) );
			//			Yii::app ()->session [$user ['User_Name']] = CJSON::encode ( $user );
			echo $user ['User_Name'];
			echo "<br/>";
			echo CacheUtil::GetCache ( $user ['User_Name'] );
		
		//			echo Yii::app ()->session [$user ['User_Name']];
		}
	}
	
	public function actionTestEcho() {
		
		//		//需要把用户的信息
		//		echo Yii::app ()->session ["admin"];
		//		echo "<br/>";
		//		echo Yii::app ()->session ["jwc"];
		

		echo 'admin_' . CacheUtil::GetCache ( "admin" );
		echo "<br/>";
		echo 'jwc_' . CacheUtil::GetCache ( "jwc" );
	
		//		unset ( Yii::app ()->session ["admin"] );
	}
	
	///////////////////////////////////////////////////////////////////////////////////////////////
	/**
	 * 用户登陆
	 */
	public function actionLogin() {
		
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$DataParam = CJSON::decode ( $_POST ['DataParam'] );
		
		if (is_null ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		
		if (empty ( $DataParam ['Username'] ) || empty ( $DataParam ['Password'] )) {
			//没有上传用户名或则密码,登陆失败
			echo $this->PackResponseData ( ErrcodeUtil::$USER_LOGIN_PWDUSER_ISNULL, '登陆账号和密码不能为空，请确认！', null );
			return;
		}
		$username = $DataParam ['Username'];
		$password = $DataParam ['Password'];
		
		if (is_null ( $username ) || "" == trim ( $username ) || is_null ( $password ) || "" == trim ( $password )) {
			//没有上传用户名或则密码,登陆失败
			echo $this->PackResponseData ( ErrcodeUtil::$USER_LOGIN_PWDUSER_ISNULL, '登陆账号和密码不能为空，请确认！', null );
			return;
		}
		$sql = "SELECT * FROM Users WHERE User_Name=:UserName AND Pass_Word = PASSWORD(:password)";
		$user = DBMethodUtils::findData ( $sql, array ("UserName" => $username, 'password' => $password ) );
		
		if (is_null ( $user )) {
			echo $this->PackResponseData ( ErrcodeUtil::$USER_LOGIN_PWDUSER_WRONG, '登陆账号或密码错误，请确认！', null );
			return;
		}
		$user ['Session'] = $this->CreateSessionID ( $user ['User_ID'] );
		$user ['SignKey'] = $this->CreateSignKey ( $user ['User_ID'] );
		$user ['Ip'] = ToolUtil::GetClientIp ();
		
		//需要保存用户的信息
		CacheUtil::SetCache ( CacheUtil::$WEB_USER_CACHE_ID . $user ['User_ID'], $user );
		
		$resuser = array ('User_ID' => "" . $user ['User_ID'], 'User_Name' => $user ['User_Name'], 'privilege' => "" /*. $user ['privilege']*/, 'IcCard' => is_null ( $user ['IcCard'] ) ? '' : $user ['IcCard'], 'Session' => $user ['Session'], 'SignKey' => $user ['SignKey'], 'LanIp' => ToolUtil::GetMyIp () );
		$lang = ToolUtil::WriteOrReadLanguage ( '', $user ['User_ID'], true );
		
		if (empty ( $DataParam ['Language'] )) {
			//初始化语言
			Yii::app ()->language = $lang;
		} else {
			Yii::app ()->language = $lang;
		}
		//加载权限
		$resuser ['Permission'] = $this->LoadPermission ( $user ['User_ID'] );
		//当前使用语言
		$resuser ['Language'] = $lang;
		
		if ($resuser ['Permission'] ['IsAdmin'] != 1 && $resuser ['Permission'] ['DevCtrPermission'] != 1 && $resuser ['Permission'] ['RfDevCtrPermission'] != 1 && $resuser ['Permission'] ['BroadcastPermission'] != 1 && $resuser ['Permission'] ['ICPermission'] != 1 && $resuser ['Permission'] ['ScanPermission'] != 1) {
			echo $this->PackResponseData ( ErrcodeUtil::$USER_NO_PERMISSION, '', null );
			return;
		}
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $resuser );
	}
	
	/**
	 * 加载个人信息
	 */
	public function actionLoadUserInfo() {
		
		$UserId = $this->GetPostOwnerID ();
		
		if (is_null ( $UserId )) {
			$UserId = 0;
		}
		$Sql = "SELECT * FROM Users WHERE User_ID = '" . $UserId . "'";
		$Res = DBMethodUtils::findData ( $Sql );
		
		if (empty ( $Res )) {
			echo $this->PackResponseData ( ErrcodeUtil::$FAILED, '', null );
			return;
		}
		$Out = array ();
		$Out ['UserName'] = $Res ['User_Name']; //登录名
		$Out ['UserDesc'] = ""; //姓名
		$Out ['IcCard'] = ""; //IC卡号
		$Out ['UserSn'] = ""; //学工号
		$Out ['Phone'] = ""; //电话
		$Out ['IsAdmin'] = $UserId == 0 ? "1" : "0"; //是否是管理员
		

		//		if ($UserId != 0) {
		$Out ['UserName'] = $Res ['User_Name'];
		$Out ['UserDesc'] = $Res ['User_Desc'];
		$Out ['IcCard'] = $Res ['IcCard'];
		$Out ['UserSn'] = $Res ['User_Sn'];
		$Out ['Phone'] = $Res ['Phone'];
		//		}
		

		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $Out );
	}
	
	/**
	 * 修改个人信息
	 */
	public function actionUpdateUserInfo() {
		
		////////////////////////////////////////////////////////
		//admin用户可以修改：姓名、IC卡号、学工号、电话号码、密码
		//普通用户可以修改：登录密码
		///////////////////////////////////////////////////////
		$DataParam = $this->LoadDataParam ();
		
		if (empty ( $DataParam )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$UserId = $this->GetPostOwnerID (); //用户id
		

		if (is_null ( $UserId )) {
			$UserId = 0;
		}
		$UserName = $this->GetDataParam ( $DataParam, 'UserName', '' ); //姓名
		$UserDesc = $this->GetDataParam ( $DataParam, 'UserDesc', '' ); //姓名
		$IcCard = $this->GetDataParam ( $DataParam, 'IcCard', '' ); //IC卡号
		$UserSn = $this->GetDataParam ( $DataParam, 'UserSn', '' ); //学工号
		$Phone = $this->GetDataParam ( $DataParam, 'Phone', '' ); //电话
		$Password = $this->GetDataParam ( $DataParam, 'Password', '' ); //登录密码
		$NewPwd = $this->GetDataParam ( $DataParam, 'NewPwd', '' ); //新密码
		

		if ($UserId > 0) { //普通用户，只能修改密码
			if (empty ( $NewPwd )) { //新密码不能为空，TODO
				echo $this->PackResponseData ( ErrcodeUtil::$USER_PASSWORD_NEW_ISNULL, '新密码不能为空', null );
				return;
			}
		}
		
		if (! empty ( $NewPwd )) { //说明要修改密码
			//校验原始密码是否正确
			$sql = "SELECT * FROM Users WHERE User_ID=:User_ID AND Pass_Word = PASSWORD(:Password)";
			$Res = DBMethodUtils::findData ( $sql, array (':User_ID' => $UserId, ':Password' => $Password ) );
			
			if (empty ( $Res )) { //原始密码错误 TODO
				echo $this->PackResponseData ( ErrcodeUtil::$USER_PASSWORD_OLD_ERR, '原始密码错误', null );
				return;
			}
		}
		$SetArr = array ();
		$ParamArr = array ();
		
		if ($UserId == 0) { //admin，需要判断学工号、IC卡号是否唯一
			//需要校验工号是否存在
			if (ASysUtil::JudgeUserSn ( $UserId, $UserSn )) { //说明学工号存在
				echo $this->PackResponseData ( ErrcodeUtil::$USER_USER_SN_EXIST, '学工号已经存在', null );
				return;
			}
			//校验IC卡是否存在
			if (ASysUtil::JudgeIcCard ( $UserId, $IcCard )) { //说明IC卡存在
				echo $this->PackResponseData ( ErrcodeUtil::$USER_ICCARD_EXIST, 'IC卡已经存在', null );
				return;
			}
			$SetArr [] = 'User_Desc = :User_Desc';
			$SetArr [] = 'IcCard = :IcCard';
			$SetArr [] = 'User_Sn = :User_Sn';
			$SetArr [] = 'Phone = :Phone';
			
			$ParamArr [':User_Desc'] = $UserDesc;
			$ParamArr [':IcCard'] = $IcCard;
			$ParamArr [':User_Sn'] = $UserSn;
			$ParamArr [':Phone'] = $Phone;
		}
		$sql = 'UPDATE Users SET ' . implode ( ",", $SetArr );
		
		if (! empty ( $NewPwd )) { //说明要修改密码
			$ParamArr [':NewPwd'] = $NewPwd;
			
			if (! empty ( $SetArr )) {
				$sql .= ', Pass_Word = PASSWORD(:NewPwd)';
			} else {
				$sql .= 'Pass_Word = PASSWORD(:NewPwd)';
			}
		}
		$sql .= ' WHERE User_ID = :User_ID';
		$ParamArr [':User_ID'] = $UserId;
		DBMethodUtils::RunSql ( $sql, $ParamArr );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', null );
	}
	
	/**
	 * 加载用户权限
	 */
	public function actionLoadPermission() {
		
		if (! isset ( $_POST ['DataParam'] )) {
			echo $this->PackResponseData ( ErrcodeUtil::$PARAM_ERR, '参数异常', null );
			return;
		}
		$UserId = $this->GetPostOwnerID ();
		$UserId = is_null ( $UserId ) ? 0 : $UserId;
		
		$sql = "SELECT * FROM Users WHERE User_ID=:User_ID";
		$user = DBMethodUtils::findData ( $sql, array (":User_ID" => $UserId ) );
		
		$resuser = array ();
		
		if (! empty ( $user )) {
			$resuser ['User_ID'] = $user ['User_ID'];
			$resuser ['User_Name'] = $user ['User_Name'];
			$resuser ['IcCard'] = is_null ( $user ['IcCard'] ) ? '' : $user ['IcCard'];
		}
		//加载权限
		$resuser ['Permission'] = $this->LoadPermission ( $UserId );
		
		echo $this->PackResponseData ( ErrcodeUtil::$SUCCESS, '', $resuser );
	}
}