<?php
class AMediaUtil {
	
	//菜单类型
	const MENU_TYPE_MEDIA = 1; // 媒体资源
	const MENU_TYPE_USER = 2; // 用户文件
	

	//文件类型
	const MediaImageIndexCelt = 0; //音频
	const MediaImageIndexAudio = 1; //音频（暂时不知和0的区别）
	const MediaImageIndexVedio = 2; //视频
	const MediaImageIndexUrl = 3; //节目源
	const MediaImageIndexGroup = 4; //文件夹
	
	/**
	 * 获取用户文件夹跟目录
	 */
	public static function LoadUserFolder() {
		
		$UserFolder = MediaFiles::model ()->findBySql ( 'SELECT * FROM MediaFiles WHERE ISNULL(Owner) AND Sysfolder = 2' );
		
		if (empty ( $UserFolder )) { //这里需要新建一条记录
			$UserFolder = new MediaFiles ();
			$UserFolder->FileName = "用户文件";
			$UserFolder->FileSize = 0;
			$UserFolder->TotalTime = 0;
			$UserFolder->FileFmt = 0;
			$UserFolder->BitRate = 0;
			$UserFolder->VedioCodec = 0;
			$UserFolder->Height = 0;
			$UserFolder->Width = 0;
			$UserFolder->FrameRate = 0;
			$UserFolder->AudioCodec = 0;
			$UserFolder->Channels = 0;
			$UserFolder->SampleRate = 0;
			$UserFolder->Gain = 0;
			$UserFolder->Sysfolder = 2;
			
			if (! $UserFolder->save ()) {
				return null;
			}
		}
		
		return $UserFolder;
	}
	
	/**
	 * 获取一个普通用户的文件夹
	 */
	public static function LoadUserOneFolder($UserId, $Parent) {
		
		$UserOneFolder = MediaFiles::model ()->findBySql ( 'SELECT * FROM MediaFiles WHERE Owner="' . $UserId . '" AND Sysfolder = 1 AND Parent = "' . $Parent . '"' );
		
		if (empty ( $UserOneFolder )) {
			//TODO 需要考虑是否需要新建实体文件夹
			$Name = "";
			$User = Users::model ()->findByPk ( $UserId );
			
			if (! empty ( $User )) {
				$Name = $User->User_Name;
			}
			$UserOneFolder = new MediaFiles ();
			$UserOneFolder->FileName = $Name;
			$UserOneFolder->FileSize = 0;
			$UserOneFolder->TotalTime = 0;
			$UserOneFolder->FileFmt = 0;
			$UserOneFolder->BitRate = 0;
			$UserOneFolder->VedioCodec = 0;
			$UserOneFolder->Height = 0;
			$UserOneFolder->Width = 0;
			$UserOneFolder->FrameRate = 0;
			$UserOneFolder->AudioCodec = 0;
			$UserOneFolder->Channels = 0;
			$UserOneFolder->SampleRate = 0;
			$UserOneFolder->Parent = $Parent;
			$UserOneFolder->Gain = 0;
			$UserOneFolder->Owner = $UserId;
			$UserOneFolder->Sysfolder = 1;
			
			if (! $UserOneFolder->save ()) {
				return null;
			}
		}
		
		return $UserOneFolder;
	}
	
	/**
	 * 删除文件及目录
	 * @param  $UserId
	 * @param  $FileId
	 */
	public static function DeleteFiles($UserId, $FileId) {
		
		//获取子文件
		$Sql = 'SELECT * FROM MediaFiles WHERE Parent = "' . $FileId . '"';
		$Res = MediaFiles::model ()->findAllBySql ( $Sql, array (':Parent' => $FileId ) );
		$DeleteParentFlag = true;
		
		if (! empty ( $Res )) {
			foreach ( $Res as $Item ) {
				//删除子目录
				$TempFlag = AMediaUtil::DeleteFiles ( $UserId, $Item->MediaID );
				
				if (! $TempFlag) { //当前目录不能删除
					$DeleteParentFlag = false;
					continue;
				}
				
				if (! is_null ( $UserId ) && $Item->Owner != $UserId) { //普通用户，且不是自己新建的文件夹；不能删除
					$DeleteParentFlag = false;
					continue;
				}
				//删除文件
				$Sql = 'call sp_del_media_file( ' . (is_null ( $UserId ) ? 0 : $UserId) . ' , ' . $Item->MediaID . ')';
				DBMethodUtils::RunSql ( $Sql );
				//删除成功，需要删除对应的文件
				$TempItem = MediaFiles::model ()->findByPk ( $Item->MediaID );
				
				if (! empty ( $TempItem )) {
					$DeleteParentFlag = false;
					continue;
				}
				if (file_exists ( $Item->FilePath )) {
					unlink ( $Item->FilePath );
				}
			}
		}
		
		if ($DeleteParentFlag) {
			$File = MediaFiles::model ()->findByPk ( $FileId );
			
			if (empty ( $File )) {
				return true;
			}
			//删除文件
			$Sql = 'call sp_del_media_file( ' . (is_null ( $UserId ) ? 0 : $UserId) . ' , ' . $File->MediaID . ')';
			DBMethodUtils::RunSql ( $Sql );
			//删除成功，需要删除对应的文件
			$TempItem = MediaFiles::model ()->findByPk ( $File->MediaID );
			
			if (! empty ( $TempItem )) {
				return false;
			}
			
			if (file_exists ( $File->FilePath )) {
				unlink ( $File->FilePath );
			}
			
			return true;
		}
		
		return false;
	}
	
	/**
	 * 获取文件父目录
	 * @param $FileId
	 */
	public static function LoadParent($UserId, $FileId) {
		
		$Out = array ();
		
		$File = MediaFiles::model ()->findByPk ( $FileId );
		
		if (! empty ( $File )) {
			return $File->MediaID;
		}
		
		return 0;
	}
	
	/**
	 * 获取子目录
	 * @param $Parent
	 */
	public static function LoadChildren($Parent, $Type) {
		
		$Sql = 'SELECT MediaID as id, FileName as text, IF(ISNULL(Parent), 0, Parent) AS Parent, :Type AS Type, "closed" AS state FROM MediaFiles WHERE TotalTime = 0 AND Parent= :Parent';
		$Out = DBMethodUtils::listData ( $Sql, array (':Type' => $Type, ':Parent' => $Parent ) );
		
		if (empty ( $Out )) {
			$Out = array ();
		}
		foreach ( $Out as $key => $value ) {
			$TempData = AMediaUtil::LoadChildren ( $value ['id'], $Type );
			$Out [$key] ['children'] = $TempData;
			
			if (empty ( $Out [$key] ['children'] )) {
				unset ( $Out [$key] ['state'] );
			}
		}
		
		return $Out;
	}
	
	/**
	 * 
	 * Enter description here ...
	 * @param unknown_type $Stream
	 * @param unknown_type $Key
	 */
	public static function GetStreamValue($Stream, $Key) {
		
		if (empty ( $Stream )) {
			return 0;
		}
		
		return isset ( $Stream [$Key] ) ? $Stream [$Key] : 0;
	}
	
	/**
	 * 
	 * Enter description here ...
	 * @param unknown_type $UserId
	 * @param unknown_type $Parent
	 */
	public static function getParent($UserId, $Parent) {
		
		if (empty ( $Parent ) || $Parent <= 0) {
			if (is_null ( $UserId )) { //系统管理员
				$Parent = null;
				$Owner = null;
			} else { //普通用户
				$Sql = 'SELECT * FROM MediaFiles WHERE Owner = "' . $UserId . '" AND Parent IN(SELECT MIN(Parent) FROM MediaFiles WHERE Owner = "' . $UserId . '")';
				$TempData = DBMethodUtils::findData ( $Sql );
				
				if (! empty ( $TempData )) {
					$Parent = $TempData ['MediaID'];
				} else { //没有父目录需要新建一个
					$Parent = null;
					$Owner = null;
					//获取用户文件目录
					$Sql = 'SELECT * FROM MediaFiles WHERE (ISNULL(Parent) OR LENGTH(Parent) <= 0) AND Sysfolder=2';
					$Sysfolder = DBMethodUtils::findData ( $Sql );
					
					if (empty ( $Sysfolder )) {
						$Sysfolder = new MediaFiles ();
						$Sysfolder->FileName = '用户文件夹';
						$Sysfolder->FileSize = 0;
						$Sysfolder->TotalTime = 0;
						$Sysfolder->FileFmt = 0;
						$Sysfolder->BitRate = 0;
						$Sysfolder->VedioCodec = 0;
						$Sysfolder->Height = 0;
						$Sysfolder->Width = 0;
						$Sysfolder->FrameRate = 0;
						$Sysfolder->AudioCodec = 0;
						$Sysfolder->Channels = 0;
						$Sysfolder->SampleRate = 0;
						$Sysfolder->Parent = null;
						$Sysfolder->Gain = 0;
						$Sysfolder->CreateTime = date ( 'Y-m-d H:i:s' );
						$Sysfolder->FilePath = "";
						$Sysfolder->Owner = null;
						$Sysfolder->Sysfolder = 2;
						
						if ($Sysfolder->save ()) {
							$Parent = $Sysfolder->MediaID;
							$Owner = $UserId;
						}
					}
					//获取用户信息
					$User = Users::model ()->findByPk ( $UserId );
					
					if (! empty ( $User ) && ! empty ( $Parent )) {
						$model = new MediaFiles ();
						$model->FileName = $User->User_Name;
						$model->FileSize = 0;
						$model->TotalTime = 0;
						$model->FileFmt = 0;
						$model->BitRate = 0;
						$model->VedioCodec = 0;
						$model->Height = 0;
						$model->Width = 0;
						$model->FrameRate = 0;
						$model->AudioCodec = 0;
						$model->Channels = 0;
						$model->SampleRate = 0;
						$model->Parent = $Parent;
						$model->Gain = 0;
						$model->CreateTime = date ( 'Y-m-d H:i:s' );
						$model->FilePath = "";
						$model->Owner = $Owner;
						$model->Sysfolder = 1;
						
						$Parent = null;
						$Owner = null;
						
						if ($model->save ()) {
							$Parent = $model->MediaID;
							$Owner = $UserId;
						}
					}
				}
			}
		}
		
		return $Parent;
	}
	
	/**
	 * 加载二级菜单
	 * @param  $UserId
	 * @param  $Type
	 */
	public static function ListSecondMenu($UserId, $Type) {
		
		if (! in_array ( $Type, array (AMediaUtil::MENU_TYPE_MEDIA, AMediaUtil::MENU_TYPE_USER ) )) {
			return array ();
		}
		
		if (! is_null ( $UserId ) && $Type != AMediaUtil::MENU_TYPE_MEDIA) {
			return array ();
		}
		//获取资源文件
		if (is_null ( $UserId )) { //超级管理员，获取超级文件夹
			$Sql = 'SELECT MediaID as id, FileName as text, IF(ISNULL(Parent), 0, Parent) AS Parent, "' . $Type . '" AS Type, "closed" AS state FROM MediaFiles WHERE TotalTime = 0';
			
			if ($Type == AMediaUtil::MENU_TYPE_MEDIA) { //系统文件夹
				$Sql .= ' AND ISNULL(Owner) AND ISNULL(Sysfolder)';
				$Sql .= ' AND (ISNULL(Parent) OR LENGTH(Parent) <= 0)';
			} else if ($Type == AMediaUtil::MENU_TYPE_USER) { //用户文件夹
				$Sql .= ' AND NOT ISNULL(Owner) AND NOT ISNULL(Sysfolder)';
				$Sql .= ' AND Parent IN (SELECT MIN(Parent) FROM MediaFiles WHERE TotalTime = 0 AND NOT ISNULL(Owner) AND NOT ISNULL(Sysfolder))';
			}
			$Res = DBMethodUtils::listData ( $Sql );
			
			if (empty ( $Res )) {
				$Res = array ();
			}
			foreach ( $Res as $key => $Item ) {
				$Res [$key] ['children'] = AMediaUtil::LoadChildren ( $Item ['id'], $Type );
				
				if (empty ( $Res [$key] ['children'] )) {
					unset ( $Res [$key] ['state'] );
				}
			}
			
			return $Res;
		} else { //普通用户，只能查看自己的文件目录
			$Sql = 'SELECT MediaID as id, FileName as text, IF(ISNULL(Parent), 0, Parent) AS Parent, "' . $Type . '" AS Type, "closed" AS state FROM MediaFiles WHERE TotalTime = 0 AND Owner="' . $UserId . '"';
			$Sql .= ' AND Parent IN (SELECT MIN(Parent) FROM MediaFiles WHERE TotalTime = 0 AND Owner="' . $UserId . '")';
			$Res = DBMethodUtils::listData ( $Sql );
			
			if (empty ( $Res )) {
				$Res = array ();
			}
			$OutRes = array ();
			
			foreach ( $Res as $key => $Item ) {
				$tempArr = AMediaUtil::LoadChildren ( $Item ['id'], $Type );
				
				if (! empty ( $tempArr )) {
					$OutRes = array_merge ( $OutRes, $tempArr );
				}
			}
			$Res = $OutRes;
			
			return $Res;
		}
	}
}