<?php
class ASysDevUtil {
	
	/**
	 * 加载基本信息
	 */
	public static function loadBaseInfo() {
		
		$sql = "SELECT * FROM BaseInfo";
		$Res = DBMethodUtils::listData ( $sql );
		
		$out = array ();
		$out ['SchoolName'] = ''; //组织名字
		$out ['ModeOne'] = ''; //模式1
		$out ['ModeTwo'] = ''; //模式2
		$out ['ModeThree'] = ''; //模式3
		$out ['ModeFour'] = ''; //模式4
		

		$newLang = '';
		
		if (isset ( $_POST ['Lang'] )) {
			$newLang = $_POST ['Lang'];
		}
		
		if (! empty ( $Res )) {
			foreach ( $Res as $item ) {
				if (in_array ( $item ['InfomationID'], array (1, 2, 3, 4 ) )) {
					if ("zh_cn" != $newLang) { //非中文
						if ($item ['Description'] == "模式1") {
							$item ['Description'] = "Mode 1";
						} else if ($item ['Description'] == "模式2") {
							$item ['Description'] = "Mode 2";
						} else if ($item ['Description'] == "模式3") {
							$item ['Description'] = "Mode 3";
						} else if ($item ['Description'] == "模式4") {
							$item ['Description'] = "Mode 4";
						}
					}
				}
				switch ($item ['InfomationID']) {
					case 0 : //组织名字
						$out ['SchoolName'] = $item ['Description'];
						break;
					case 1 : //模式1
						$out ['ModeOne'] = $item ['Description'];
						break;
					case 2 : //模式2
						$out ['ModeTwo'] = $item ['Description'];
						break;
					case 3 : //模式3
						$out ['ModeThree'] = $item ['Description'];
						break;
					case 4 : //模式4
						$out ['ModeFour'] = $item ['Description'];
						break;
					default :
						break;
				}
			}
		}
		
		return $out;
	}
	
	/**
	 * 删除设备分组
	 * @param $DevClassId
	 */
	public static function deleteDevClass($DevClassId) {
		
		if (empty ( $DevClassId ) && is_numeric ( $DevClassId )) {
			return false;
		}
		//获取分区子节点
		$sql = "SELECT * FROM DevClasses WHERE Parent = '" . $DevClassId . "'";
		$Children = DBMethodUtils::listData ( $sql );
		
		if (! empty ( $Children )) {
			foreach ( $Children as $item ) {
				ASysDevUtil::deleteDevClass ( $item ['ClassID'] );
			}
		}
		//设置设备分区id空
		$sql = "UPDATE DeviceList SET Parent = NULL WHERE Parent = '" . $DevClassId . "'";
		DBMethodUtils::RunSql ( $sql );
		
		//删除分区
		$sql = "DELETE FROM DevClasses WHERE ClassID = '" . $DevClassId . "'";
		DBMethodUtils::RunSql ( $sql );
		
		return true;
	}
	
	/**
	 * 更新设备分区
	 * @param  $ParentId
	 * @param  $DeviceTree
	 */
	public static function UpdateDeviceClass($ParentId, $DeviceTree) {
		
		$ClassIdArr = array ();
		
		if (empty ( $DeviceTree )) {
			return $ClassIdArr;
		}
		foreach ( $DeviceTree as $item ) {
			$id = DataUtil::GetValueFromArr ( $item, "id", "" );
			$text = DataUtil::GetValueFromArr ( $item, "text", "" );
			$isDevice = DataUtil::GetValueFromArr ( $item, "IsDevice", 0, true );
			$children = DataUtil::GetValueFromArr ( $item, "children", null );
			
			if ($isDevice == "1") { //设备，只需要更新设备的父节点就可以
				$sql = "UPDATE DeviceList SET Parent = :Parent WHERE DevID = :DevID";
				DBMethodUtils::RunSql ( $sql, array (':Parent' => $ParentId, ':DevID' => $id ) );
			} else { //分组，需要判断分组是否存在，不存在则需要新建;还需要处理分组下的子节点数据
				$Class = DevClasses::model ()->findByPk ( $id );
				
				if (empty ( $Class )) {
					$Class = new DevClasses ();
				}
				$Class->Name = $text;
				$Class->Parent = $ParentId;
				
				if ($Class->save ()) {
					$ClassIdArr [] = $Class->ClassID;
					
					if (! empty ( $children )) {
						$tempArr = ASysDevUtil::UpdateDeviceClass ( $Class->ClassID, $children );
						
						$ClassIdArr = array_merge ( $ClassIdArr, $tempArr );
					}
				}
			}
		}
		
		return $ClassIdArr;
	}
}