<?php
class ASysTaskUtil {
	
	/**
	 * 获取模式列表
	 * @param  $Enabled 1：运行模式，0：备用模式
	 * @param  $Start
	 * @param  $Size
	 * @param  $Sort
	 * @param  $Order
	 */
	public static function ListMode($Enabled, $Start, $Size, $Sort, $Order) {
		
		$sql = "SELECT idBroadcastMode AS id, ModeName AS Name, Priority, DATE_FORMAT(StartTime, '%H:%i:%s') AS StartTime, 
			DATE_FORMAT(StopTime, '%H:%i:%s') AS StopTime, TimeStyle, Active, DATE_FORMAT(StartTime, '%Y-%m-%d') AS UseDate, 
			IF(ISNULL(TaskCount), 0, TaskCount) AS TaskCount FROM BroadcastMode a
			LEFT JOIN (SELECT COUNT(*) AS TaskCount, BrdMode FROM PlaySessions GROUP BY BrdMode) b ON a.idBroadcastMode = b.BrdMode 
			WHERE Enabled = " . (is_numeric($Enabled) ? $Enabled : 0);
		
		//获取总数
		$CountSql = "SELECT COUNT(*) c FROM (" . $sql . ") cc";
		$AllCount = 0;
		$AllCountData = DBMethodUtils::findData ( $CountSql );
		
		if (! empty ( $AllCountData ['c'] )) {
			$AllCount = $AllCountData ['c'];
		}
		//排序
		if (! empty ( $Sort ) && ! empty ( $Order )) {
			if ("DESC" == strtoupper ( $Order )) {
				$Order = "DESC";
			} else {
				$Order = "ASC";
			}
			if ("id" == $Sort) {
				$sql .= " ORDER BY idBroadcastMode " . $Order;
			} else if ("Name" == $Sort) {
				$sql .= " ORDER BY Name " . $Order;
			} else if ("Priority" == $Sort) {
				$sql .= " ORDER BY Priority " . $Order;
			} else if ("Active" == $Sort) {
				$sql .= " ORDER BY Active " . $Order;
			} else if ("StartTime" == $Sort) {
				$sql .= " ORDER BY DATE_FORMART(StartTime, '%H:%i:%s') " . $Order;
			} else if ("StopTime" == $Sort) {
				$sql .= " ORDER BY DATE_FORMART(StopTime, '%H:%i:%s') AS StopTime " . $Order;
			} else if ("TimeStyle" == $Sort) {
				$sql .= " ORDER BY TimeStyle " . $Order;
			}
		}
		//分页
		if (is_numeric ( $Start ) && $Start >= 0 && is_numeric ( $Size ) && $Size > 0) {
			$sql .= " LIMIT " . $Start . "," . $Size;
		}
		$Rows = DBMethodUtils::listData ( $sql );
		$OutRows = array ();
		$ss = array();
		
		if (! empty ( $Rows )) {
			foreach ( $Rows as $item ) {
				if ($item ['TimeStyle'] == 0) { //指定日期
					$item ['TimeStyle'] = $item ['UseDate'];
				} else { //按周重复
					$TimeStyleArr = array();
					
					if (($item ['TimeStyle'] & 1 ) > 0) {
						$TimeStyleArr[] =LanguageUtil::getCommonStr ( 'week_0' );
					}
					if (($item ['TimeStyle'] & 2 ) > 0) {
						$TimeStyleArr[] =LanguageUtil::getCommonStr ( 'week_1' );
					}
					if (($item ['TimeStyle'] & 4 ) > 0) {
						$TimeStyleArr[] =LanguageUtil::getCommonStr ( 'week_2' );
					}
					if (($item ['TimeStyle'] & 8 ) > 0) {
						$TimeStyleArr[] =LanguageUtil::getCommonStr ( 'week_3' );
					}
					if (($item ['TimeStyle'] & 16 ) > 0) {
						$TimeStyleArr[] =LanguageUtil::getCommonStr ( 'week_4' );
					}
					if (($item ['TimeStyle'] & 32 ) > 0) {
						$TimeStyleArr[] =LanguageUtil::getCommonStr ( 'week_5' );
					}
					if (($item ['TimeStyle'] & 64 ) > 0) {
						$TimeStyleArr[] =LanguageUtil::getCommonStr ( 'week_6' );
					}
					$item ['TimeStyle'] = implode(" ", $TimeStyleArr);
				}
				unset ( $item ['UseDate'] );
				$OutRows [] = $item;
			}
		}
		
		return array ('Total' => $AllCount, 'Rows' => $OutRows );
	}

	/**
	 * 加载分区
	 * @param  $UserID
	 * @param  $ModeId
	 * @param  $Parent
	 */
	public static function LoadDevClass($UserID, $ModeId, $Parent) {
		
		$sql = 'SELECT ClassID AS id,Name as name, Parent AS Parent, 0 AS IsDevice, "closed" AS state, false AS checked FROM DevClasses';
		
		if (empty ( $Parent )) {
			$sql .= ' WHERE ISNULL(Parent)';
		} else {
			$sql .= ' WHERE Parent = ' . $Parent;
		}
		$Out = DBMethodUtils::listData ( $sql );
		
		if (! empty ( $Out )) {
			foreach ( $Out as $key => $item ) {
				//加载子节点分类成员
				$Children = ASysTaskUtil::LoadDevClass ( $UserID, $ModeId, $item ['id'] );
				//加载子节点设备
				$Devs = ASysTaskUtil::LoadDevices ( $UserID, $ModeId, $item ['id'] );
				
				if (! empty ( $Devs )) {
					if (empty ( $Children )) {
						$Children = $Devs;
					} else {
						$Children = array_merge ( $Children, $Devs );
					}
				}
				$Out [$key] ['children'] = $Children;
			}
		}
		
		return $Out;
	}
	
	/**
	 * 加载设备
	 * @param  $UserID
	 * @param  $ModeId
	 * @param  $Parent
	 */
	public static function LoadDevices($UserID, $ModeId, $Parent) {
		
		$sql = 'SELECT a.DevID AS id, a.Dev_Name AS name, a.Parent AS Parent, 1 AS IsDevice, "closed" AS state, 
				IF(ISNULL(b.BrdModeID) OR b.BrdModeID <= 0, false, true) AS checked 
				FROM DeviceList a 
				LEFT JOIN BrdModeMember b ON a.DevID = b.DeviceID AND b.BrdModeID = "' . $ModeId . '"';
		
		if (empty ( $Parent )) {
			$sql .= ' WHERE ISNULL(a.Parent)';
		} else {
			$sql .= ' WHERE a.Parent = ' . $Parent;
		}
		
		if (! is_null ( $UserID ) && $UserID > 0) {
			$sql .= DeviceUtil::GetUserCtrDevSql ( " AND DevID", $UserID );
		}
		$sql .= ' ORDER by a.DevID';
		
		return DBMethodUtils::listData ( $sql );
	}
	
	/**
	 * 加载接收成员
	 * @param $ModeId
	 * @param $UserID
	 */
	public static function LoadModeDevice($ModeId, $UserID) {
		
		$DeviceClassArr = ASysTaskUtil::LoadDevClass ( $UserID, $ModeId, null );
		
		$Devs = ASysTaskUtil::LoadDevices ( $UserID, $ModeId, null );
		
		if (! empty ( $Devs )) {
			if (empty ( $DeviceClassArr )) {
				$DeviceClassArr = $Devs;
			} else {
				$DeviceClassArr = array_merge ( $DeviceClassArr, $Devs );
			}
		}
		$selectAll = false;
		
		return ASysTaskUtil::dealDeviceTree ( $DeviceClassArr, $selectAll );
	}
	
	/**
	 * 处理设备树形结构
	 * @param $TreeData
	 */
	public static function dealDeviceTree($TreeData, &$selectAll) {
		
//		if (empty ( $TreeData )) {
//			return $TreeData;
//		}
//		$out = array ();
//		$All = true;
//		
//		foreach ( $TreeData as $key => $item ) {
//			$item ['id'] = str_replace ( 'DC_', "", $item ['id'] );
//			$item ['Parent'] = str_replace ( 'DC_', "", $item ['Parent'] );
//			
//			if ($item ['Parent'] == "") {
//				$item ['Parent'] = null;
//			}
//			if ($item ['IsDevice'] != 0) { //是设备
//				$out [] = $item;
//				
//				if ($All && $item ['checked'] != 1) {
//					$All = false;
//				}
//				continue;
//			}
//			
//			//是分类
//			if (empty ( $item ['children'] )) {
//			} else {
//				$TempAll = true;
//				$children = ASysTaskUtil::dealDeviceTree ( $item ['children'], $TempAll );
//				
//				if (! empty ( $children )) {
//					$item ['checked'] = $TempAll ? 1 : 0;
//					$item ['children'] = $children;
//					$out [] = $item;
//				}
//				
//				if ($All && ! $TempAll) {
//					$All = false;
//				}
//			}
//		}
//		$selectAll = $All;
//		
//		return $out;

		if (empty ( $TreeData )) {
			return $TreeData;
		}
		$out = array ();
		$SelectNum = 0;
		$HasHalf = false;
		
		foreach ( $TreeData as $key => $item ) {
			$item ['id'] = str_replace ( 'DC_', "", $item ['id'] );
			$item ['Parent'] = str_replace ( 'DC_', "", $item ['Parent'] );
//			$item ['name'] = $item ['text'];
			$item ['checked'] = intval ( $item ['checked'] );
			$item ['open'] = false;
			
			if ($item ['Parent'] == "") {
				$item ['Parent'] = null;
			}
			if ($item ['IsDevice'] != 0) { //是设备
				$out [] = $item;
				
				if ($item ['checked'] == 1) {
					$SelectNum ++;
				} else {
					$HasHalf = true;
				}
				continue;
			}
			
			//是分类
			if (empty ( $item ['children'] )) {
			} else {
				$TempAll = 1;
				$children = ASysTaskUtil::dealDeviceTree ( $item ['children'], $TempAll );
				
				if (! empty ( $children )) {
					$item ['checked'] = $TempAll == 1 || $TempAll == 2 ? 1 : 0;
					$item ['halfCheck'] = $TempAll == 2 ? 1 : 0;
					$item ['children'] = $children;
					$out [] = $item;
				}
				
				if ($TempAll == 1) {
					$SelectNum ++;
				} else if ($TempAll == 2) {
					$HasHalf = true;
				}
			}
		}
		$selectAll = $SelectNum <= 0 ? 0 : ($HasHalf ? 2 : 1);
		
		return $out;
	}
}