<?php
class ASysUtil {
	
	/**
	 * 加载网络配置数据
	 */
	public static function LoadNetworkInfo() {
		
		$Out = array ('Netcard' => array (), 'DNS' => array ('First' => '', 'Second' => '' ) );

		if($handle = opendir('/sys/class/net')){
		    while(false !== ($entry = readdir($handle))) {
                if ($entry == 'lo' || $entry == '.' || $entry == '..')
                    continue;
                $Param['Id'] = $entry;
                $Param['Mask'] = '';
                $Param['Getway'] = '';
                do {
                    $Param['Ip'] = exec("ifconfig " . $entry . " | sed -n '/inet addr:/p' | awk -F'[: ]+' '{print $4}'");
                    if($Param['Ip'] == ''){
                        break;
                    }
                    $ip = explode('.', $Param['Ip']);
                    if(count($ip) == 4){
                        foreach ($ip as $index => $item) {
                            if(!is_numeric($item) || $item > 255 || $item < 0){
                                $Param['Ip'] = '';
                                break;
                            }
                        }
                    }
                    if (count($ip) != 4 || $Param['Ip'] == '') {
                        break;
                    }

                    $Param['Mask'] = exec("ifconfig " . $entry . " | sed -n '/Mask:/p' | awk -F'[: ]+' '{print $8}'");
                    if ( $Param['Mask'] == "") {
                        break;
                    }

                    $Param['Getway'] = exec("netstat -rn  | sed -n '/^" . $Param['Ip'] . "/p' | awk -F'[ ]+' '{print $2}'");
                    if ($Param['Getway'] == '') {
                        $Param['Getway'] = exec("netstat -rn  | sed -n '/^0.0.0.0/p' | awk -F'[ ]+' '{print $2}'");
                    }
                }while(false);
                $Out ['Netcard'] [] = $Param;
            }
            closedir($handle);
        }

		//获取DNS数据
		$Output = array ();
		$cmd = 'bash idste-dns-cfg';
		exec ( $cmd, $Output );
		
		if (! empty ( $Output )) {
			$Item = strtolower ( $Output [0] );
			$arr = explode ( ' ', $Item );
			
			if (count ( $arr ) >= 2 && strtolower ( trim ( $arr [0] ) ) == 'dns-nameservers') {
				$Out ['DNS'] ['First'] = $arr [1];
				
				if (count ( $arr ) >= 3) {
					$Out ['DNS'] ['Second'] = $arr [2];
				}
			}
		}
		
		return $Out;
	}
	
	/**
	 * 获取网络配置数据
	 * @param  $Start 开始数据
	 * @param  $Arr 命令获取的数组
	 */
	public static function LoadNetData($Start, $Arr) {
		
		foreach ( $Arr as $Item ) {
			$Item = strtolower ( $Item );
			
			if (strlen ( $Item ) <= strlen ( $Start )) {
				continue;
			}
			$Begin = substr ( $Item, 0, strlen ( $Start ) );
			
			if ($Begin == $Start) {
				return trim ( str_replace ( $Start, '', $Item ) );
			}
		}
		
		return '';
	}
	
	/**
	 * 校验IC卡是否存在 
	 * @param $IcCard true : 存在
	 */
	public static function JudgeIcCard($userId, $IcCard) {
		
		if (empty ( $IcCard )) {
			return false;
		}
		$ParamArr = array();
		$sql = 'SELECT * FROM Users WHERE IcCard = :IcCard';
		$ParamArr[":IcCard"] = $IcCard;
		
		if (is_numeric ( $userId )) {
			$sql .= ' AND User_ID != "' . $userId . '"';
		}
		
		$Rows = DBMethodUtils::listData ( $sql, $ParamArr );
		
		if (count ( $Rows ) > 0) {
			return true;
		}
		
		return false;
	}
	
	/**
	 * 校验工号是否存在 
	 * @param $IcCard true : 存在
	 */
	public static function JudgeUserSn($userId, $UserSn) {
		
		if (empty ( $UserSn )) {
			return false;
		}
		$sql = 'SELECT * FROM Users WHERE User_Sn = :User_Sn';
		$ParamArr[":User_Sn"] = $UserSn;
		
		if (is_numeric ( $userId )) {
			$sql .= ' AND User_ID != "' . $userId . '"';
		}
		$Rows = DBMethodUtils::listData ( $sql, $ParamArr );
		
		if (count ( $Rows ) > 0) {
			return true;
		}
		
		return false;
	}
	
	/**
	 * 校验登录名是否存在 
	 * @param $IcCard true : 存在
	 */
	public static function JudgeUserName($userId, $UserName) {
		
		if (empty ( $UserName )) {
			return false;
		}
		$sql = 'SELECT * FROM Users WHERE User_Name = :User_Name';
		$ParamArr[":User_Name"] = $UserName;
		
		if (is_numeric ( $userId )) {
			$sql .= ' AND User_ID != "' . $userId . '"';
		}
		$Rows = DBMethodUtils::listData ( $sql, $ParamArr );
		
		if (count ( $Rows ) > 0) {
			return true;
		}
		
		return false;
	}

}