<?php
/**
 * 实现与缓存相关的操作
 * @author bliu@hentica.com
 *
 */
class CacheUtil {
	/**用户缓存的id前缀，完整由前缀+用户id组成*/
	public static $USER_CACHE_ID = 'user_';
	
	public static $WEB_USER_CACHE_ID = 'web_user_';

	/**
	 * 设置缓存
	 * @param  $id 缓存的id
	 * @param  $value 缓存的值
	 * @param  $time 缓存时间，默认设置为 60 * 60 * 2 = 7200，2小时
	 * @return 缓存内容
	 */
	public static function SetCache($id, $value, $time = 7200) {
		
//		Yii::app()->cache->delete($id);
		Yii::app()->cache->set($id, $value);
		
		return $value;
	}
	
	/**
	 * 根据缓存的id获取缓存内容
	 * @param $id 缓存的id值
	 * @return 缓存内容
	 */
	public static function GetCache($id) {
		return Yii::app()->cache->get($id);
	}
	
	/**
	 * 根据缓存id删除缓存
	 * @param $id
	 */
	public static function DeleteCache($id) {
		Yii::app()->cache->delete($id);
	}
	
	/**
	 * 清空所有缓存
	 */
	public static function FlushCache() {
		Yii::app()->cache->flush();
	}
	
}