<?php

class DBMethodUtils {
	
	/**
	 * 获取用户数据库 
	 */
	public static function DB() {
		
		return Yii::app ()->db;
	}
	
	/**
	 * 查询一条数据
	 * @param $sql
	 */
	public static function findData($sql, $param = array(), $where = array(), $order = array()) {
		
		try {
			$db = DBMethodUtils::DB ()->createCommand ( $sql )->query ( $param );
			
			if (!empty($where)) {
				$db = $db->where($where);
			}
			
			if (!empty($order)) {
				$db = $db->order($order);
			}
			
			$result = $db->read ();
			
			if (! $result) {
				return null;
			}
			
			return $result;
		} catch ( Exception $e ) {
		}
		
		return null;
	}
	
	/**
	 * 查询一个列表
	 * @param $sql
	 */
	public static function listData($sql, $param = array()) {
		
		try {
			$db = DBMethodUtils::DB ()->createCommand ( $sql )->query ( $param );
			
//			if (!empty($where)) {
//				$result = DBMethodUtils::DB ()->createCommand ( $sql )->query ( $param )->where($where)->readAll ();
//			}
//			if (!empty($order)) {
//				if (count($order) == 1) {
//					$db = $db->order("DevLogID asc")->readAll ();
//				} else {
//					$db = $db->order($order)->readAll ();
//				}
//			}
//			
//			if (!empty($limit)) {
//				if (count($limit) >= 2) {
//					$db = $db->limit($limit[0], $limit[1])->readAll ();
//				} else {
//					$db = $db->limit($limit[0])->readAll ();
//				}
//			}
			$result = $db->readAll ();
			
			if (! $result) {
				return array ();
			}
			
			return $result;
		} catch ( Exception $e ) {
			return array ();
		}
	}
	
	/**
	 * 执行一条sql或者存储过程语句
	 * @param $sql
	 */
	public static function RunSql($sql, $param = array()) {
		try {
			return DBMethodUtils::DB ()->createCommand ( $sql )->execute ( $param );
		} catch ( Exception $e ) {
			return 0;
		}
	}
}