<?php
class ExpandUtil {
	
	/**
	 * 加载扩展设备信息
	 */
	public static function LoadExpandDev($edit = false) {
		
		$expandDev = null;
		
		try {
			$sql = 'select * from PwrDisplaySet';
			
			if (! $edit) {
				$sql .= ' WHERE Name IS NOT NULL and LENGTH(trim(Name)) >= 1 and  Type IS NOT NULL';
			}
			$sql .= ' ORDER BY PwrID ASC';
			
			$expandDev = DBMethodUtils::listData ( $sql );
		} catch ( Exception $e ) {
		
		}
		if (is_null ( $expandDev )) {
			$expandDev = array ();
		}
		
		if (empty ( $expandDev )) {
			$sql = "INSERT INTO PwrDisplaySet(PwrID)VALUES";
			$insert = array ();
			
			for($i = 2; $i <= 15; $i ++) {
				$insert [] = "(" . $i . ")";
				if ($edit) {
					$expandDev [] = array ('Name' => '', 'PwrID' => $i, 'Type' => '' );
				}
			}
			$sql .= implode ( ",", $insert );
			DBMethodUtils::RunSql ( $sql );
		}
		
		return $expandDev;
	}
	
	/**
	 * 加载子设备的模式
	 */
	public static function LoadExpandMode() {
		
		$newLang = '';
		
		if (isset ( $_POST ['Lang'] )) {
			$newLang = $_POST ['Lang'];
		}
		
		//子设备模式
		$expandMode = array ();
		
		$condi = array ();
		$condi [0] = LanguageUtil::getStr ( 'appcommon', 'mode_power_off' );
		
		$power = array ();
		$power [0] = LanguageUtil::getStr ( 'appcommon', 'mode_power_off' );
		$power [1] = LanguageUtil::getStr ( 'appcommon', 'mode_power_on' );
		$power [4] = LanguageUtil::getStr ( 'appcommon', 'mode_power_native' );
		
		$dbarr = DBMethodUtils::listData ( "SELECT InfomationID, Description FROM BaseInfo WHERE InfomationID IN(1,2,3,4)" );
		
		foreach ( $dbarr as $dbarritem ) {
			if ("zh_cn" != $newLang) { //非中文
				if ($dbarritem ['Description'] == "模式1") {
					$dbarritem ['Description'] = "Mode 1";
				} else if ($dbarritem ['Description'] == "模式2") {
					$dbarritem ['Description'] = "Mode 2";
				} else if ($dbarritem ['Description'] == "模式3") {
					$dbarritem ['Description'] = "Mode 3";
				} else if ($dbarritem ['Description'] == "模式4") {
					$dbarritem ['Description'] = "Mode 4";
				}
			}
			$condi [$dbarritem ['InfomationID']] = $dbarritem ['Description'];
		}
		$condi [4] = LanguageUtil::getStr ( 'appcommon', 'mode_power_native' );
		
		$expandMode [0] = $condi;
		$expandMode [1] = $power;
		
		return $expandMode;
	}
}