-- MySQL Workbench Synchronization
-- Generated: 2017-10-27 18:28
-- Model: New Model
-- Version: D05.01.27
-- Project: idste-server
-- Author: xuhj(xuhj@idste.cn)

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

CREATE TABLE IF NOT EXISTS `nccs`.`CallWaiter` (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `user` INT(11) NOT NULL,
  `session` VARCHAR(45) NOT NULL,
  `updateAt` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE INDEX `session_unique` (`session` ASC))
ENGINE = MEMORY
DEFAULT CHARACTER SET = utf8;

ALTER TABLE `nccs`.`DeviceDesiredStaus` 
ADD COLUMN `IpCall` TINYINT(1) NOT NULL DEFAULT '0' COMMENT '0: idle\n1:ringing\n2:talking' AFTER `RfDevCtrl`,
ADD COLUMN `IpCallPort` INT(11) NULL DEFAULT NULL AFTER `IpCall`,
ADD COLUMN `IpCallEvent` DATETIME NULL DEFAULT NULL AFTER `IpCallPort`;

ALTER TABLE `nccs`.`DeviceStatus` 
ADD COLUMN `State_Pc` TINYINT(4) NULL DEFAULT '0' AFTER `RfDevStatus`,
ADD COLUMN `IpCallStatus` TINYINT(4) UNSIGNED NULL DEFAULT '0' AFTER `SysPowerCmd`,
ADD COLUMN `RfDevCmd` BINARY(16) NULL DEFAULT NULL AFTER `IpCallStatus`;

CREATE TABLE IF NOT EXISTS `nccs`.`Event` (
  `Id` INT(11) NOT NULL AUTO_INCREMENT,
  `Name` VARCHAR(31) NOT NULL,
  `StartTask` SMALLINT(6) NULL DEFAULT NULL,
  `EndTask` SMALLINT(6) NULL DEFAULT NULL,
  `Config` VARBINARY(64) NOT NULL COMMENT '¼',
  `Model` INT(11) NOT NULL COMMENT 'ͺ',
  `Version` INT(11) NOT NULL DEFAULT '0' COMMENT '汾:Զɣǰ˽ֹ',
  PRIMARY KEY (`Id`),
  INDEX `model_idx` (`Model` ASC),
  CONSTRAINT `EventModel`
    FOREIGN KEY (`Model`)
    REFERENCES `nccs`.`EventModel` (`id`))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

CREATE TABLE IF NOT EXISTS `nccs`.`EventModel` (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `Manufacturer` VARCHAR(31) NOT NULL,
  `Model` VARCHAR(31) NOT NULL,
  `Magic` INT(11) UNSIGNED NOT NULL,
  PRIMARY KEY (`id`))
ENGINE = InnoDB
AUTO_INCREMENT = 4
DEFAULT CHARACTER SET = utf8;

CREATE TABLE IF NOT EXISTS `nccs`.`IpCall` (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `device` VARCHAR(45) NULL DEFAULT NULL COMMENT 'device id',
  `waiter` INT(11) NULL DEFAULT NULL,
  `audioPort` INT(11) NULL DEFAULT NULL,
  `ringing` TIMESTAMP NULL DEFAULT CURRENT_TIMESTAMP,
  `status` ENUM('ringing', 'talking', 'idle') NULL DEFAULT 'ringing',
  `direction` ENUM('b2s', 'd2s') NULL DEFAULT 'b2s',
  `webrtcUpdate` TIMESTAMP NULL DEFAULT NULL,
  `webrtcStatus` ENUM('running', 'error', 'ready', 'idle') NULL DEFAULT 'idle',
  `wsPort` INT(11) NULL DEFAULT NULL COMMENT 'websocket listen port',
  PRIMARY KEY (`id`),
  UNIQUE INDEX `port_unique` (`audioPort` ASC),
  UNIQUE INDEX `webrtcPort_UNIQUE` (`wsPort` ASC))
ENGINE = MEMORY
DEFAULT CHARACTER SET = utf8;

CREATE TABLE IF NOT EXISTS `nccs`.`IpCameraRtmp` (
  `name` VARCHAR(128) NULL DEFAULT NULL COMMENT 'keymd5',
  `key` VARCHAR(45) NOT NULL COMMENT 'rtmpĿkeyֵͷIp/˿/ͨ/(mainsub)',
  `pushId` INT(11) NOT NULL DEFAULT '-1' COMMENT 'ffmpegID',
  `pullCnt` INT(11) NOT NULL DEFAULT '0' COMMENT 'rtmp',
  `updateAt` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`key`),
  UNIQUE INDEX `key_UNIQUE` (`key` ASC))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

ALTER TABLE `nccs`.`PlaySessions` 
CHANGE COLUMN `SessionType` `SessionType` TINYINT(4) NULL DEFAULT NULL COMMENT '0: automatic broadcast task\n1: player created task\n2: manually played task\n10:BW803 player created task' ;

CREATE TABLE IF NOT EXISTS `nccs`.`SrsServer` (
  `id` INT(11) NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(32) NOT NULL,
  `server` VARCHAR(128) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE INDEX `server_uni` (`server` ASC))
ENGINE = InnoDB
DEFAULT CHARACTER SET = utf8;

CREATE TABLE IF NOT EXISTS `nccs`.`SrsServerStatus` (
  `id` INT(11) NOT NULL,
  `server` VARCHAR(128) NOT NULL,
  `count` INT(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`))
ENGINE = MEMORY
DEFAULT CHARACTER SET = utf8;

ALTER TABLE `nccs`.`Timetable` 
ADD COLUMN `OneTime` TINYINT(4) NOT NULL DEFAULT '0' AFTER `Type`;

DROP TABLE IF EXISTS `nccs`.`TimeTemplate` ;

DROP TABLE IF EXISTS `nccs`.`TempIcCard` ;


USE `nccs`;

-- -----------------------------------------------------
-- View `nccs`.`v_stream_trans_table`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `nccs`.`v_stream_trans_table`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_stream_trans_table` AS select `a`.`NetworkID` AS `NetworkID`,`a`.`IpAddress` AS `proxy`,`b`.`IpAddress` AS `IpAddress`,`c`.`MultiPort` AS `MultiPort`,`c`.`SessionID` AS `SessionID` from ((`nccs`.`DeviceStatus` `a` left join `nccs`.`SubNetwork` `b` on((`b`.`idSubNetwork` = `a`.`NetworkID`))) left join `nccs`.`PlayingSessions` `c` on((`c`.`SessionID` = `a`.`ActualSessionID`))) where (`a`.`ActualSessionID` > 0) group by `c`.`SessionID`,`a`.`NetworkID`;

SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
