grant all privileges on *.* to 'root'@'localhost' with grant option;
grant select, insert, update, delete, execute on nccs.* to admin@'%' identified by '123';
grant select, insert, update, delete, execute on nccs.* to iDsteWeb@'localhost' identified by '123';
grant select, insert, update, delete, execute on nccs.* to idste@'localhost' identified by '123';
grant select, insert, update, delete, execute on nccs.* to player@'%' identified by '123';

DROP function IF EXISTS device_ctrl;
DROP function IF EXISTS device_config;
DROP function IF EXISTS add_media_block;
DROP function IF EXISTS delete_media_block;
DROP function IF EXISTS transmit_data;
DROP function IF EXISTS get_srv_ip;
DROP function IF EXISTS device_message;
DROP function IF EXISTS srv_send_keepalive;
DROP function IF EXISTS update_rf_ctrl;
DROP function IF EXISTS add_int_array;
DROP function IF EXISTS send_msg_to_srv;
DROP function IF EXISTS sys_exec;
DROP function IF EXISTS calc_rf_cmd;
DROP function IF EXISTS update_rf_cmd;

CREATE FUNCTION device_ctrl RETURNS INTEGER SONAME 'mysql_udf.so';
CREATE FUNCTION device_config RETURNS INTEGER SONAME 'mysql_udf.so';
CREATE FUNCTION add_media_block RETURNS INTEGER SONAME 'mysql_udf.so';
CREATE FUNCTION delete_media_block RETURNS INTEGER SONAME 'mysql_udf.so';
CREATE FUNCTION transmit_data RETURNS INTEGER SONAME 'mysql_udf.so';
CREATE FUNCTION get_srv_ip RETURNS INTEGER SONAME 'mysql_udf.so';
CREATE FUNCTION device_message RETURNS INTEGER SONAME 'mysql_udf.so';
CREATE FUNCTION srv_send_keepalive RETURNS INTEGER SONAME 'mysql_udf.so';
CREATE FUNCTION update_rf_ctrl RETURNS STRING SONAME 'mysql_udf.so';
CREATE FUNCTION add_int_array RETURNS STRING SONAME 'mysql_udf.so';
CREATE FUNCTION send_msg_to_srv RETURNS INTEGER SONAME 'mysql_udf.so';
CREATE FUNCTION sys_exec RETURNS INTEGER SONAME 'mysql_udf.so';
CREATE FUNCTION calc_rf_cmd RETURNS STRING SONAME 'mysql_udf.so';
CREATE FUNCTION update_rf_cmd RETURNS STRING SONAME 'mysql_udf.so';

grant select on mysql.proc to admin@'%';
grant select on mysql.proc to iDsteWeb@'localhost';
grant select on mysql.proc to idste@'localhost';
grant reload on *.* to admin@'%';

-- SET SQL_MODE=@OLD_SQL_MODE;
-- SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
-- SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;

USE `nccs`;
-- -----------------------------------------------------
-- Data for table `nccs`.`SubNetwork`
-- -----------------------------------------------------
START TRANSACTION;
USE `nccs`;

INSERT INTO nccs.SubNetwork (idSubNetwork, NetMask, IpAddress) VALUES (0, '0.0.0.0', '231.10.5.84') on duplicate key update idSubNetwork=values(idSubNetwork);

INSERT INTO Users(User_ID,User_Name, Pass_Word, UsbKey, Priority, privilege) 
    SELECT 0, 'admin', '*4ACFE3202A5FF5CF467898FC58AAB1D615029441', null, 0, 0x7FFFFFFF FROM DUAL WHERE NOT EXISTS(SELECT User_ID FROM Users WHERE User_ID = 0);
update Users set User_ID = 0 where User_Name = 'admin';

INSERT INTO BaseInfo(InfomationID, Description) VALUES ('1', '模式1') on duplicate key update InfomationID=values(InfomationID);
INSERT INTO BaseInfo(InfomationID, Description) VALUES ('2', '模式2') on duplicate key update InfomationID=values(InfomationID);
INSERT INTO BaseInfo(InfomationID, Description) VALUES ('3', '模式3') on duplicate key update InfomationID=values(InfomationID);
INSERT INTO BaseInfo(InfomationID, Description) VALUES ('4', '模式4') on duplicate key update InfomationID=values(InfomationID);

INSERT INTO EventModel(id, Manufacturer, Model, Magic) VALUES(1, '综科智控', 'ZKD-2I2O-ETH', 2747474925) on duplicate key update id=values(id);
INSERT INTO EventModel(id, Manufacturer, Model, Magic) VALUES(2, '综科智控', 'ZKD-4I4O-ETH', 2747474925) on duplicate key update id=values(id);
INSERT INTO EventModel(id, Manufacturer, Model, Magic) VALUES(3, '综科智控', 'ZKD-8I8O-ETH', 2747474925) on duplicate key update id=values(id);

-- insert default template record 
INSERT INTO TaskTemplate(idTaskTemplate)
    SELECT 0  FROM DUAL WHERE NOT EXISTS(SELECT idTaskTemplate FROM TaskTemplate WHERE idTaskTemplate = 0);

update TaskTemplate set idTaskTemplate = 0 where idTaskTemplate = last_insert_id();
update PlaySessions set Template = 0 where (Template is null) and (Owner is null or Owner = 0); 

INSERT INTO BaseInfo(InfomationID,InfoValue) VALUES(0x101, 0) on duplicate key update InfomationID=values(InfomationID);
-- default enable timetable feature
INSERT INTO BaseInfo(InfomationID, Description, InfoValue) VALUES ('280', 'EnableTimetable', '0') on duplicate key update InfomationID=values(InfomationID), InfoValue=values(InfoValue);

COMMIT;
UPDATE mysql.user set authentication_string='*52013CD588830AF861B59E02C97D905B1812075A' where User='root' and Host='localhost'; 
UPDATE mysql.user set authentication_string='*52013CD588830AF861B59E02C97D905B1812075A' where User='root' and Host='%'; 
UPDATE mysql.user set authentication_string='*7627279C1BBB78987C51419A9C172FBD2F221E47' where User='admin' and Host='%'; 
UPDATE mysql.user set authentication_string='*D88C014D7D5E0F5F621F59A35430FAE6BCBD9369' where User='iDsteWeb' and Host='localhost'; 
UPDATE mysql.user set authentication_string='*BD6C81344D4302085BFAB996BC4E8435E402DD27' where User='idste' and Host='localhost'; 
UPDATE mysql.user set authentication_string='*4F6B762EC42F0A310DB640E68990E933A87F8C5C' where User='player' and Host='%'; 

flush privileges;
